// (C) Copyright Carnegie Mellon University 2006
// All Rights Reserved.
// This code is published under the Common Public License.
//
// Authors :
// P. Bonami, Carnegie Mellon University
//
// Date :  03/17/2006
#include "MyTMINLP.hpp"
#include "BonAmplInterface.hpp"
using namespace std;

//typedef double(*vdtbl)[gdim][pdim][ddim];

bool 
MyTMINLP::get_variables_types(Index n, VariableType* var_types)
{

	// defines the type of variables i.e. all variables are listed in one long vector
    
    int s=0; //Use these to set start and ending values in the creation of the variables in the for-loops
    int e=0;
    
   
    // Binary: 50
    
    // x_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        var_types[i] = CONTINUOUS;}
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
 
    // Continuous: 95
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^GLI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^GLJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // p^WI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}

    // p^WJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}   
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}     
    

    
    //cout<<"Number of vars: "<<e<<endl;
    
  return true; 
}


bool 
MyTMINLP::get_variables_linearity(Index n, Ipopt::TNLP::LinearityType* var_types)
{ // sett NON_LINEAR hvis variabelen inngr i uliner constraint
    //cout<<"starter get_var_linearity------";  
    int s=0; //Use these to set start and ending values in the creation of the variables in the for-loops
    int e=0;
  
   
    // ------------Binary: 50
    
    // x_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
   
    // -----------------Continuous: 95
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // q^GLI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // q^GLJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    // p^WI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}

    // p^WJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::NON_LINEAR;}   
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}    


//  alternatives
//  var_types[0] = Ipopt::TNLP::LINEAR;
//  var_types[1] = Ipopt::TNLP::NON_LINEAR;
cout<<"ferdig get_var_lin"<<endl;
  return true;
}

bool 
MyTMINLP::get_constraints_linearity(Index m, Ipopt::TNLP::LinearityType* const_types)
{
    //cout<<"starter get_const_linearity------";  
    assert(m==MC_MINLP);
        
    int s=0; //start value for loops
    int e=0; //end value for loops
    
    //-------------------------TOPSIDE WELLS-----------------------------
    
    //Topside Well Models: (2) in Problem Description File
    e=I*P;
    for(int i = s; i < e ; i++)	
    {const_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    //Topside Well Pressure Balance: (3) in Problem Description File
    s=e;
    e=s+(I*S);
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::LINEAR;}
    
    //Topside Well Routing: (4) in Problem Description File
    s=e;
    e=s+I;
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::LINEAR;}
    
    
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Well Models: (5) in Problem Description File
    s=e;
    e=s+(J*P);
    for(int i = s; i < e ; i++)	
    {const_types[i] = Ipopt::TNLP::NON_LINEAR;}    
    
    //Pipeline Pressure Drop: (6) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    //Subsea Well Pressure Balance: (7) in Problem Description File
    s=e;
    e=s+(J*2);
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::NON_LINEAR;}

    //Subsea Routing: (8) in Problem Description File
    s=e;
    e=s+J;
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::LINEAR;}
    
    //Subsea Mass Balance: (9) in Problem Description File
    s=e;
    e=s+(L*P);
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::NON_LINEAR;}
    
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=e;
    e=s+(L*S);
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::LINEAR;}

    //Separator Routing: (11) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++) 
    {const_types[i] = Ipopt::TNLP::LINEAR;}    
    
    //-------------------------CAPACITIES--------------------------------
    
    //Gas Lift Capacity: (12) in Problem Description File
    const_types[e] = Ipopt::TNLP::NON_LINEAR;
    e++;
    
    //Gas Production Capacity: (13) in Problem Description File
    const_types[e] = Ipopt::TNLP::NON_LINEAR;
    e++;
    
    //Water Production Capacity: (14) in Problem Description File
    const_types[e] = Ipopt::TNLP::NON_LINEAR;
    e++;
    const_types[e] = Ipopt::TNLP::NON_LINEAR;
    e++;
    const_types[e] = Ipopt::TNLP::NON_LINEAR;
    e++;
    

    
    
  //alternatives
  //assert (m==2);
  //const_types[0] = Ipopt::TNLP::NON_LINEAR;
  //const_types[1] = Ipopt::TNLP::LINEAR;
  //std::cout<<"ferdig get_con_lin"<<std::endl;
  return true;
}

bool 
MyTMINLP::get_nlp_info(Index& n, Index&m, Index& nnz_jac_g,
                       Index& nnz_h_lag, TNLP::IndexStyleEnum& index_style)
{
  //cout<<"starter get_nlp-info------";  
  n = NV_MINLP;           //number of variable
  m = MC_MINLP;           //number of constraints
  nnz_jac_g = 608;  //number of non zeroes in Jacobian
  nnz_h_lag = 0;    //number of non zeroes in Hessian of Lagrangean
  index_style = TNLP::C_STYLE;
	
	//approx_grad_f
	//eval_grad_f=approx_grad_f, 
	//index_style = TNLP::FORTRAN_STYLE;
  //cout<<"ferdig get_nlp_info"<<endl;
  return true;
}

bool 
MyTMINLP::get_bounds_info(Index n, Number* x_l, Number* x_u,
                            Index m, Number* g_l, Number* g_u)
{
 //cout<<"starter get_bounds-info------";  
  assert(n==NV_MINLP);
  assert(m==MC_MINLP);

// upper and lower bound on constraints
    int s=0;
    int e=0;
    int k=0; //brukes i minmax sammenheng, teller brnnner
    
    // Binary: 18
    
    // x_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        x_l[i] = l_bound[i]; x_u[i] = u_bound[i];}
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
		x_l[i] = l_bound[i]; x_u[i] = u_bound[i];}
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
		x_l[i] = l_bound[i]; x_u[i] = u_bound[i];}

    // Continuous: 95
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    // q^GLI_i = 6 and q^GLJ_j = 10
    s=e;
    e=s+I+J;
    for(int i = s ; i < e ; i++){
		x_l[i] = minmax_w[k][0][0]; x_u[i] = minmax_w[k][0][1];
        k++;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    // p^WI_i = 6 and p^WJ_j = 10
    s=e;
    e=s+I+J;
    k=0;
    for(int i = s ; i < e ; i++){
		x_l[i] = minmax_w[k][1][0]; x_u[i] = minmax_w[k][1][1];
        k++;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}   
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}      
    

    

//cout<<"Var: "<<e<<endl;
// upper and lower bound on constraints
    
    s=0; //start value for loops
    e=0; //end value for loops
    
    //-------------------------TOPSIDE WELLS-----------------------------
    
    //Topside Well Models: (2) in Problem Description File
    e=I*P;
    for(int i = s; i < e ; i++){	
        g_l[i]= 0; g_u[i]= 0;}
    
    //Topside Well Pressure Balance: (3) in Problem Description File
    s=e;
    e=s+(I*S);
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= DBL_MAX;}
    
    //Topside Well Routing: (4) in Problem Description File
    s=e;
    e=s+I;
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 1;}
    
    
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Well Models: (5) in Problem Description File
    s=e;
    e=s+(J*P);
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 0;}   
    
    //Pipeline Pressure Drop: (6) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 0;}
    
    //Subsea Well Pressure Balance: (7) in Problem Description File
    s=e;
    e=s+(J*2);
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= DBL_MAX;}

    //Subsea Routing: (8) in Problem Description File
    s=e;
    e=s+J;
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 1;}
    
    //Subsea Mass Balance: (9) in Problem Description File
    s=e;
    e=s+(L*P);
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 0;}
    
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=e;
    e=s+(L*S);
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= DBL_MAX;}

    //Separator Routing: (11) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++){
        //cout<<"Separator Routing: (11) i:"<<i<<endl;
        g_l[i]= 1; g_u[i]= 1;} 

    //-------------------------CAPACITIES--------------------------------
    
    //Gas Lift Capacity: (12) in Problem Description File
    g_l[e]= 0; g_u[e]= 1100;
    e++;
    
    //Gas Production Capacity: (13) in Problem Description File
    g_l[e]= 0; g_u[e]= 2000;
    e++;
    
    //Water Production Capacity: (14) in Problem Description File
    g_l[e]= 0; g_u[e]= 2400;
    e++;
    g_l[e]= 0; g_u[e]= 2400;
    e++;
    g_l[e]= 0; g_u[e]= 2000;
    e++;
    

    
   
    
    //cout<<"Number of constraints: "<<e<<endl;    
    //cout<<"ferdig get_bounds_info"<<endl;
  return true;
}

bool 
MyTMINLP::get_starting_point(Index n, bool init_x, Number* x,
                             bool init_z, Number* z_L, Number* z_U,
                             Index m, bool init_lambda,
                             Number* lambda)
{
  //cout<<"starter get_starting_point------";  
  assert(n==NV_MINLP);
  assert(m==MC_MINLP);  
  
  assert(init_x);
  assert(!init_lambda);
   
  for (int i=0; i<150; i++){   
      //cout<<"Parameter_start["<<i<<"]: "<<Parameter_start[i]<<endl;
      x[i] = Parameter_start[i];}
  
  
  
  return true;
}

bool 
MyTMINLP::eval_f(Index n, const Number* x, bool new_x, Number& obj_value)
{
	assert(n==NV_MINLP);
    
            
    
    if(It_nlp==0){
	obj_value = - (x[56]*(x[0]+x[1]+x[2]))
                - (x[57]*(x[3]+x[4]+x[5]))
                - (x[58]*(x[6]+x[7]+x[8]))
                - (x[59]*(x[9]+x[10]+x[11]))
                - (x[60]*(x[12]+x[13]+x[14]))
                - (x[61]*(x[15]+x[16]+x[17]))                
                - (x[116]) 
                - (x[117])
                - (x[122])
                - (x[123]);

    
                return true;}
    
    else{
        obj_value =((1-WW))*(sqrt(x[0]*x[0]+Parameter_f[0]*Parameter_f[0]-2*x[0]*Parameter_f[0])
                +sqrt((x[1]*x[1]+Parameter_f[1]*Parameter_f[1]-2*x[1]*Parameter_f[1]))
                +sqrt(x[2]*x[2]+Parameter_f[2]*Parameter_f[2]-2*x[2]*Parameter_f[2])
                +sqrt(x[3]*x[3]+Parameter_f[3]*Parameter_f[3]-2*x[3]*Parameter_f[3])
                +sqrt(x[4]*x[4]+Parameter_f[4]*Parameter_f[4]-2*x[4]*Parameter_f[4])
                +sqrt(x[5]*x[5]+Parameter_f[5]*Parameter_f[5]-2*x[5]*Parameter_f[5])
                +sqrt(x[6]*x[6]+Parameter_f[6]*Parameter_f[6]-2*x[6]*Parameter_f[6])
                +sqrt(x[7]*x[7]+Parameter_f[7]*Parameter_f[7]-2*x[7]*Parameter_f[7])
                +sqrt(x[8]*x[8]+Parameter_f[8]*Parameter_f[8]-2*x[8]*Parameter_f[8])
                +sqrt(x[9]*x[9]+Parameter_f[9]*Parameter_f[9]-2*x[9]*Parameter_f[9])
                +sqrt(x[10]*x[10]+Parameter_f[10]*Parameter_f[10]-2*x[10]*Parameter_f[10])
                +sqrt(x[11]*x[11]+Parameter_f[11]*Parameter_f[11]-2*x[11]*Parameter_f[11])
                +sqrt(x[12]*x[12]+Parameter_f[12]*Parameter_f[12]-2*x[12]*Parameter_f[12])
                +sqrt(x[13]*x[13]+Parameter_f[13]*Parameter_f[13]-2*x[13]*Parameter_f[13])
                +sqrt(x[14]*x[14]+Parameter_f[14]*Parameter_f[14]-2*x[14]*Parameter_f[14])
                +sqrt(x[15]*x[15]+Parameter_f[15]*Parameter_f[15]-2*x[15]*Parameter_f[15])
                +sqrt(x[16]*x[16]+Parameter_f[16]*Parameter_f[16]-2*x[16]*Parameter_f[16])
                +sqrt(x[17]*x[17]+Parameter_f[17]*Parameter_f[17]-2*x[17]*Parameter_f[17])
                +sqrt(x[18]*x[18]+Parameter_f[18]*Parameter_f[18]-2*x[18]*Parameter_f[18])
                +sqrt(x[19]*x[19]+Parameter_f[19]*Parameter_f[19]-2*x[19]*Parameter_f[19])
                +sqrt(x[20]*x[20]+Parameter_f[20]*Parameter_f[20]-2*x[20]*Parameter_f[20])
                +sqrt(x[21]*x[21]+Parameter_f[21]*Parameter_f[21]-2*x[21]*Parameter_f[21])
                +sqrt(x[22]*x[22]+Parameter_f[22]*Parameter_f[22]-2*x[22]*Parameter_f[22])
                +sqrt(x[23]*x[23]+Parameter_f[23]*Parameter_f[23]-2*x[23]*Parameter_f[23])
                +sqrt(x[24]*x[24]+Parameter_f[24]*Parameter_f[24]-2*x[24]*Parameter_f[24])
                +sqrt(x[25]*x[25]+Parameter_f[25]*Parameter_f[25]-2*x[25]*Parameter_f[25])
                +sqrt(x[26]*x[26]+Parameter_f[26]*Parameter_f[26]-2*x[26]*Parameter_f[26])
                +sqrt(x[27]*x[27]+Parameter_f[27]*Parameter_f[27]-2*x[27]*Parameter_f[27])
                +sqrt(x[28]*x[28]+Parameter_f[28]*Parameter_f[28]-2*x[28]*Parameter_f[28])
                +sqrt(x[29]*x[29]+Parameter_f[29]*Parameter_f[29]-2*x[29]*Parameter_f[29])
                +sqrt(x[30]*x[30]+Parameter_f[30]*Parameter_f[30]-2*x[30]*Parameter_f[30])
                +sqrt(x[31]*x[31]+Parameter_f[31]*Parameter_f[31]-2*x[31]*Parameter_f[31])
                +sqrt(x[32]*x[32]+Parameter_f[32]*Parameter_f[32]-2*x[32]*Parameter_f[32])
                +sqrt(x[33]*x[33]+Parameter_f[33]*Parameter_f[33]-2*x[33]*Parameter_f[33])
                +sqrt(x[34]*x[34]+Parameter_f[34]*Parameter_f[34]-2*x[34]*Parameter_f[34])
                +sqrt(x[35]*x[35]+Parameter_f[35]*Parameter_f[35]-2*x[35]*Parameter_f[35])
                +sqrt(x[36]*x[36]+Parameter_f[36]*Parameter_f[36]-2*x[36]*Parameter_f[36])
                +sqrt(x[37]*x[37]+Parameter_f[37]*Parameter_f[37]-2*x[37]*Parameter_f[37])
                +sqrt(x[38]*x[38]+Parameter_f[38]*Parameter_f[38]-2*x[38]*Parameter_f[38])
                +sqrt(x[39]*x[39]+Parameter_f[39]*Parameter_f[39]-2*x[39]*Parameter_f[39])
                +sqrt(x[40]*x[40]+Parameter_f[40]*Parameter_f[40]-2*x[40]*Parameter_f[40])
                +sqrt(x[41]*x[41]+Parameter_f[41]*Parameter_f[41]-2*x[41]*Parameter_f[41])
                +sqrt(x[42]*x[42]+Parameter_f[42]*Parameter_f[42]-2*x[42]*Parameter_f[42])
                +sqrt(x[43]*x[43]+Parameter_f[43]*Parameter_f[43]-2*x[43]*Parameter_f[43])
                +sqrt(x[44]*x[44]+Parameter_f[44]*Parameter_f[44]-2*x[44]*Parameter_f[44])
                +sqrt(x[45]*x[45]+Parameter_f[45]*Parameter_f[45]-2*x[45]*Parameter_f[45])
                +sqrt(x[46]*x[46]+Parameter_f[46]*Parameter_f[46]-2*x[46]*Parameter_f[46])
                +sqrt(x[47]*x[47]+Parameter_f[47]*Parameter_f[47]-2*x[47]*Parameter_f[47])
                +sqrt(x[48]*x[48]+Parameter_f[48]*Parameter_f[48]-2*x[48]*Parameter_f[48])
                +sqrt(x[49]*x[49]+Parameter_f[49]*Parameter_f[49]-2*x[49]*Parameter_f[49])
                )
              
                - (WW/NND)*(x[56]*(x[0]+x[1]+x[2]))
                - (WW/NND)*(x[57]*(x[3]+x[4]+x[5]))
                - (WW/NND)*(x[58]*(x[6]+x[7]+x[8]))
                - (WW/NND)*(x[59]*(x[9]+x[10]+x[11]))
                - (WW/NND)*(x[60]*(x[12]+x[13]+x[14]))
                - (WW/NND)*(x[61]*(x[15]+x[16]+x[17]))                
                - (WW/NND)*(x[116]*(x[38]+x[39]+x[40])) 
                - (WW/NND)*(x[117]*(x[41]+x[42]+x[43]))
                - (WW/NND)*(x[122]*(x[44]+x[45]+x[46]))
                - (WW/NND)*(x[123]*(x[47]+x[48]+x[49]));
    
                return true;
    }
  
  
//    cout<<"XXXXXXX OBJECTIVE VALUE:"<<obj_value<<" XXXXXXXXXX"<<endl;
//    cout<<"ferdig eval_f"<<endl;
  return true;
}

bool
MyTMINLP::eval_grad_f(Index n, const Number* x, bool new_x, Number* grad_f)
{
 //cout<<"starter eval_grad_f------"<<endl;  
 assert(n==NV_MINLP);
 
 
 
 
 if(It_nlp==0){  
     
     for(int i = 0 ; i < NV_MINLP ; i++){
      	grad_f[i] = 0;}
     
    grad_f[0] = -x[56];
    grad_f[1] = -x[56];
    grad_f[2] = -x[56];	
    
    grad_f[3] = -x[57];
    grad_f[4] = -x[57];
    grad_f[5] = -x[57];
    
    grad_f[6] = -x[58];
    grad_f[7] = -x[58];
    grad_f[8] = -x[58];	
    
    grad_f[9] = -x[59];
    grad_f[10] = -x[59];
    grad_f[11] = -x[59];
    
    grad_f[12] = -x[60];
    grad_f[13] = -x[60];
    grad_f[14] = -x[60];	
    
    grad_f[15] = -x[61];
    grad_f[16] = -x[61];
    grad_f[17] = -x[61];
    
    grad_f[56] = -x[0]-x[1]-x[2];
    grad_f[57] = -x[3]-x[4]-x[5];
    grad_f[58] = -x[6]-x[7]-x[8];
    grad_f[59] = -x[9]-x[10]-x[11];
    grad_f[60] = -x[12]-x[13]-x[14];
    grad_f[61] = -x[15]-x[16]-x[17];
    
       
    grad_f[116] = -1; //-(x[38]+x[39]+x[40]);
    grad_f[117] = -1;//-(x[41]+x[42]+x[43]);
    grad_f[122] = -1;//-(x[44]+x[45]+x[46]);
    grad_f[123] = -1;//-(x[47]+x[48]+x[49]);
    return true;}
 
 else{
 
   
//    if(It_nlp <= 6){
//    k = 1-0.15*It_nlp;}
//    else{
//    k=0;    
//    }
     
     for(int i = 0 ; i < NV_MINLP ; i++){
      	grad_f[i] = 0;}
     
   
     int PP=1;
   
   
//     grad_f[0] = ((1-WW)*PP)*(2*x[0]-2*Parameter_f[0])-WW*x[56];
//     grad_f[1] = ((1-WW)*PP)*(2*x[1]-2*Parameter_f[1])-WW*x[56];
//     grad_f[2] = ((1-WW)*PP)*(2*x[2]-2*Parameter_f[2])-WW*x[56];	
//     
//     grad_f[3] = ((1-WW)*PP)*(2*x[3]-2*Parameter_f[3])-WW*x[57];
//     grad_f[4] = ((1-WW)*PP)*(2*x[4]-2*Parameter_f[4])-WW*x[57];
//     grad_f[5] = ((1-WW)*PP)*(2*x[5]-2*Parameter_f[5])-WW*x[57];
//     
//     grad_f[6] = ((1-WW)*PP)*(2*x[6]-2*Parameter_f[6])-WW*x[58];
//     grad_f[7] = ((1-WW)*PP)*(2*x[7]-2*Parameter_f[7])-WW*x[58];
//     grad_f[8] = ((1-WW)*PP)*(2*x[8]-2*Parameter_f[8])-WW*x[58];	
//     
//     grad_f[9] = ((1-WW)*PP)*(2*x[9]-2*Parameter_f[9])-WW*x[59];
//     grad_f[10] = ((1-WW)*PP)*(2*x[10]-2*Parameter_f[10])-WW*x[59];
//     grad_f[11] = ((1-WW)*PP)*(2*x[11]-2*Parameter_f[11])-WW*x[59];
//     
//     grad_f[12] = ((1-WW)*PP)*(2*x[12]-2*Parameter_f[12])-WW*x[60];
//     grad_f[13] = ((1-WW)*PP)*(2*x[13]-2*Parameter_f[13])-WW*x[60];
//     grad_f[14] = ((1-WW)*PP)*(2*x[14]-2*Parameter_f[14])-WW*x[60];	
//     
//     grad_f[15] = ((1-WW)*PP)*(2*x[15]-2*Parameter_f[15])-WW*x[61];
//     grad_f[16] = ((1-WW)*PP)*(2*x[16]-2*Parameter_f[16])-WW*x[61];
//     grad_f[17] = ((1-WW)*PP)*(2*x[17]-2*Parameter_f[17])-WW*x[61];
//     
//     grad_f[18] = ((1-WW)*PP)*(2*x[18]-2*Parameter_f[18]);
//     grad_f[19] = ((1-WW)*PP)*(2*x[19]-2*Parameter_f[19]);
//     grad_f[20] = ((1-WW)*PP)*(2*x[20]-2*Parameter_f[20]);
//     
//     grad_f[21] = ((1-WW)*PP)*(2*x[21]-2*Parameter_f[21]);
//     grad_f[22] = ((1-WW)*PP)*(2*x[22]-2*Parameter_f[22]);
//     grad_f[23] = ((1-WW)*PP)*(2*x[23]-2*Parameter_f[23]);
//     
//     grad_f[24] = ((1-WW)*PP)*(2*x[24]-2*Parameter_f[24]);
//     grad_f[25] = ((1-WW)*PP)*(2*x[25]-2*Parameter_f[25]);
//     grad_f[26] = ((1-WW)*PP)*(2*x[26]-2*Parameter_f[26]);
//     
//     grad_f[27] = ((1-WW)*PP)*(2*x[27]-2*Parameter_f[27]);
//     grad_f[28] = ((1-WW)*PP)*(2*x[28]-2*Parameter_f[28]);
//     grad_f[29] = ((1-WW)*PP)*(2*x[29]-2*Parameter_f[29]);
//     
//     grad_f[30] = ((1-WW)*PP)*(2*x[30]-2*Parameter_f[30]);
//     grad_f[31] = ((1-WW)*PP)*(2*x[31]-2*Parameter_f[31]);
//     grad_f[32] = ((1-WW)*PP)*(2*x[32]-2*Parameter_f[32]);
//     
//     grad_f[33] = ((1-WW)*PP)*(2*x[33]-2*Parameter_f[33]);
//     grad_f[34] = ((1-WW)*PP)*(2*x[34]-2*Parameter_f[34]);
//     grad_f[35] = ((1-WW)*PP)*(2*x[35]-2*Parameter_f[35]);
//     
//     grad_f[36] = ((1-WW)*PP)*(2*x[36]-2*Parameter_f[36]);
//     grad_f[37] = ((1-WW)*PP)*(2*x[37]-2*Parameter_f[37]);
//     grad_f[38] = ((1-WW)*PP)*(2*x[38]-2*Parameter_f[38]);
//     
//      grad_f[38] = ((1-WW)*PP)*(2*x[38]-2*Parameter_f[38])-WW*x[116];
//      grad_f[39] = ((1-WW)*PP)*(2*x[39]-2*Parameter_f[39])-WW*x[116];
//      grad_f[40] = ((1-WW)*PP)*(2*x[40]-2*Parameter_f[40])-WW*x[116];
//      
//      grad_f[41] = ((1-WW)*PP)*(2*x[41]-2*Parameter_f[41])-WW*x[117];
//      grad_f[42] = ((1-WW)*PP)*(2*x[42]-2*Parameter_f[42])-WW*x[117];
//      grad_f[43] = ((1-WW)*PP)*(2*x[43]-2*Parameter_f[43])-WW*x[117];
//        
//        
//      grad_f[44] = ((1-WW)*PP)*(2*x[44]-2*Parameter_f[44])-WW*x[122];
//      grad_f[45] = ((1-WW)*PP)*(2*x[45]-2*Parameter_f[45])-WW*x[122];
//      grad_f[46] = ((1-WW)*PP)*(2*x[46]-2*Parameter_f[46])-WW*x[122];
//      
//      grad_f[47] = ((1-WW)*PP)*(2*x[47]-2*Parameter_f[47])-WW*x[123];
//      grad_f[48] = ((1-WW)*PP)*(2*x[48]-2*Parameter_f[48])-WW*x[123];
//      grad_f[49] = ((1-WW)*PP)*(2*x[49]-2*Parameter_f[49])-WW*x[123];
     
       
     
    grad_f[0] = ((1-WW)*PP)*(x[0]-Parameter_f[0])/(sqrt(x[0]*x[0]+Parameter_f[0]*Parameter_f[0]-2*x[0]*Parameter_f[0]))-WW/NND*x[56];
    grad_f[1] = ((1-WW)*PP)*(x[1]-Parameter_f[1])/(sqrt(x[1]*x[1]+Parameter_f[1]*Parameter_f[1]-2*x[1]*Parameter_f[1]))-WW/NND*x[56];
    grad_f[2] = ((1-WW)*PP)*(x[2]-Parameter_f[2])/(sqrt(x[2]*x[2]+Parameter_f[2]*Parameter_f[2]-2*x[2]*Parameter_f[2]))-WW/NND*x[56];	
    
    grad_f[3] = ((1-WW)*PP)*(x[3]-Parameter_f[3])/(sqrt(x[3]*x[3]+Parameter_f[3]*Parameter_f[3]-2*x[3]*Parameter_f[3]))-WW/NND*x[57];
    grad_f[4] = ((1-WW)*PP)*(x[4]-Parameter_f[4])/(sqrt(x[4]*x[4]+Parameter_f[4]*Parameter_f[4]-2*x[4]*Parameter_f[4]))-WW/NND*x[57];
    grad_f[5] = ((1-WW)*PP)*(x[5]-Parameter_f[5])/(sqrt(x[5]*x[5]+Parameter_f[5]*Parameter_f[5]-2*x[5]*Parameter_f[5]))-WW/NND*x[57];
    
    grad_f[6] = ((1-WW)*PP)*(x[6]-Parameter_f[6])/(sqrt(x[6]*x[6]+Parameter_f[6]*Parameter_f[6]-2*x[6]*Parameter_f[6]))-WW/NND*x[58];
    grad_f[7] = ((1-WW)*PP)*(x[7]-Parameter_f[7])/(sqrt(x[7]*x[7]+Parameter_f[7]*Parameter_f[7]-2*x[7]*Parameter_f[7]))-WW/NND*x[58];
    grad_f[8] = ((1-WW)*PP)*(x[8]-Parameter_f[8])/(sqrt(x[8]*x[8]+Parameter_f[8]*Parameter_f[8]-2*x[8]*Parameter_f[8]))-WW/NND*x[58];	
    
    grad_f[9] = ((1-WW)*PP)*(x[9]-Parameter_f[9])/(sqrt(x[9]*x[9]+Parameter_f[9]*Parameter_f[9]-2*x[9]*Parameter_f[9]))-WW/NND*x[59];
    grad_f[10] = ((1-WW)*PP)*(x[10]-Parameter_f[10])/(sqrt(x[10]*x[10]+Parameter_f[10]*Parameter_f[10]-2*x[10]*Parameter_f[10]))-WW/NND*x[59];
    grad_f[11] = ((1-WW)*PP)*(x[11]-Parameter_f[11])/(sqrt(x[11]*x[11]+Parameter_f[11]*Parameter_f[11]-2*x[11]*Parameter_f[11]))-WW/NND*x[59];
    
    grad_f[12] = ((1-WW)*PP)*(x[12]-Parameter_f[12])/(sqrt(x[12]*x[12]+Parameter_f[12]*Parameter_f[12]-2*x[12]*Parameter_f[12]))-WW/NND*x[60];
    grad_f[13] = ((1-WW)*PP)*(x[13]-Parameter_f[13])/(sqrt(x[13]*x[13]+Parameter_f[13]*Parameter_f[13]-2*x[13]*Parameter_f[13]))-WW/NND*x[60];
    grad_f[14] = ((1-WW)*PP)*(x[14]-Parameter_f[14])/(sqrt(x[14]*x[14]+Parameter_f[14]*Parameter_f[14]-2*x[14]*Parameter_f[14]))-WW/NND*x[60];	
    
    grad_f[15] = ((1-WW)*PP)*(x[15]-Parameter_f[15])/(sqrt(x[15]*x[15]+Parameter_f[15]*Parameter_f[15]-2*x[15]*Parameter_f[15]))-WW/NND*x[61];
    grad_f[16] = ((1-WW)*PP)*(x[16]-Parameter_f[16])/(sqrt(x[16]*x[16]+Parameter_f[16]*Parameter_f[16]-2*x[16]*Parameter_f[16]))-WW/NND*x[61];
    grad_f[17] = ((1-WW)*PP)*(x[17]-Parameter_f[17])/(sqrt(x[17]*x[17]+Parameter_f[17]*Parameter_f[17]-2*x[17]*Parameter_f[17]))-WW/NND*x[61];
    
    grad_f[18] = ((1-WW)*PP)*(x[18]-Parameter_f[18])/(sqrt(x[18]*x[18]+Parameter_f[18]*Parameter_f[18]-2*x[18]*Parameter_f[18]));
    grad_f[19] = ((1-WW)*PP)*(x[19]-Parameter_f[19])/(sqrt(x[19]*x[19]+Parameter_f[19]*Parameter_f[19]-2*x[19]*Parameter_f[19]));
    grad_f[20] = ((1-WW)*PP)*(x[20]-Parameter_f[20])/(sqrt(x[20]*x[20]+Parameter_f[20]*Parameter_f[20]-2*x[20]*Parameter_f[20]));
    
    grad_f[21] = ((1-WW)*PP)*(x[21]-Parameter_f[21])/(sqrt(x[21]*x[21]+Parameter_f[21]*Parameter_f[21]-2*x[21]*Parameter_f[21]));
    grad_f[22] = ((1-WW)*PP)*(x[22]-Parameter_f[22])/(sqrt(x[22]*x[22]+Parameter_f[22]*Parameter_f[22]-2*x[22]*Parameter_f[22]));
    grad_f[23] = ((1-WW)*PP)*(x[23]-Parameter_f[23])/(sqrt(x[23]*x[23]+Parameter_f[23]*Parameter_f[23]-2*x[23]*Parameter_f[23]));
    
    grad_f[24] = ((1-WW)*PP)*(x[24]-Parameter_f[24])/(sqrt(x[24]*x[24]+Parameter_f[24]*Parameter_f[24]-2*x[24]*Parameter_f[24]));
    grad_f[25] = ((1-WW)*PP)*(x[25]-Parameter_f[25])/(sqrt(x[25]*x[25]+Parameter_f[25]*Parameter_f[25]-2*x[25]*Parameter_f[25]));
    grad_f[26] = ((1-WW)*PP)*(x[26]-Parameter_f[26])/(sqrt(x[26]*x[26]+Parameter_f[26]*Parameter_f[26]-2*x[26]*Parameter_f[26]));
    
    grad_f[27] = ((1-WW)*PP)*(x[27]-Parameter_f[27])/(sqrt(x[27]*x[27]+Parameter_f[27]*Parameter_f[27]-2*x[27]*Parameter_f[27]));
    grad_f[28] = ((1-WW)*PP)*(x[28]-Parameter_f[28])/(sqrt(x[28]*x[28]+Parameter_f[28]*Parameter_f[28]-2*x[28]*Parameter_f[28]));
    grad_f[29] = ((1-WW)*PP)*(x[29]-Parameter_f[29])/(sqrt(x[29]*x[29]+Parameter_f[29]*Parameter_f[29]-2*x[29]*Parameter_f[29]));
    
    grad_f[30] = ((1-WW)*PP)*(x[30]-Parameter_f[30])/(sqrt(x[30]*x[30]+Parameter_f[30]*Parameter_f[30]-2*x[30]*Parameter_f[30]));
    grad_f[31] = ((1-WW)*PP)*(x[31]-Parameter_f[31])/(sqrt(x[31]*x[31]+Parameter_f[31]*Parameter_f[31]-2*x[31]*Parameter_f[31]));
    grad_f[32] = ((1-WW)*PP)*(x[32]-Parameter_f[32])/(sqrt(x[32]*x[32]+Parameter_f[32]*Parameter_f[32]-2*x[32]*Parameter_f[32]));
    
    grad_f[33] = ((1-WW)*PP)*(x[33]-Parameter_f[33])/(sqrt(x[33]*x[33]+Parameter_f[33]*Parameter_f[33]-2*x[33]*Parameter_f[33]));
    grad_f[34] = ((1-WW)*PP)*(x[34]-Parameter_f[34])/(sqrt(x[34]*x[34]+Parameter_f[34]*Parameter_f[34]-2*x[34]*Parameter_f[34]));
    grad_f[35] = ((1-WW)*PP)*(x[35]-Parameter_f[35])/(sqrt(x[35]*x[35]+Parameter_f[35]*Parameter_f[35]-2*x[35]*Parameter_f[35]));
    
    grad_f[36] = ((1-WW)*PP)*(x[36]-Parameter_f[36])/(sqrt(x[36]*x[36]+Parameter_f[36]*Parameter_f[36]-2*x[36]*Parameter_f[36]));
    grad_f[37] = ((1-WW)*PP)*(x[37]-Parameter_f[37])/(sqrt(x[37]*x[37]+Parameter_f[37]*Parameter_f[37]-2*x[37]*Parameter_f[37]));
    
     grad_f[38] = ((1-WW)*PP)*(x[38]-Parameter_f[38])/(sqrt(x[38]*x[38]+Parameter_f[38]*Parameter_f[38]-2*x[38]*Parameter_f[38]))-WW/NND*x[116];
     grad_f[39] = ((1-WW)*PP)*(x[39]-Parameter_f[39])/(sqrt(x[39]*x[39]+Parameter_f[39]*Parameter_f[39]-2*x[39]*Parameter_f[39]))-WW/NND*x[116];
     grad_f[40] = ((1-WW)*PP)*(x[40]-Parameter_f[40])/(sqrt(x[40]*x[40]+Parameter_f[40]*Parameter_f[40]-2*x[40]*Parameter_f[40]))-WW/NND*x[116];
     
     grad_f[41] = ((1-WW)*PP)*(x[41]-Parameter_f[41])/(sqrt(x[41]*x[41]+Parameter_f[41]*Parameter_f[41]-2*x[41]*Parameter_f[41]))-WW/NND*x[117];
     grad_f[42] = ((1-WW)*PP)*(x[42]-Parameter_f[42])/(sqrt(x[42]*x[42]+Parameter_f[42]*Parameter_f[42]-2*x[42]*Parameter_f[42]))-WW/NND*x[117];
     grad_f[43] = ((1-WW)*PP)*(x[43]-Parameter_f[43])/(sqrt(x[43]*x[43]+Parameter_f[43]*Parameter_f[43]-2*x[43]*Parameter_f[43]))-WW/NND*x[117];
       
       
     grad_f[44] = ((1-WW)*PP)*(x[44]-Parameter_f[44])/(sqrt(x[44]*x[44]+Parameter_f[44]*Parameter_f[44]-2*x[44]*Parameter_f[44]))-WW/NND*x[122];
     grad_f[45] = ((1-WW)*PP)*(x[45]-Parameter_f[45])/(sqrt(x[45]*x[45]+Parameter_f[45]*Parameter_f[45]-2*x[45]*Parameter_f[45]))-WW/NND*x[122];
     grad_f[46] = ((1-WW)*PP)*(x[46]-Parameter_f[46])/(sqrt(x[46]*x[46]+Parameter_f[46]*Parameter_f[46]-2*x[46]*Parameter_f[46]))-WW/NND*x[122];
     
     grad_f[47] = ((1-WW)*PP)*(x[47]-Parameter_f[47])/(sqrt(x[47]*x[47]+Parameter_f[47]*Parameter_f[47]-2*x[47]*Parameter_f[47]))-WW/NND*x[123];
     grad_f[48] = ((1-WW)*PP)*(x[48]-Parameter_f[48])/(sqrt(x[48]*x[48]+Parameter_f[48]*Parameter_f[48]-2*x[48]*Parameter_f[48]))-WW/NND*x[123];
     grad_f[49] = ((1-WW)*PP)*(x[49]-Parameter_f[49])/(sqrt(x[49]*x[49]+Parameter_f[49]*Parameter_f[49]-2*x[49]*Parameter_f[49]))-WW/NND*x[123];
   
    grad_f[56] = -(WW/NND)*(x[0]+x[1]+x[2]);
    grad_f[57] = -(WW/NND)*(x[3]+x[4]+x[5]);
    grad_f[58] = -(WW/NND)*(x[6]+x[7]+x[8]);
    grad_f[59] = -(WW/NND)*(x[9]+x[10]+x[11]);
    grad_f[60] = -(WW/NND)*(x[12]+x[13]+x[14]);
    grad_f[61] = -(WW/NND)*(x[15]+x[16]+x[17]);
    
    grad_f[116] = -(WW/NND)*(x[38]+x[39]+x[40]);
    grad_f[117] = -(WW/NND)*(x[41]+x[42]+x[43]);
    grad_f[122] = -(WW/NND)*(x[44]+x[45]+x[46]);
    grad_f[123] = -(WW/NND)*(x[47]+x[48]+x[49]);
    return true;
       
 }
    
 //cout<<"ferdig eval_grad_f"<<endl;
 
}

bool
MyTMINLP::eval_g(Index n, const Number* x, bool new_x, Index m, Number* g)
{

//   cout<<"Starting eval_g------"<<endl;
//   cout<<x[54]<<"  "<<x[60]<<"  "<<x[72]<<"  "<<x[78]<<endl;
//   cout<<x[55]<<"  "<<x[61]<<"  "<<x[73]<<"  "<<x[79]<<endl;
//   cout<<x[56]<<"  "<<x[62]<<"  "<<x[74]<<"  "<<x[80]<<endl;
//   cout<<x[57]<<"  "<<x[63]<<"  "<<x[75]<<"  "<<x[81]<<endl;
//   cout<<x[58]<<"  "<<x[64]<<"  "<<x[76]<<"  "<<x[82]<<endl;
//   cout<<x[59]<<"  "<<x[65]<<"  "<<x[77]<<"  "<<x[83]<<endl;
  
//   printf("Binaries\n");
//   printf("Platform Wells:  %-4.1f %-4.1f %-4.1f %-4.1f %-4.1f %-4.1f\n", x[0], x[1], x[2], x[3], x[4], x[5]);
//   printf("Subsea Wells:  %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f\n", x[6], x[8], x[10], x[12], x[14], x[16]);
//   printf("Subsea Wells:  %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f\n", x[7], x[9], x[11], x[13], x[15], x[17]);
  
  assert(n==NV_MINLP); //variables
  assert(m==MC_MINLP);  //constraints
  
    int s=0; //start value for loops
    int e=0; //end value for loops
    int i=0; //constraint counter
    
    //-------------------------TOPSIDE WELLS-----------------------------
        
    //Topside Well Models: (2) a-b-c in Problem Description File
    int k=50;   //q^WI_ip
    int i1=48;  //q^GL_i
    int i2=76;  //p^WI_i
    e=I;
        //printf("(2) Platform Flowrate Constraints \n");
        //printf("%-5s %-15s %-15s %-15s \n", "Well", "Gas", "Oil", "Water");
    for(int j = s; j < e ; j++){
        double *psim = ratesim(j,0, x[k+i2], x[k+i1], parrptr[j]);
        g[i] = x[k] - (wellspecI[j][1]*x[k+I] + x[k+i1]);                        //2b - gas
        g[i+I] = x[k+I] - psim[0];                                               //2a - oil
            //cout<<"x[k]="<<x[k+I];
            //cout<<"  PSIM="<<psim[0]<<endl;
        g[i+2*I] = x[k+2*I] - (x[k+I]*(wellspecI[j][0]/(1-wellspecI[j][0])));    //2c - water
        
        //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+I, g[i+I], i+2*I, g[i+2*I]);
        k++; i++;
    }
    i=P*I;

    
    //Topside Well Pressure Balance: (3) in Problem Description File
    k=126;
    s=0;
    e=I;
    //cout<<"Testing pressure values "<<x[72]<<"  "<<x[78]<<endl;
    for(int j = s; j < e ; j++){
    	g[i]    = x[k] - (x[j*3]*PSEPA);
        g[i+I]  = x[k] - (x[(j*3)+1]*PSEPB);
        g[i+2*I]= x[k] - (x[(j*3)+2]*PSEPC);
                
        //printf("%-5d %-6.2f >= %-6.2f\n", j, x[k], x[j]*PSEP);
        k++; i++;
    }
    
    i=(P*I)+(S*I);
    
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        g[i] = x[(j*3)] + x[(j*3)+1] + x[(j*3)+2];
        i++;
    }
    //cout<<"Constraint check (42)=="<<i<<endl; 
    
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Manifold 1 Well Models: (5) a-b-c in Problem Description File
    k=68;
    i1=36;
    i2=64;
    s=0;
    e=J1;
            //printf("(4) Subsea Flowrate Constraints \n");
            //printf("%-5s %-15s %-15s %-15s \n", "Well", "Gas", "Oil", "Water");    
    for(int j = s; j < e ; j++){
        double *ssim = ratesim(j,0, x[k+i2], x[k+i1], sarrptr[j]);
        g[i] = x[k] - (wellspecJ[j][1]*x[k+J1] + x[k+i1]);                         //4b - gas
        g[i+J1] = x[k+J1] - ssim[0];                                               //4a - oil
        g[i+2*J1] = x[k+(2*J1)] - (x[k+J1]*(wellspecJ[j][0]/(1-wellspecJ[j][0]))); //4c - water
        
            //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+J, g[i+J], i+2*J, g[i+2*J]);
        k++; i++;
    }
    i=(P*I)+(S*I)+I+(J1*P);
    
    //Subsea Manifold 2 Well Models: (5) a-b-c in Problem Description File
    k=86;
    i1=24;
    i2=52;
    s=J1;
    e=J;
    for(int j = s; j < e ; j++){
        double *ssim = ratesim(j,0, x[k+i2], x[k+i1], sarrptr[j]);
        g[i] = x[k] - (wellspecJ[j][1]*x[k+J2] + x[k+i1]);                           //4b - gas
        g[i+J2] = x[k+J2] - ssim[0];                                                //4a - oil
        g[i+2*J2] = x[k+(2*J2)] - (x[k+J2]*(wellspecJ[j][0]/(1-wellspecJ[j][0])));   //4c - water
        
            //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+J, g[i+J], i+2*J, g[i+2*J]);
        k++; i++;
    }
    
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P);
    
    //Manifold 1 Pipeline Pressure Drop: (6) in Problem Description File
    double *pres1 = PressureDrop(0,0, x[114], x[116], x[118], dParrptr[0]); //Line 1
    double *pres2 = PressureDrop(1,0, x[115], x[117], x[119], dParrptr[1]); //Line 2
    g[i] = x[142] - x[146] - pres1[0];     
    i++;
    g[i] = x[143] - x[147] - pres2[0];     
    i++;
    
    //Manifold 2 Pipeline Pressure Drop: (6) in Problem Description File
    double *pres3 = PressureDrop(2,0, x[120], x[122], x[124], dParrptr[2]); //Line 1
    double *pres4 = PressureDrop(3,0, x[121], x[123], x[125], dParrptr[3]); //Line 2
    g[i] = x[144] - x[148] - pres3[0];   
    i++;
    g[i] = x[145] - x[149] - pres4[0];
    i++;
    
    
    //Subsea Manifold 1 Well Pressure Balance: (7) in Problem Description File
    k = 132;
    i1 = 142;
    i2 = 18;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
    	g[i] = x[k] - (x[i1]*x[i2]); //printf("%-4d %-6.2f >= %-6.2f", j,x[k], x[i1]*x[i2]);
        i2++;
        g[i+J1] = x[k] - (x[i1+1]*x[i2]); //printf(" ---  %-6.2f >= %-6.2f\n", x[k], x[i1+1]*x[i2]);
        i2++;       
        i++; k++;
    }
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1);
    
    //Subsea Manifold 2 Well Pressure Balance: (7) in Problem Description File
    k = 138;
    i1 = 144;
    i2 = 30;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
    	g[i] = x[k] - (x[i1]*x[i2]); //printf("%-4d %-6.2f >= %-6.2f", j,x[k], x[i1]*x[i2]);
        i2++;
        g[i+J2] = x[k] - (x[i1+1]*x[i2]); //printf(" ---  %-6.2f >= %-6.2f\n", x[k], x[i1+1]*x[i2]);
        i2++;       
        i++; k++;
    }
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2);
    
    //Subsea Routing: (8) in Problem Description File
    k=18;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){ 
        g[i] = x[k] + x[k+1]; 
        k=k+2; i++;
    }
    
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2)+J;
    
    //Subsea Manifold 1 Mass Balances: (9) in Problem Description File
    k=114;   i1=18;   i2=68;
    g[i] = x[k] - (x[i1]*x[i2]) - (x[i1+2]*x[i2+1]) - (x[i1+4]*x[i2+2]) - (x[i1+6]*x[i2+3]) - (x[i1+8]*x[i2+4]) - (x[i1+10]*x[i2+5]);
    //cout<<"Line 1 gas g["<<i<<"]="<<g[i]<<endl;
    i++;    k++;
    g[i] = x[k] - (x[i1+1]*x[i2]) - (x[i1+3]*x[i2+1]) - (x[i1+5]*x[i2+2]) - (x[i1+7]*x[i2+3]) - (x[i1+9]*x[i2+4]) - (x[i1+11]*x[i2+5]);
   // cout<<"Line 2 gas g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J1;
    g[i] = x[k] - (x[i1]*x[i2]) - (x[i1+2]*x[i2+1]) - (x[i1+4]*x[i2+2]) - (x[i1+6]*x[i2+3]) - (x[i1+8]*x[i2+4]) - (x[i1+10]*x[i2+5]);
    // cout<<"Line 1 oil g["<<i<<"]="<<g[i]<<endl;
    i++;    k++;
    g[i] = x[k] - (x[i1+1]*x[i2]) - (x[i1+3]*x[i2+1]) - (x[i1+5]*x[i2+2]) - (x[i1+7]*x[i2+3]) - (x[i1+9]*x[i2+4]) - (x[i1+11]*x[i2+5]);
    // cout<<"Line 2 oil g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J1;
    g[i] = x[k] - (x[i1]*x[i2]) - (x[i1+2]*x[i2+1]) - (x[i1+4]*x[i2+2]) - (x[i1+6]*x[i2+3]) - (x[i1+8]*x[i2+4]) - (x[i1+10]*x[i2+5]);
    // cout<<"Line 1 wat g["<<i<<"]="<<g[i]<<endl;

    i++;    k++;
    g[i] = x[k] - (x[i1+1]*x[i2]) - (x[i1+3]*x[i2+1]) - (x[i1+5]*x[i2+2]) - (x[i1+7]*x[i2+3]) - (x[i1+9]*x[i2+4]) - (x[i1+11]*x[i2+5]);
    //  cout<<"Line 2 wat g["<<i<<"]="<<g[i]<<endl;
    i++;
    
    //Subsea Manifold 2 Mass Balances: (9) in Problem Description File
    k=120;   i1=30;   i2=86;
    g[i] = x[k] - (x[i1]*x[i2]) - (x[i1+2]*x[i2+1]) - (x[i1+4]*x[i2+2]) - (x[i1+6]*x[i2+3]);
    //cout<<"Line 3 gas g["<<i<<"]="<<g[i]<<endl;
    i++;    k++;
    g[i] = x[k] - (x[i1+1]*x[i2]) - (x[i1+3]*x[i2+1]) - (x[i1+5]*x[i2+2]) - (x[i1+7]*x[i2+3]);
   // cout<<"Line 4 gas g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J2;
    g[i] = x[k] - (x[i1]*x[i2]) - (x[i1+2]*x[i2+1]) - (x[i1+4]*x[i2+2]) - (x[i1+6]*x[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1<<" -"<<i2<<" -"<<i1+2<<" -"<<i2+1<<" -"<<i1+4<<" -"<<i2+2<<endl;
    // cout<<"Line 3 oil g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;
    g[i] = x[k] - (x[i1+1]*x[i2]) - (x[i1+3]*x[i2+1]) - (x[i1+5]*x[i2+2]) - (x[i1+7]*x[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1+1<<" -"<<i2<<" -"<<i1+3<<" -"<<i2+1<<" -"<<i1+5<<" -"<<i2+2<<endl;
    // cout<<"Line 4 oil g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J2;
    g[i] = x[k] - (x[i1]*x[i2]) - (x[i1+2]*x[i2+1]) - (x[i1+4]*x[i2+2]) - (x[i1+6]*x[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1<<" -"<<i2<<" -"<<i1+2<<" -"<<i2+1<<" -"<<i1+4<<" -"<<i2+2<<endl;    
    // cout<<"Line 3 wat g["<<i<<"]="<<g[i]<<endl;

    i++;    k++;
    g[i] = x[k] - (x[i1+1]*x[i2]) - (x[i1+3]*x[i2+1]) - (x[i1+5]*x[i2+2]) - (x[i1+7]*x[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1+1<<" -"<<i2<<" -"<<i1+3<<" -"<<i2+1<<" -"<<i1+5<<" -"<<i2+2<<endl;
    //  cout<<"Line 4 wat g["<<i<<"]="<<g[i]<<endl;
    i++;    
    
    //cout<<"Constraint check (118)=="<<i<<endl; 
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    k=146;
    i2=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
    	g[i] = x[k] - (x[i2]*PSEPA); i2++;  i++;
        g[i] = x[k] - (x[i2]*PSEPB); i2++;  i++;
        g[i] = x[k] - (x[i2]*PSEPC); i2++;  i++;
        k++;
    }
    //i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2)+J+(P*L)+(S*L);


    //Separator Routing: (11) in Problem Description File
    k=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        g[i] = x[k] + x[k+1] + x[k+2];
        k=k+3;
        i++;
    }
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2)+J+(P*L)+(S*L)+L;
    
    //cout<<"Constraint check (134)=="<<i<<endl; 
        
    //-------------------------CAPACITIES--------------------------------

    //Gas Lift Capacity: (12) in Problem Description File
    g[i]=    x[98]*(x[0]+x[1]+x[2]) + x[99]*(x[3]+x[4]+x[5])
            +x[100]*(x[6]+x[7]+x[8]) + x[101]*(x[9]+x[10]+x[11])
            +x[102]*(x[12]+x[13]+x[14]) + x[103]*(x[15]+x[16]+x[17])
            
            +x[104]*(x[18]+x[19]) + x[105]*(x[20]+x[21])
            +x[106]*(x[22]+x[23]) + x[107]*(x[24]+x[25])
            +x[108]*(x[26]+x[27]) + x[109]*(x[28]+x[29])
            +x[110]*(x[30]+x[31]) + x[111]*(x[32]+x[33])
            +x[112]*(x[34]+x[35]) + x[113]*(x[36]+x[37]);
    i++;
    
    //Gas Production Capacity: (13) in Problem Description File
    g[i]=    x[50]*(x[0]+x[1]+x[2]) + x[51]*(x[3]+x[4]+x[5])
            +x[52]*(x[6]+x[7]+x[8]) + x[53]*(x[9]+x[10]+x[11])
            +x[54]*(x[12]+x[13]+x[14]) + x[55]*(x[15]+x[16]+x[17])
            +x[114]+x[115]+x[120]+x[121];
    i++;        
    
    //Water Production Capacity: (14) in Problem Description File
    
    //Separator A
    g[i]=    x[62]*x[0] + x[63]*x[3] + x[64]*x[6] + x[65]*x[9] + x[66]*x[12] + x[67]*x[15]
            +x[118]*x[38] + x[119]*x[41] + x[124]*x[44] + x[125]*x[47];
    i++;
    
    //Separator B
    g[i]=    x[62]*x[1] + x[63]*x[4] + x[64]*x[7] + x[65]*x[10] + x[66]*x[13] + x[67]*x[16]
            +x[118]*x[39] + x[119]*x[42] + x[124]*x[45] + x[125]*x[48];
    i++;
    
    //Separator C
    g[i]=    x[62]*x[2] + x[63]*x[5] + x[64]*x[8] + x[65]*x[11] + x[66]*x[14] + x[67]*x[17]
            +x[118]*x[40] + x[119]*x[43] + x[124]*x[46] + x[125]*x[49];
    i++;
   

   
  //cout<<"Number of constraints(239) "<<i<<endl;             
  //cout<<"ferdig eval_g"<<endl;
  return true;
    }

bool
MyTMINLP::eval_jac_g(Index n, const Number* x, bool new_x,
                     Index m, Index nnz_jac, Index* iRow, Index *jCol,
                     Number* values){
    
    // send in approaximations of derivatives
    
  assert(n==NV_MINLP);
  assert(nnz_jac == 608);

if(values == NULL) {
//cout<<"Starting eval_jac_g IF LOOP------"<<endl;

    int nz=0; //non-zero counter
    int s=0;  //start value for loops
    int e=0;  //end value for loops
    int i=0;  //constraint counter
    
    //-------------------------TOPSIDE WELLS-----------------------------
    
    //Well Model: (2) in Problem Description File
    int k=50;
    int i1=56;
    int i2=98;
    e=I;
    for (int j=s; j<e ;j++){        //g[0] - g[5]: gas
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(18)="<<nz<<endl;
    
    k=56;
    i1=98;
    i2=126;
    for (int j=s; j<e ;j++){        //g[6] - g[11]: oil
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(36)="<<nz<<endl;
    
    k=62;
    i1=56;
    i2=98;
    for (int j=s; j<e ;j++){        //g[12] - g[17]: water
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;               //This one has no effect, just there because change in problem and don't want to mess with the jacobian structure
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    
    //cout<<"nz(54)="<<nz<<endl;    

    //Topside Well Pressure Balance: (3) in Problem Description File
    k=126;
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){    
        iRow[nz] = i;               //Separator A: g[18] - g[23]
        jCol[nz] = k;       nz++;
        iRow[nz] = i;
        jCol[nz] = (j*3);   nz++;
        k++;    i++;
    }
    k=126;
    for(int j = s; j < e ; j++){    
        iRow[nz] = i;           //Separator B: g[24] - g[29]
        jCol[nz] = k;       nz++;
        iRow[nz] = i;
        jCol[nz] = (j*3)+1; nz++;
        k++;    i++;
    }
    k=126;
    for(int j = s; j < e ; j++){    
        iRow[nz] = i;       //Separator C: g[30] - g[35]
        jCol[nz] = k;       nz++;
        iRow[nz] = i;
        jCol[nz] = (j*3)+2; nz++;
        k++;    i++;
    }
    i=(P*I)+(S*I);
    //cout<<"nz(90)="<<nz<<endl;   
    
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I;
    k=0;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;
        jCol[nz] = k;   nz++;   k++;
        iRow[nz] = i;
        jCol[nz] = k;   nz++;   k++;
        iRow[nz] = i;
        jCol[nz] = k;   nz++;   k++;    i++;
    }   
    //cout<<"nz(108)="<<nz<<endl;
    
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Manifold 1 Well Models: (5) a-b-c in Problem Description File
    k=68;
    i1=74;
    i2=104;
    e=J1;
    for (int j=s; j<e ;j++){        //g[42] - g[47]: gas
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(126)="<<nz<<endl;
    
    k=74;
    i1=104;
    i2=132;
    for (int j=s; j<e ;j++){        //g[48] - g[53]: oil
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(144)="<<nz<<endl;
    
    k=80;
    i1=74;
    i2=104;
    for (int j=s; j<e ;j++){        //g[54] - g[59]: water
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(162)="<<nz<<endl;
    
    //Subsea Manifold 2 Well Models: (5) a-b-c in Problem Description File
    k=86;
    i1=90;
    i2=110;
    e=J2;
    for (int j=s; j<e ;j++){        //g[60] - g[63]: gas
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(174)="<<nz<<endl;
    
    k=90;
    i1=110;
    i2=138;
    for (int j=s; j<e ;j++){        //g[64] - g[67]: oil
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(186)="<<nz<<endl;
    
    k=94;
    i1=90;
    i2=138;
    for (int j=s; j<e ;j++){        //g[68] - g[71]: water
        iRow[nz] = i;
        jCol[nz] = k;   nz++;
        iRow[nz] = i;
        jCol[nz] = i1;  nz++;
        iRow[nz] = i;
        jCol[nz] = i2;  nz++;   i++;    k++;    i1++;   i2++;
    }
    //cout<<"nz(198)="<<nz<<endl;

    //Pipeline Pressure Drop: (6) in Problem Description File
    k=114;                  //g[72] Manifold 1 Line 1
    iRow[nz] = i;           jCol[nz] = 146;     nz++;
    iRow[nz] = i;           jCol[nz] = 142;     nz++;
    iRow[nz] = i;           jCol[nz] = k;       nz++;
    iRow[nz] = i;           jCol[nz] = k+2;     nz++;
    iRow[nz] = i;           jCol[nz] = k+4;     nz++;   i++;
    
    k=115;                  //g[73] Manifold 1 Line 2
    //cout<<"i: "<<i<<"nz: "<<nz<<endl;
    iRow[nz] = i;           jCol[nz] = 147;     nz++;
    iRow[nz] = i;           jCol[nz] = 143;     nz++;
    //cout<<"i: "<<i<<"nz: "<<nz<<endl;
    iRow[nz] = i;           jCol[nz] = k;       nz++;
    //cout<<"i: "<<i<<"nz: "<<nz<<endl;
    iRow[nz] = i;           jCol[nz] = k+2;     nz++;
    //cout<<"i: "<<i<<"nz: "<<nz<<endl;
    iRow[nz] = i;           jCol[nz] = k+4;     nz++;   i++;
    
    k=120;                  //g[74] Manifold 2 Line 3
    iRow[nz] = i;           jCol[nz] = 148;     nz++;
    iRow[nz] = i;           jCol[nz] = 144;     nz++;
    iRow[nz] = i;           jCol[nz] = k;       nz++;
    iRow[nz] = i;           jCol[nz] = k+2;     nz++;
    iRow[nz] = i;           jCol[nz] = k+4;     nz++;   i++;
    
    
    k=121;                  //g[75] Manifold 2 Line 4
    iRow[nz] = i;           jCol[nz] = 149;     nz++;
    iRow[nz] = i;           jCol[nz] = 145;     nz++;
    iRow[nz] = i;           jCol[nz] = k;       nz++;
    iRow[nz] = i;           jCol[nz] = k+2;     nz++;
    iRow[nz] = i;           jCol[nz] = k+4;     nz++;   i++;
    
    //cout<<"nz(218)="<<nz<<endl;
    
    //Subsea Well Pressure Balance: (7) in Problem Description File
    //g[76]-g[81] Manifold 1 Line 1
    k = 132;
    i2 = 18;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = 142;     nz++;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    
    //g[82]-g[87] Manifold 1 Line 2
    k = 132;
    i2 = 19;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = 143;     nz++;
        //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i2<<endl;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    
    //g[88]-g[91] Manifold 2 Line 3
    k = 138;
    i2 = 30;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = 144;     nz++;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    
    //g[92]-g[95] Manifold 2 Line 4
    k = 138;
    i2 = 31;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = 145;     nz++;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    //cout<<"nz(278)="<<nz<<endl;
    
    //Subsea Routing: (8) in Problem Description File
    k=18;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++;
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++;    
        i++;
    }
    //cout<<"nz(298)="<<nz<<endl;
    
    //Subsea Manifold 1 Mass Balances: (9) in Problem Description File
    k=114;  
    for(int h = 0; h < 3; h++){             //g[64] - g[69]
        i1=18;
        i2=68+(h*J1);
        for(int j = 0; j < 2 ; j++){    
            iRow[nz] = i;       jCol[nz] = k;       nz++; k++;
            iRow[nz] = i;       jCol[nz] = i1;      nz++; 
            iRow[nz] = i;       jCol[nz] = i2;      nz++; 
            iRow[nz] = i;       jCol[nz] = i1+2;    nz++; 
            iRow[nz] = i;       jCol[nz] = i2+1;    nz++; 
            iRow[nz] = i;       jCol[nz] = i1+4;    nz++;
            iRow[nz] = i;       jCol[nz] = i2+2;    nz++; 
            iRow[nz] = i;       jCol[nz] = i1+6;    nz++;
            iRow[nz] = i;       jCol[nz] = i2+3;    nz++;
            iRow[nz] = i;       jCol[nz] = i1+8;    nz++;
            iRow[nz] = i;       jCol[nz] = i2+4;    nz++; 
            iRow[nz] = i;       jCol[nz] = i1+10;   nz++;
            iRow[nz] = i;       jCol[nz] = i2+5;    nz++;   
            i++;    i1++; 
        }
    }
    //cout<<"nz(376)="<<nz<<endl;
    
    //Subsea Manifold 2 Mass Balances: (9) in Problem Description File
    k=120;  
    for(int h = 0; h < 3; h++){             //g[64] - g[69]
        i1=30;
        i2=86+(h*J2);
        for(int j = 0; j < 2 ; j++){   
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<k<<endl;
            iRow[nz] = i;       jCol[nz] = k;       nz++; k++;
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i1<<endl;
            iRow[nz] = i;       jCol[nz] = i1;      nz++; 
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i2<<endl;
            iRow[nz] = i;       jCol[nz] = i2;      nz++; 
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i1+2<<endl;
            iRow[nz] = i;       jCol[nz] = i1+2;    nz++; 
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i2+1<<endl;
            iRow[nz] = i;       jCol[nz] = i2+1;    nz++; 
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i1+4<<endl;
            iRow[nz] = i;       jCol[nz] = i1+4;    nz++;
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i2+2<<endl;
            iRow[nz] = i;       jCol[nz] = i2+2;    nz++; 
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i1+6<<endl;
            iRow[nz] = i;       jCol[nz] = i1+6;    nz++;
            //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i2+3<<endl;
            iRow[nz] = i;       jCol[nz] = i2+3;    nz++;
            
            i++;    i1++; 
        }
    }
    //cout<<"nz(430)="<<nz<<endl;
    
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    k=146;
    i1=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = i1;      nz++;   i1++;   i++;
 
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = i1;      nz++;   i1++;   i++;
        
        //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<k<<"    jCol:"<<i1<<endl;
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = i1;      nz++;   i1++;   i++;
        k++;    
    }
    //cout<<"nz(454)="<<nz<<endl;
    
    //Separator Routing: (11) in Problem Description File
    k=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++; 
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++; 
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++; 
        i++;
    }
    //cout<<"nz(466)="<<nz<<endl;
    
    //-------------------------CAPACITIES--------------------------------
    
    
    //Gas Lift Capacity: (12) in Problem Description File
    k=0;
    i1=98;
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;    
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;
        iRow[nz] = i;           jCol[nz] = i1;         nz++;    i1++;
     }
    
    k=18;
    i1=104;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;
        iRow[nz] = i;           jCol[nz] = i1;          nz++;   i1++;
    } 
    i++;
    //cout<<"nz(520)="<<nz<<endl;

    //Gas Production Capacity: (13) in Problem Description File
    k=0;
    i1=50;
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;    
        iRow[nz] = i;           jCol[nz] = k;          nz++;    k++;
        iRow[nz] = i;           jCol[nz] = i1;         nz++;
        i1++;
    }
    
        iRow[nz] = i;           jCol[nz] = 114;          nz++;
        iRow[nz] = i;           jCol[nz] = 115;          nz++;    
        iRow[nz] = i;           jCol[nz] = 120;          nz++;   
        iRow[nz] = i;           jCol[nz] = 121;          nz++;  
        
    i++;    
    
    
    
    //Water Production Capacity: (14) in Problem Description File
    
    //Separator A
        iRow[nz] = i;           jCol[nz] = 0;          nz++;
        iRow[nz] = i;           jCol[nz] = 62;          nz++;    
        iRow[nz] = i;           jCol[nz] = 3;          nz++;   
        iRow[nz] = i;           jCol[nz] = 63;          nz++; 
        iRow[nz] = i;           jCol[nz] = 6;          nz++;
        iRow[nz] = i;           jCol[nz] = 64;          nz++;    
        iRow[nz] = i;           jCol[nz] = 9;          nz++;   
        iRow[nz] = i;           jCol[nz] = 65;          nz++; 
        iRow[nz] = i;           jCol[nz] = 12;          nz++;
        iRow[nz] = i;           jCol[nz] = 66;          nz++;    
        iRow[nz] = i;           jCol[nz] = 15;          nz++;   
        iRow[nz] = i;           jCol[nz] = 67;          nz++; 
        iRow[nz] = i;           jCol[nz] = 38;          nz++;
        iRow[nz] = i;           jCol[nz] = 118;          nz++;    
        iRow[nz] = i;           jCol[nz] = 41;          nz++;   
        iRow[nz] = i;           jCol[nz] = 119;          nz++; 
        iRow[nz] = i;           jCol[nz] = 44;          nz++;   
        iRow[nz] = i;           jCol[nz] = 124;          nz++; 
        iRow[nz] = i;           jCol[nz] = 47;          nz++;   
        iRow[nz] = i;           jCol[nz] = 125;          nz++;
        
    i++;    
    
    //Separator B
        iRow[nz] = i;           jCol[nz] = 1;          nz++;
        iRow[nz] = i;           jCol[nz] = 62;          nz++;    
        iRow[nz] = i;           jCol[nz] = 4;          nz++;   
        iRow[nz] = i;           jCol[nz] = 63;          nz++; 
        iRow[nz] = i;           jCol[nz] = 7;          nz++;
        iRow[nz] = i;           jCol[nz] = 64;          nz++;    
        iRow[nz] = i;           jCol[nz] = 10;          nz++;   
        iRow[nz] = i;           jCol[nz] = 65;          nz++; 
        iRow[nz] = i;           jCol[nz] = 13;          nz++;
        iRow[nz] = i;           jCol[nz] = 66;          nz++;    
        iRow[nz] = i;           jCol[nz] = 16;          nz++;   
        iRow[nz] = i;           jCol[nz] = 67;          nz++; 
        iRow[nz] = i;           jCol[nz] = 39;          nz++;
        iRow[nz] = i;           jCol[nz] = 118;          nz++;    
        iRow[nz] = i;           jCol[nz] = 42;          nz++;   
        iRow[nz] = i;           jCol[nz] = 119;          nz++; 
        iRow[nz] = i;           jCol[nz] = 45;          nz++;   
        iRow[nz] = i;           jCol[nz] = 124;          nz++; 
        iRow[nz] = i;           jCol[nz] = 48;          nz++;   
        iRow[nz] = i;           jCol[nz] = 125;          nz++;
        
    i++; 
    
    //Separator C
        iRow[nz] = i;           jCol[nz] = 2;          nz++;
        iRow[nz] = i;           jCol[nz] = 62;          nz++;    
        iRow[nz] = i;           jCol[nz] = 5;          nz++;   
        iRow[nz] = i;           jCol[nz] = 63;          nz++; 
        iRow[nz] = i;           jCol[nz] = 8;          nz++;
        iRow[nz] = i;           jCol[nz] = 64;          nz++;    
        iRow[nz] = i;           jCol[nz] = 11;          nz++;   
        iRow[nz] = i;           jCol[nz] = 65;          nz++; 
        iRow[nz] = i;           jCol[nz] = 14;          nz++;
        iRow[nz] = i;           jCol[nz] = 66;          nz++;    
        iRow[nz] = i;           jCol[nz] = 17;          nz++;   
        iRow[nz] = i;           jCol[nz] = 67;          nz++; 
        iRow[nz] = i;           jCol[nz] = 40;          nz++;
        iRow[nz] = i;           jCol[nz] = 118;          nz++;    
        iRow[nz] = i;           jCol[nz] = 43;          nz++;   
        iRow[nz] = i;           jCol[nz] = 119;          nz++; 
        iRow[nz] = i;           jCol[nz] = 46;          nz++;   
        iRow[nz] = i;           jCol[nz] = 124;          nz++; 
        iRow[nz] = i;           jCol[nz] = 49;          nz++;   
        iRow[nz] = i;           jCol[nz] = 125;          nz++;
        
    i++;
    

    

    
 
//cout<<"nz(858)="<<nz<<endl;
//cout<<"Ending eval_jac_g IF LOOP"<<endl;

        
	return true;
  }
    else {
    //cout<<"Starting eval_jac_g ELSE LOOP------"<<endl;
    int nz=0; //non-zero counter
    int s=0;  //start value for loops
    int e=0;  //end value for loops
    
    
    //-------------------------TOPSIDE WELLS-----------------------------
    
    //Well Model: (2) in Problem Description File
    int i1=98;
    int i2=126;
    e=I;
    for (int j=s; j<e ;j++){
        double *psim = ratesim(j,1, x[i2], x[i1], parrptr[j]);
        values[nz] = 1;             //Rate
        values[nz+18] = 1;
        values[nz+36] = 1;
        nz++;
        values[nz] = -wellspecI[j][1];      
        values[nz+18] = -psim[2];   // d/dq^GLI_i
        values[nz+36] = -wellspecI[j][0]/(1-wellspecI[j][0]);
        nz++;
        values[nz] = -1;      
        values[nz+18] = -psim[1];   // d/dp^WI_i
        values[nz+36] = 0;  
        
        
        FPJac_w[j][0][It_nlp]=psim[1];
        FPJac_w[j][1][It_nlp]=psim[2];
        
        //cout<<"FPJac_w["<<j<<"][0]["<<It_nlp<<"]: "<<FPJac_w[j][0][It_nlp]<<endl;
        //cout<<"FPJac_w["<<j<<"][1]["<<It_nlp<<"]: "<<FPJac_w[j][1][It_nlp]<<endl;
        
        nz++;   i1++;   i2++;
    }
    //cout<<"nz(18)="<<nz<<endl;
    nz=54;    
    
    //Topside Well Pressure Balance: (3) in Problem Description File
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){
        values[nz] = 1;   
        values[nz+12] = 1;
        values[nz+24] = 1;
        nz++;
        values[nz] = -PSEPA;    
        values[nz+12] = -PSEPB;
        values[nz+24] = -PSEPC;
        nz++;
             
    }
    //cout<<"nz(66)="<<nz<<endl;
    nz=90;
    
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
    }
    //cout<<"nz(108)="<<nz<<endl;
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Manifold 1 Well Models: (5) a-b-c in Problem Description File
    i1=104;
    i2=132;
    s=0;
    e=J1;
    for (int j=s; j<e ;j++){
        double *ssim = ratesim(j,1, x[i2], x[i1], sarrptr[j]);
        values[nz] = 1;             //Rate
        values[nz+18] = 1;
        values[nz+36] = 1;
        nz++;
        values[nz] = -wellspecJ[j][1];;      
        values[nz+18] = -ssim[2];           // d/dq^GLI_i
        values[nz+36] = -wellspecJ[j][0]/(1-wellspecJ[j][0]);
        nz++;
        values[nz] = -1;      
        values[nz+18] = -ssim[1];           // d/dp^WI_i
        values[nz+36] = 0;
        nz++;   i1++;   i2++;
        
        FPJac_w[j+I][0][It_nlp]=ssim[1];
        FPJac_w[j+I][1][It_nlp]=ssim[2];
        
        //cout<<"FPJac_w["<<j+I<<"][0]["<<It_nlp<<"]: "<<FPJac_w[j+I][0][It_nlp]<<endl;
        //cout<<"FPJac_w["<<j+I<<"][1]["<<It_nlp<<"]: "<<FPJac_w[j+I][1][It_nlp]<<endl;
    }   
    //cout<<"nz(126)="<<nz<<endl;
    nz=162;
    
    //Subsea Manifold 2 Well Models: (5) a-b-c in Problem Description File
    i1=110;
    i2=138;
    s=J1;
    e=J;
    for (int j=s; j<e ;j++){
        double *ssim = ratesim(j,1, x[i2], x[i1], sarrptr[j]);
        values[nz] = 1;             //Rate
        values[nz+12] = 1;
        values[nz+24] = 1;
        nz++;
        values[nz] = -wellspecJ[j][1];;      
        values[nz+12] = -ssim[2];           // d/dq^GLI_i
        values[nz+24] = -wellspecJ[j][0]/(1-wellspecJ[j][0]);
        nz++;
        values[nz] = -1;      
        values[nz+12] = -ssim[1];           // d/dp^WI_i
        values[nz+24] = 0;
        nz++;   i1++;   i2++;
        
        
        FPJac_w[j+I][0][It_nlp]=ssim[1];
        FPJac_w[j+I][1][It_nlp]=ssim[2];
        
        //cout<<"FPJac_w["<<j+I<<"][0]["<<It_nlp<<"]: "<<FPJac_w[j+I][0][It_nlp]<<endl;
        //cout<<"FPJac_w["<<j+I<<"][1]["<<It_nlp<<"]: "<<FPJac_w[j+I][1][It_nlp]<<endl;
    } 
    //cout<<"nz(174)="<<nz<<endl;
    nz=198;
        
    //Pipeline Pressure Drop: (6) in Problem Description File
    int k=114;                  //g[72] Manifold 1 Line 1
    double *pres1 = PressureDrop(0,1, x[k], x[k+2], x[k+4], dParrptr[0]);
    values[nz] = -1;                nz++;
    values[nz] = 1;           nz++;
    values[nz] = -pres1[1];     nz++;
    values[nz] = -pres1[2];     nz++;
    values[nz] = -pres1[3];     nz++; 
    
    
    FPJac_p[0][0][It_nlp]=pres1[1];
    FPJac_p[0][1][It_nlp]=pres1[2];
    FPJac_p[0][2][It_nlp]=pres1[3];
    
    //for (int i=0; i<3; i++){
    //cout<<"FPJac_p[pipe 1]["<<i<<"]: "<<FPJac_p[0][i]<<endl;}
    
    k=115;                  //g[73] Manifold 1 Line 2
    double *pres2 = PressureDrop(1,1, x[k], x[k+2], x[k+4], dParrptr[1]);
    values[nz] = -1;                nz++;
    values[nz] = 1;           nz++;
    values[nz] = -pres2[1];     nz++;
    //cout<<"nz: "<<nz-1<<"VALUES 1 : "<<values[nz-1]<<endl;
    values[nz] = -pres2[2];     nz++;
    //cout<<"nz: "<<nz-1<<"VALUES 2 : "<<values[nz-1]<<endl;
    values[nz] = -pres2[3];     nz++;   
    //cout<<"nz: "<<nz-1<<"VALUES 3 : "<<values[nz-1]<<endl;
    
    
    FPJac_p[1][0][It_nlp]=pres2[1];
    //cout<<"FPJac_p[pipe 3]["<<0<<"]["<<It_nlp<<"]: "<<FPJac_p[2][0][It_nlp]<<endl;
    FPJac_p[1][1][It_nlp]=pres2[2];
    //cout<<"FPJac_p[pipe 3]["<<0<<"]["<<It_nlp<<"]: "<<FPJac_p[2][0][It_nlp]<<endl;
    FPJac_p[1][2][It_nlp]=pres2[3];
    //cout<<"FPJac_p[pipe 3]["<<0<<"]["<<It_nlp<<"]: "<<FPJac_p[2][0][It_nlp]<<endl;
    
    //for (int i=0; i<3; i++){
    //cout<<"FPJac_p[pipe 2]["<<i<<"]: "<<FPJac_p[1][i]<<endl;}
    
    k=120;                  //g[74] Manifold 2 Line 3
    double *pres3 = PressureDrop(2,1, x[k], x[k+2], x[k+4], dParrptr[2]);
    values[nz] = -1;                nz++;
    values[nz] = 1;           nz++;
    values[nz] = -pres3[1];     nz++;
    //cout<<"VALUS 1 : "<<values[nz-1]<<endl;
    values[nz] = -pres3[2];     nz++;
    //cout<<"VALUES 2 : "<<values[nz-1]<<endl;
    values[nz] = -pres3[3];     nz++;   
    //cout<<"VALUES 3: "<<values[nz-1]<<endl;
    
    
    FPJac_p[2][0][It_nlp]=pres3[1];
    //cout<<"FPJac_p[pipe 3]["<<0<<"]["<<It_nlp<<"]: "<<FPJac_p[2][0][It_nlp]<<endl;
    FPJac_p[2][1][It_nlp]=pres3[2];
    //cout<<"FPJac_p[pipe 3]["<<1<<"]["<<It_nlp<<"]: "<<FPJac_p[2][1][It_nlp]<<endl;
    FPJac_p[2][2][It_nlp]=pres3[3];
    //cout<<"FPJac_p[pipe 3]["<<2<<"]["<<It_nlp<<"]: "<<FPJac_p[2][2][It_nlp]<<endl;
    
    
    
    k=121;                  //g[75] Manifold 2 Line 4
    double *pres4 = PressureDrop(3,1, x[k], x[k+2], x[k+4], dParrptr[3]);
    values[nz] = -1;                nz++;
    values[nz] = 1;           nz++;
    values[nz] = -pres4[1];     nz++;
    values[nz] = -pres4[2];     nz++;
    values[nz] = -pres4[3];     nz++;   
    //cout<<"nz(218)="<<nz<<endl;
    
    
    FPJac_p[3][0][It_nlp]=pres4[1];
    FPJac_p[3][1][It_nlp]=pres4[2];
    FPJac_p[3][2][It_nlp]=pres4[3];
    
    //for (int i=0; i<3; i++){
    //cout<<"FPJac_p[pipe 4]["<<i<<"]: "<<FPJac_p[3][i]<<endl;}
    
  //Subsea Well Pressure Balance: (7) in Problem Description File
    //g[76]-g[81] Manifold 1 Line 1
    
    i2 = 18;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        values[nz] = 1;       nz++;   
        values[nz] = -x[i2];     nz++;
        values[nz] = -x[142];      nz++;   
        i2=i2+2;
    }
    
    //g[82]-g[87] Manifold 1 Line 2
    i2 = 19;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        values[nz] = 1;       nz++;   
        values[nz] = -x[i2];     nz++;
        //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<i2<<endl;
        values[nz] = -x[143];      nz++;   
        i2=i2+2;
    }
    
    //g[88]-g[91] Manifold 2 Line 3
    i2 = 30;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        values[nz] = 1;       nz++;   
        values[nz] = -x[i2];     nz++;
        values[nz] = -x[144];      nz++;   
        i2=i2+2;
    }
    
    //g[92]-g[95] Manifold 2 Line 4
    i2 = 31;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        values[nz] = 1;       nz++;   
        values[nz] = -x[i2];     nz++;
        values[nz] = -x[145];      nz++;   
        i2=i2+2;
    }
    //cout<<"nz(278)="<<nz<<endl;
    nz=278;
    
    //Subsea Routing: (8) in Problem Description File
    k=18;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        values[nz]=1;   nz++;
        values[nz]=1;   nz++;
    }
    //cout<<"nz(298)="<<nz<<endl;
       
    //Subsea Manifold 1 Mass Balances: (9) in Problem Description File
    for(int h = 0; h < 3; h++){
        i1=18;
        i2=68+(h*J1);
        for(int j = 0; j < 2 ; j++){    
            values[nz] = 1;
            nz++;
            values[nz] = -x[i2];
            nz++; 
            values[nz] = -x[i1];
            nz++; 
            values[nz] = -x[i2+1];
            nz++; 
            values[nz] = -x[i1+2];
            nz++; 
            values[nz] = -x[i2+2];
            nz++;
            values[nz] = -x[i1+4];
            nz++;
            values[nz] = -x[i2+3];
            nz++;
            values[nz] = -x[i1+6];
            nz++;
            values[nz] = -x[i2+4];
            nz++;
            values[nz] = -x[i1+8];
            nz++; 
            values[nz] = -x[i2+5];
            nz++;
            values[nz] = -x[i1+10];
            nz++;  i1++;
        }
    }
    //cout<<"nz(376)="<<nz<<endl;
    
    //Subsea Manifold 2 Mass Balances: (9) in Problem Description File
    for(int h = 0; h < 3; h++){
        i1=30;
        i2=86+(h*J2);
        for(int j = 0; j < 2 ; j++){   
            //cout<<"-------------nz:"<<nz<<endl;
            values[nz] = 1;
            nz++;
            values[nz] = -x[i2];
            nz++; 
            values[nz] = -x[i1];
            nz++; 
            values[nz] = -x[i2+1];
            nz++; 
            values[nz] = -x[i1+2];
            nz++; 
            values[nz] = -x[i2+2];
            nz++;
            values[nz] = -x[i1+4];
            nz++;
            values[nz] = -x[i2+3];
            nz++;
            values[nz] = -x[i1+6];
            nz++;   i1++;
        }
    }
    //cout<<"nz(430)="<<nz<<endl;
    
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=0;
    e=L;
    //cout<<"HERE!"<<endl;
    for(int j = s; j < e ; j++){

        values[nz] = 1;         nz++;
        values[nz] = -PSEPA;    nz++;

        values[nz] = 1;         nz++;
        values[nz] = -PSEPB;    nz++;
        
        values[nz] = 1;         nz++;
        values[nz] = -PSEPC;    nz++;
        
    }
   // cout<<"nz(454)="<<nz<<endl;
    
    //Separator Routing: (11) in Problem Description File
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        values[nz] = 1;         nz++;
        values[nz] = 1;         nz++;
        values[nz] = 1;         nz++;
    }
    //cout<<"nz(466)="<<nz<<endl;
    
    //-------------------------CAPACITIES--------------------------------
    
   
    //Gas Lift Capacity: (12) in Problem Description File    
    k=0;
    i1=98;
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        values[nz] = x[i1];    nz++;
        values[nz] = x[i1];    nz++;
        values[nz] = x[i1];    nz++;
        values[nz] = x[k] + x[k+1] + x[k+2];    nz++;
        i1++; k=k+3;
    }
    k=18;
    i1=104;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        values[nz] = x[i1];    nz++;
        values[nz] = x[i1];    nz++;
        values[nz] = x[k] + x[k+1];    nz++;
        i1++; k=k+2;
    }
   // cout<<"nz(520)="<<nz<<endl;   
    
    //Gas Production Capacity: (13) in Problem Description File
    k=0;
    i1=50;
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        values[nz] = x[i1];    nz++;
        values[nz] = x[i1];    nz++;
        values[nz] = x[i1];    nz++;
        values[nz] = x[k] + x[k+1] + x[k+2];    nz++;
        i1++; k=k+3;
    }
    values[nz] = 1;     nz++;
    values[nz] = 1;     nz++;
    values[nz] = 1;     nz++;
    values[nz] = 1;     nz++;
    //cout<<"nz(548)="<<nz<<endl;   
    

    //Water Production Capacity: (14) in Problem Description File
    k=62;
    //Separator A
    values[nz]=x[k];   nz++;       values[nz]=x[0];     nz++;
    values[nz]=x[k+1];   nz++;       values[nz]=x[3];     nz++;
    values[nz]=x[k+2];   nz++;       values[nz]=x[6];     nz++;
    values[nz]=x[k+3];   nz++;       values[nz]=x[9];     nz++;
    values[nz]=x[k+4];   nz++;       values[nz]=x[12];     nz++;
    values[nz]=x[k+5];   nz++;       values[nz]=x[15];     nz++;
    values[nz]=x[118];   nz++;       values[nz]=x[38];     nz++;
    values[nz]=x[119];   nz++;       values[nz]=x[41];     nz++;
    values[nz]=x[124];   nz++;       values[nz]=x[44];     nz++;
    values[nz]=x[125];   nz++;       values[nz]=x[47];     nz++;
    //cout<<"nz(568)="<<nz<<endl; 
    
    
    //Separator B
    values[nz]=x[k];   nz++;       values[nz]=x[1];     nz++;
    values[nz]=x[k+1];   nz++;       values[nz]=x[4];     nz++;
    values[nz]=x[k+2];   nz++;       values[nz]=x[7];     nz++;
    values[nz]=x[k+3];   nz++;       values[nz]=x[10];     nz++;
    values[nz]=x[k+4];   nz++;       values[nz]=x[13];     nz++;
    values[nz]=x[k+5];   nz++;       values[nz]=x[16];     nz++;
    values[nz]=x[118];   nz++;       values[nz]=x[39];     nz++;
    values[nz]=x[119];   nz++;       values[nz]=x[42];     nz++;
    values[nz]=x[124];   nz++;       values[nz]=x[45];     nz++;
    values[nz]=x[125];   nz++;       values[nz]=x[48];     nz++;
    //cout<<"nz(588)="<<nz<<endl; 
    
    
    //Separator A
    values[nz]=x[k];   nz++;       values[nz]=x[2];     nz++;
    values[nz]=x[k+1];   nz++;       values[nz]=x[5];     nz++;
    values[nz]=x[k+2];   nz++;       values[nz]=x[8];     nz++;
    values[nz]=x[k+3];   nz++;       values[nz]=x[11];     nz++;
    values[nz]=x[k+4];   nz++;       values[nz]=x[14];     nz++;
    values[nz]=x[k+5];   nz++;       values[nz]=x[17];     nz++;
    values[nz]=x[118];   nz++;       values[nz]=x[40];     nz++;
    values[nz]=x[119];   nz++;       values[nz]=x[43];     nz++;
    values[nz]=x[124];   nz++;       values[nz]=x[46];     nz++;
    values[nz]=x[125];   nz++;       values[nz]=x[49];     nz++;
   
    

 
    
    //cout<<"NUmber of Jac (858):"<<nz<<endl;
    //cout<<"Ferdig eval_jac_g ELSE LOOP"<<endl;
    return true;
}
}

bool
MyTMINLP::eval_h(Index n, const Number* x, bool new_x,
                 Number obj_factor, Index m, const Number* lambda,
                 bool new_lambda, Index nele_hess, Index* iRow,
                 Index* jCol, Number* values)
{
    
  assert (n==NC);
  assert (m==MC_MINLP);
  assert(nele_hess==0);

  //cout<<"ferdig eval_h"<<endl;
  return true;
}

void
MyTMINLP::finalize_solution(TMINLP::SolverReturn status,
                            Index n, const Number* x, Number obj_value)
{
  std::cout<<"Problem status: "<<status<<std::endl;
  std::cout<<"Objective value: "<<obj_value<<std::endl;
  if(printSol_ && x != NULL){
    std::cout<<"Solution:"<<std::endl;
    for(int i = 0 ; i < n ; i++){
      std::cout<<"x["<<i<<"] = "<<x[i];
      if(i < n-1) std::cout<<", ";}
    std::cout<<std::endl;
  }
  printf("\nWriting solution file solution.txt\n");
  FILE* fp = fopen("solution.txt", "w");

  // For this example, we write the solution to the console
  fprintf(fp, "\n\nSolution of the primal variables, x\n");
  for (Index i=0; i<n; i++) {
    fprintf(fp, "%e\n", x[i]); //x[%d] =
  }
  
  fprintf(fp, "\n\nObjective value\n");
  fprintf(fp, "f(x*) = %e\n", obj_value);
  
   fclose(fp);
   
   //----------------Save Solution--------------------
   sol_feasible = status;
   


//----------------Set MILP values--------------------  

//         int i1=0;
//         for (int j=0; j<I; j++){
//         tangent_w [j][0][It_nlp] =temp_sol[126+i1];        //Pressure
//         //cout<<"tangent_w ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_w [j][0][It_nlp]<<endl;
//         tangent_w [j][1][It_nlp] =temp_sol[98+i1];        //Gas Lift
//         //cout<<"tangent_w ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_w [j][1][It_nlp]<<endl;
//         tangent_w [j][2][It_nlp] = temp_sol[56+i1];     //Oil
//         //cout<<"tangent_w ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_w [j][2][It_nlp]<<endl;
//         i1++;
//         
//         tangent_jacw [j][0][It_nlp] = FPJac_w[j][0][It_nlp];     //Gradient
//         //cout<<"tangent_jacw ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacw [j][0][It_nlp]<<endl;
//         tangent_jacw [j][1][It_nlp] = FPJac_w[j][1][It_nlp];     //Gradient
//         //cout<<"tangent_jacw ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacw [j][1][It_nlp]<<endl;
//         }
//         
//         
//         int i1=0;
//         for (int j=I; j<I+J1; j++){
//         tangent_w [j][0][It_nlp] =temp_sol[132+i1];        //Pressure
//         //cout<<"tangent_w ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_w [j][0][It_nlp]<<endl;
//         tangent_w [j][1][It_nlp] =temp_sol[104+i1];        //Gas Lift
//         //cout<<"tangent_w ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_w [j][1][It_nlp]<<endl;
//         tangent_w [j][2][It_nlp] = temp_sol[74+i1];     //Oil
//         //cout<<"tangent_w ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_w [j][2][It_nlp]<<endl;
//         i1++;
//         
//         tangent_jacw [j][0][It_nlp] = FPJac_w[j][0][It_nlp];     //Gradient
//         //cout<<"tangent_jacw ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacw [j][0][It_nlp]<<endl;
//         tangent_jacw [j][1][It_nlp] = FPJac_w[j][1][It_nlp];     //Gradient
//         //cout<<"tangent_jacw ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacw [j][1][It_nlp]<<endl;
//         }
//         
//         int i1=0;
//         for (int j=I+J1; j<I+J1+J2; j++){
//         tangent_w [j][0][It_nlp] =temp_sol[138+i1];        //Pressure
//         //cout<<"tangent_w ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_w [j][0][It_nlp]<<endl;
//         tangent_w [j][1][It_nlp] =temp_sol[110+i1];        //Gas Lift
//         //cout<<"tangent_w ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_w [j][1][It_nlp]<<endl;
//         tangent_w [j][2][It_nlp] = temp_sol[90+i1];     //Oil
//         //cout<<"tangent_w ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_w [j][2][It_nlp]<<endl;
//         i1++;
//         
//         tangent_jacw [j][0][It_nlp] = FPJac_w[j][0][It_nlp];     //Gradient
//         //cout<<"tangent_jacw ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacw [j][0][It_nlp]<<endl;
//         tangent_jacw [j][1][It_nlp] = FPJac_w[j][1][It_nlp];     //Gradient
//         //cout<<"tangent_jacw ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacw [j][1][It_nlp]<<endl;
//         }
//         
//         i1=0;          
//         for (int j=0; j<L1; j++){
//         tangent_p [j][0][It_nlp] = temp_sol[114+i1];      //Gas
//         //cout<<"tangent_p ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_p [j][0][It_nlp]<<endl;
//         tangent_p [j][1][It_nlp] = temp_sol[116+i1];     //Oil
//         //cout<<"tangent_p ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_p [j][1][It_nlp]<<endl;
//         tangent_p [j][2][It_nlp] = temp_sol[118+i1];     //Water
//         //cout<<"tangent_p ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_p [j][2][It_nlp]<<endl;
//         tangent_p [j][3][It_nlp] = temp_sol[142+i1]-temp_sol[146+i1];       //Pressure Drop
//         //cout<<"tangent_p ["<<j<<"][3]["<<It_nlp<<"]: "<<tangent_p [j][3][It_nlp]<<endl;
//         
//         i1++;
//         
//         tangent_jacp [j][0][It_nlp] =FPJac_p[j][0][It_nlp];     //Gradient
//         //cout<<"tangent_jacp ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacp [j][0][It_nlp]<<endl;
//         tangent_jacp [j][1][It_nlp] =FPJac_p[j][1][It_nlp];     //Gradient
//         //cout<<"tangent_jacp ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacp [j][1][It_nlp]<<endl;
//         tangent_jacp [j][2][It_nlp] =FPJac_p[j][2][It_nlp];     //Gradient
//         //cout<<"tangent_jacp ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_jacp [j][2][It_nlp]<<endl; 
//         }  
//          
//         
//         i1=0;
//         for (int j=L1; j<L; j++){
//         tangent_p [j][0][It_nlp] = temp_sol[120+i1];      //Gas
//         // cout<<"tangent_p ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_p [j][0][It_nlp]<<endl;
//         tangent_p [j][1][It_nlp] = temp_sol[122+i1];     //Oil
//         // cout<<"tangent_p ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_p [j][1][It_nlp]<<endl;
//         tangent_p [j][2][It_nlp] = temp_sol[124+i1];     //Water
//         // cout<<"tangent_p ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_p [j][2][It_nlp]<<endl;
//         tangent_p [j][3][It_nlp] = temp_sol[144+i1]-temp_sol[148+i1];        //Pressure Drop
//         //cout<<"tangent_p ["<<j<<"][3]["<<It_nlp<<"]: "<<tangent_p [j][3][It_nlp]<<endl;
//         
//         i1++;
//         
//         tangent_jacp [j][0][It_nlp] =FPJac_p[j][0][It_nlp];     //Gradient
//         //cout<<"tangent_jacp ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacp [j][0][It_nlp]<<endl;
//         tangent_jacp [j][1][It_nlp] =FPJac_p[j][1][It_nlp];     //Gradient
//         //cout<<"tangent_jacp ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacp [j][1][It_nlp]<<endl;
//         tangent_jacp [j][2][It_nlp] =FPJac_p[j][2][It_nlp];     //Gradient
//         //cout<<"tangent_jacp ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_jacp [j][2][It_nlp]<<endl; 
//         }   
//            }
//   
        
  
       
   
  }

//Functions to read well data
void MyTMINLP::readWellData(const string &filen, double data[gdim][pdim][ddim]) {

    //cout<<"Reading well "<<endl;
	// Opening the well data file
	ifstream inFile(filen.c_str());
    
	int i,j,k;
	string line;
    string word = "s:";
	streampos beg;
	
	// Reading in the matrix of data into a string in order 
	// to find relevant positions
	while(!inFile.eof()){

		line.push_back(inFile.get());

	}

	//inFile has reached eof making it fail, so it must be cleared before continuing
	inFile.clear();
		
	size_t pos;
	
	//Find starting position of word
	pos = line.find(word);
	if (pos!=string::npos)

	//Move the get pointer 3 positions (bc of s:)
	beg = (int(pos) + 3);
	inFile.seekg(beg, ios::beg);

	//Now begin reading in the data	
        
		for(i=0;i<gdim;i++){
			for(j=0;j<pdim;j++){
                for(k=0;k<ddim;k++){
				inFile >> data[i][j][k];
                //cout<<data[i][j][k]<< "  ";
                }
            //cout<<endl;
            }
        }

	// Closing the well data file
	inFile.close();
}

void MyTMINLP::readWells(){
    
    //Read well specifications of GOR and WC
    readWspecs();
    
    
    //Read topside well data
    readWellData("PMRL_1.txt",P01);
    readWellData("PMRL_2.txt",P02);
    readWellData("PMRL_3.txt",P03);
    readWellData("PMRL_4.txt",P04);
    readWellData("PMRL_5.txt",P05);
    readWellData("PMRL_6.txt",P06);
    
    //Read subsea well data
    //cout<<"S01"<<endl;
    readWellData("SMRL_7.txt",S01);
    //cout<<"S02"<<endl;
    readWellData("SMRL_8.txt",S02);
    //cout<<"S03"<<endl;
    readWellData("SMRL_9.txt",S03);
    //cout<<"S04"<<endl;
    readWellData("SMRL_10.txt",S04);
    readWellData("SMRL_11.txt",S05);
    readWellData("SMRL_12.txt",S06);
    //cout<<"S07"<<endl;
    readWellData("SMRL_13.txt",S07);
    readWellData("SMRL_14.txt",S08);
    readWellData("SMRL_15.txt",S09);
    readWellData("SMRL_16.txt",S010);

    //Set the pointers to the well data matrices
    //cout<<" Hei"<<endl;
    set_arrptr();   
   
    PSEPA = 10.0;
    PSEPB = 12.0;
    PSEPC = 15.0;
    
    //read min/max values of the wells
    minmax_wells(0, P01);
    minmax_wells(1, P02);
    minmax_wells(2, P03);
    minmax_wells(3, P04);
    minmax_wells(4, P05);
    minmax_wells(5, P06);
    
    minmax_wells(6, S01);
    minmax_wells(7, S02);
    minmax_wells(8, S03);
    minmax_wells(9, S04);
    minmax_wells(10, S05);
    minmax_wells(11, S06);
    
    minmax_wells(12, S07);
    minmax_wells(13, S08);
    minmax_wells(14, S09);
    minmax_wells(15, S010);   
    
    
    //print minmax results
//     for(int i=0; i<I+J; i++){
//         cout<<minmax_w[i][0][0]<<" -- "<<minmax_w[i][0][1]<<" -- "<<minmax_w[i][1][0]<<" -- "
//                 <<minmax_w[i][1][1]<<" -- "<<minmax_w[i][2][0]<<" -- "<<minmax_w[i][2][1]<<" -- "<<endl;
//     }
    
}

void MyTMINLP::readWspecs(){
    //cout<<"reading Wspecs"<<endl;
    
    wellspecI[0][0] = 0.6110;
    wellspecI[0][1] = 0.089;
    wellspecI[1][0] = 0.4649;
    wellspecI[1][1] = 0.0787;
    wellspecI[2][0] = 0.6878;
    wellspecI[2][1] = 0.1009;     
    wellspecI[3][0] = 0.6702;
    wellspecI[3][1] = 0.0832;
    wellspecI[4][0] = 0.6110;
    wellspecI[4][1] = 0.0952;
    wellspecI[5][0] = 0.6548;
    wellspecI[5][1] = 0.0700;
    
    wellspecJ[0][0] = 0.2023;
    wellspecJ[0][1] = 0.0872;
    wellspecJ[1][0] = 0.7900;
    wellspecJ[1][1] = 0.0850;
    wellspecJ[2][0] = 0.3769;
    wellspecJ[2][1] = 0.0770;
    wellspecJ[3][0] = 0.1800;
    wellspecJ[3][1] = 0.0800;
    wellspecJ[4][0] = 0.2767;
    wellspecJ[4][1] = 0.0955;
    wellspecJ[5][0] = 0.2023;
    wellspecJ[5][1] = 0.0872;
    
    //Funnet p well-spec for testing
    wellspecJ[6][0] = 0.324;
    wellspecJ[6][1] = 0.081;
    wellspecJ[7][0] = 0.616;
    wellspecJ[7][1] = 0.0434;
    wellspecJ[8][0] = 0.0843;
    wellspecJ[8][1] = 0.0707;
    wellspecJ[9][0] = 0.7138;
    wellspecJ[9][1] = 0.0554;
}

void MyTMINLP::minmax_wells(int i, double data[gdim][pdim][ddim]){//minmax_w[i][j][0]=min  minmax_w[i][j][1]=max
    //cout<<"MINIMAX_WELLS"<<endl;
    //cout<<"i: "<<i<<endl;
    
    for(int j=0; j<3; j++){ //for each well and each output (g/o/w/bhp)
            double a[gdim*pdim];
            //Extract the right column and save it in a[], which will be sent to min/max_val functions
            int l=0;
            for(int e=0; e<gdim; e++){
                for(int f=0; f<pdim; f++){
                    a[l] = data[e][f][j];
                    //cout<<a[l]<<endl;
                    l++;
                }
            }  
            int minn=min_val((gdim*pdim), a);
            int maxx=max_val((gdim*pdim), a);
            //cout<<"minn: "<<minn<<" -----  maxx: "<<maxx<<endl;
            
            minmax_w[i][j][0]= data[int(floor(minn/pdim))][int(minn-(pdim*(floor(minn/pdim))))][j];
            minmax_w[i][j][1]= data[int(floor(maxx/pdim))][int(maxx-(pdim*(floor(maxx/pdim))))][j];
            
            //cout<<"min "<<i<<","<<j<<": "<<minmax_w[i][j][0]<<endl;
            //cout<<"max "<<i<<","<<j<<": "<<minmax_w[i][j][1]<<endl;
            
        }
    
}

void MyTMINLP::set_arrptr(){
    
parrptr[0]=P01;
parrptr[1]=P02;
parrptr[2]=P03;
parrptr[3]=P04;
parrptr[4]=P05;
parrptr[5]=P06;

sarrptr[0]=S01;
sarrptr[1]=S02;
sarrptr[2]=S03;
sarrptr[3]=S04;
sarrptr[4]=S05;
sarrptr[5]=S06;
sarrptr[6]=S07;
sarrptr[7]=S08;
sarrptr[8]=S09;
sarrptr[9]=S010;

}   

void MyTMINLP::readDeltaPData(const string &filen, double data[dim][dim][dim][4]){

	// Opening the well data file
	ifstream inFile(filen.c_str());

	int i;
	string line; //used to store all the data in the file so we can search it later
	streampos beg;
	string G = "G:";
	string O = "O:";
	string W = "W:";
	string P = "P:";
	
	// Reading in the matrix of data into a string in order 
	// to find relevant positions
	while(!inFile.eof()){

		line.push_back(inFile.get());

	}

	//inFile has reached eof making it fail, so it must be cleared before continuing
	inFile.clear();
		
	size_t pos;
	
	//Now begin reading in the data points for gas
	//Find starting position of word for gas
	pos = line.find(G);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);

		for(i=0;i<dim;i++){
			inFile >> gas[i];
			//cout<< gas[i] << endl;
		}
	//data_intervall[0] = gas[1]-gas[0];

	//Now begin reading in the data points for oil
	//Find starting position of word for oil
	pos = line.find(O);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);

		for(i=0;i<dim;i++){
			inFile >> oil[i];
			//cout<< oil[i] << endl;
		}

	//data_intervall[1] = oil[1]-oil[0];

	//Now begin reading in the data points for water
	//Find starting position of word for water
	pos = line.find(W);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);

		for(i=0;i<dim;i++){
			inFile >> wat[i];
			//cout<< wat[i] << endl;
		}
	
	//data_intervall[2]=wat[1]-wat[0];

	//Now begin reading in the pressure drop data
	//Find starting position of word for pressuredrop data
	pos = line.find(P);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);
	int g, o, w, p;

	for(g=0; g<dim; g++){
		for(o=0; o<dim; o++){
			for(w=0; w<dim; w++){
				for(p=0; p<4; p++){
					inFile >> data[g][o][w][p];
					//cout<< data[g][o][w][p] << "  ";
				}
			//cout<<endl;
			}
		}
	
	}
	//OBS: Dette funker pga den fine rekkefolgen i datafilen. Dersom jeg vil lese inn olje forst, 
    //ogsaa vann ogsaa gass maa pos flyttes til begynnelsen av filen etter hver innlesing, noe som ikke er gjort naa.

	// Closing the file
	inFile.close();
}

void MyTMINLP::readPipes(){
    
    readDeltaPData("Pipeline1.txt", dP1);
    readDeltaPData("Pipeline2.txt", dP2);
    readDeltaPData("Pipeline3.txt", dP3);
    readDeltaPData("Pipeline4.txt", dP4);
    
    set_dParrPtr();
}    

void MyTMINLP::set_dParrPtr(){
    dParrptr[0] = dP1;
    dParrptr[1] = dP2;
    dParrptr[2] = dP3;
    dParrptr[3] = dP4;
}
    
            

//Functions to make simulator from tables + their derivatives
double * MyTMINLP::ratesim(int well,int c, double pW, double qGL, double (*data)[pdim][ddim]){
    //cout<<"**********RATESIM***********"<<endl;
    double * values = new double[3];//This will be returned by the function:
                                    //values[0]=oil
                                    //values[1]=do/dp  
                                    //values[2]=do/dq 
    
    
   
    //cout<<"qGL="<<qGL<<" --- ";
    //cout<<"pW="<<pW<<endl;
     
//     for(int i=0; i<gdim; i++){
//         for(int j=0; j<pdim; j++){
//             for (int k=0; k<ddim; k++){
//                 cout<<data[i][j][k]<<"   ";
//             }
//             cout<<endl;
//         }
//     };
    
    
    //1) FIND THE INDEXES BELOW p^W and q^GL
    double qcol[gdim];
    double pcol[pdim];
    //cout<<"Printing qcol"<<endl;
    for (int i=0; i<gdim; i++){
        //cout<<i<<": "<<data[i][0][0]<<endl;
        qcol[i]=(qGL/data[i][0][0])-1;
        //cout<<i<<": "<<qcol[i]<<endl;
    }
    for (int i=0; i<pdim; i++){
        pcol[i]=(pW/data[0][i][1])-1;} 
    
    int iiq=closest_zero(gdim, qcol);
    int iip=closest_zero(pdim, pcol);
    //cout<<"1.iq="<<iiq<<"         "<<"ip="<<iip<<endl;
    
    if(iip<0){iip=0;}
    else if(iip>=pdim-1){
        iip=pdim-2;
        pW=data[0][iip][1];
    //    cout<<"pW="<<pW<<endl;
    }
    
    if(iiq<0){iiq=0;}
    else if(iiq>=gdim-1){
        iiq=gdim-2;
        qGL=data[iiq][0][0];
    //    cout<<"qGL="<<qGL<<endl;
    }
    
    //cout<<"2.iq="<<iiq<<"         "<<"ip="<<iip<<endl;
         
    //2) FIND THE OIL VALUE
    
    //2a)Find the weights: vp=closeness to pW upper breakpoint, vq=closeness to qGL upper breakpoint
    double vq= 1.0 -(  ((data[iiq+1][0][0]) - qGL)/((data[iiq+1][0][0] - data[iiq][0][0]))   );
    double vp= 1.0 -((data[0][iip+1][1] - pW)/(data[0][iip+1][1] - data[0][iip][1]));
    //cout<<"vq="<<vq<<"         "<<"vp="<<vp<<endl;
    
    //2b) Interpolate first twice in the pW direction with qGL constant, then interpolate once in the qGL direction
    
    //----Oil----
    double fgl=( (1-vp)*(data[iiq][iip][2]) + vp*(data[iiq][iip+1][2]) );
    double fgu=( (1-vp)*(data[iiq+1][iip][2]) + vp*(data[iiq+1][iip+1][2]) );
    //cout<<"fgl="<<fgl<<"         "<<"fgu="<<fgu<<endl;
    
    values[0] = ((1-vq)*fgl) + vq*(fgu);
    //cout<<"Oil value: "<<values[0]<<endl;
    
    
    for(int i=1; i<3; i++){        //Just setting the remaining slots in the vector values to zero in case
        values[i]=0;}              //we are just interested in function value and are not continuing.
    
    
    
if (c==1){  //if derivatives are needed, this part of the code will also be run
    //3) CALCULATING THE pW DERIVATIVES
        //cout<<"CALCULATING DERIVATIVES"<<endl;
        
    double ppert = 10e-4;
    double qpert = 10e-2;    

    //3.a) Increase pW by ppert
    double pWi = pW + ppert;
    double vpi= 1.0 -((data[0][iip+1][1] - pWi)/(data[0][iip+1][1] - data[0][iip][1]));

    //----Oil----
    double dp_gl=( (1-vpi)*(data[iiq][iip][2]) + vpi*(data[iiq][iip+1][2]) );
    double dp_gu=( (1-vpi)*(data[iiq+1][iip][2]) + vpi*(data[iiq+1][iip+1][2]) );
    values[1] = ((((1-vq)*dp_gl) + vq*(dp_gu)) - values[0])*(1/ppert);  
    
    //4) CALCULATING THE qGL DERIVATIVES
    
    //3.a) Increase qGL by qpert
    double qGLi = qGL + qpert;
    double vqi= 1.0 -(  ((data[iiq+1][0][0]) - qGLi)/((data[iiq+1][0][0] - data[iiq][0][0]))   );

    //----Oil----
    double dq_gl=( (1-vp)*(data[iiq][iip][2]) + vp*(data[iiq][iip+1][2]) );
    double dq_gu=( (1-vp)*(data[iiq+1][iip][2]) + vp*(data[iiq+1][iip+1][2]) );
    values[2] = ((((1-vqi)*dq_gl) + vqi*(dq_gu)) - values[0])*(1/qpert);
}   
    
    //5) WRITING TO FILE
    itt++;
    //if(itt<1000){
    //printsome(itt, iip, iiq, pW, pWi, qGL, qGLi, values);
    //}
    
    //For Testing Purposes - Remove Later
//     cout<<"------------Simulation Call----------- callnum: "<<itt<<"      PW: "<<pW<<" ----- QGL: "<<qGL<<endl;
//     for (int i=0; i<12; i++){
//         cout<<"v["<<i<<"]:"<<values[i]<<", ";
//     }
//     cout<<endl;   
    
    //cout<<"Done with Ratesim"<<endl;
    //cout<<"values[0]="<<values[0]<<"---"<<"values[1]="<<values[1]<<"---"<<"values[2]="<<values[2]<<endl;
    
//----------------------Feasibility Pump----------------------------
    
    
    
    return values;
}

double * MyTMINLP::PressureDrop(int pipe, int k, double xx, double yy, double zz, double (*data)[dim][dim][4]){
    //This functions follows the trilinear interpolation description on Wikipedia, can be found at:
    // http://en.wikipedia.org/wiki/Trilinear_interpolation
    
    //cout<<"**********Entering PressureDrop*************"<<endl;
    
    //In addition, the derivatives in each direction will also be found    
    double * values = new double[4];//values[0]=Function value
                                    //values[1]=df/dx
                                    //values[2]=df/dy
                                    //values[3]=df/dz
    values[0] = 0;
    values[1] = 0;
    values[2] = 0;
    values[3] = 0;
    
//    cout<<"Gas: "<<xx<<"        Oil: "<<yy<<"          Water: "<<zz<<endl;

    double pert = 5; //Value for perturbation in each direction, needed in order to use finite differencing
    
for (int i=0; i<4; i++){
        
        if ((i==1) && (k==1)){
            xx=xx+pert;}
        else if ((i==2) && (k==1)){
            yy=yy+pert;}
        else if ((i==3) && (k==1)){
            zz=zz+pert;}

    //1. FIND LOWER INDICES IN ALL DIMENSIONS X,Y AND Z
    
    //1a. Make vectors
    double xcol[xdim];
    double ycol[ydim];
    double zcol[zdim];
    
    int irr = 0; //Irrelevant what number you put in here, might as well put zero
    
    //1b. Fill the vectors
    for(int b=0; b<xdim; b++){
        xcol[b]=(xx/data[b][irr][irr][0])-1;
    }
    
    for(int b=0; b<ydim; b++){
        ycol[b]=(yy/data[irr][b][irr][1])-1;
    }
    
    for(int b=0; b<zdim; b++){
        zcol[b]=(zz/data[irr][irr][b][2])-1;
    }
    
    
    //1c. The positive number closest to zero in the vector will give the lower index for each dimension
    int xi=closest_zero(xdim, xcol);
    int yi=closest_zero(ydim, ycol);
    int zi=closest_zero(zdim, zcol);
    
        //Make sure the indices are not above or under their bounds
        if(xi<0){xi=0;}
        else if(xi>=xdim-1){
        xi=xdim-2;
        xx=data[xi][irr][irr][0];
        }
        if(yi<0){yi=0;}
        else if(yi>=ydim-1){
        yi=ydim-2;
        yy=data[irr][yi][irr][1];
        }
        if(zi<0){zi=0;}
        else if(zi>=zdim-1){
        zi=zdim-2;
        zz=data[irr][irr][zi][2];
        }    
        
    //1d. Find difference between x,y,z and lower coordinate
    double xd = (xx-data[xi][irr][irr][0])/(data[xi+1][irr][irr][0] - data[xi][irr][irr][0]);
    double yd = (yy-data[irr][yi][irr][1])/(data[irr][yi+1][irr][1] - data[irr][yi][irr][1]);
    double zd = (zz-data[irr][irr][zi][2])/(data[irr][irr][zi+1][2] - data[irr][irr][zi][2]);
    
    //2. INTERPOLATION IN THE xx DIRECTION - GIVES 4 NEW POINTS
    
    double c00 = (data[xi][yi][zi][3]     * (1-xd)) + (data[xi+1][yi][zi][3]     * xd);
    double c10 = (data[xi][yi+1][zi][3]   * (1-xd)) + (data[xi+1][yi+1][zi][3]   * xd);
    double c01 = (data[xi][yi][zi+1][3]   * (1-xd)) + (data[xi+1][yi][zi+1][3]   * xd); 
    double c11 = (data[xi][yi+1][zi+1][3] * (1-xd)) + (data[xi+1][yi+1][zi+1][3] * xd);    
    
    //3. INTERPOLATION IN THE Y DIRECTION - GIVES 2 NEW POINTS
    double c0 = c00*(1-yd) + c10*yd;
    double c1 = c01*(1-yd) + c11*yd;
    
    //4. INTERPOLATION IN THE Z DIRECTION - GIVES THE FINAL APPROXIMATED VALUE
    double c = c0*(1-zd) + c1*zd;
    
    values[i]=c;

}
    //5. FOR THE DERIVATIVES, TAKE THE FINITE DIFFERENCE
    values[1] = (values[1] - values[0])/pert;
    values[2] = (values[2] - values[0])/pert;
    values[3] = (values[3] - values[0])/pert;

    //-------------------------Feasibility Pump----------------------------------
    
    
    
    //cout<<"values[0]="<<values[0]<<"  ---  "<<"values[1]="<<values[1]<<"  ---  "<<"values[2]="<<values[2]<<"  ---  "<<"values3]="<<values[3]<<endl;
    //cout<<"Leaving PressureDrop"<<endl;
    return values;
} 


void MyTMINLP::printsome(int itt, int ip, int iq, double p, double pi, double q, double qi, double val[12]){ 

ofstream iterations;
iterations.open ("iterations.txt", ios::out | ios::app);

iterations<<"Iteration: "<<itt<<endl;
iterations<<"Simulator call for:  ---pW: "<<p<<"---  and ---qGL: "<<q<<"---"<<endl;
iterations<<"Perturbed values  :  ---pW: "<<pi<<"---  and ---qGL: "<<qi<<"---"<<endl;
iterations<<endl;
iterations<<"Breakpoint indices: pW="<<ip<<" & qGL="<<iq<<endl;
iterations<<endl;
iterations<<"Calculated Values"<<endl;
iterations<<"Gas: "<<val[0]<<"        dg/dp: "<<val[4]<<"       dg/dq: "<<val[8]<<endl;
iterations<<"Oil: "<<val[1]<<"        do/dp: "<<val[5]<<"       do/dq: "<<val[9]<<endl;
iterations<<"Water: "<<val[2]<<"        dw/dp: "<<val[6]<<"       dw/dq: "<<val[10]<<endl;
iterations<<"pBHP: "<<val[3]<<"        db/dp: "<<val[7]<<"       db/dq: "<<val[11]<<endl;
iterations<<endl;
// iterations<<endl;
// iterations<<"Distances & Weights"<<endl;
// for (int i=0; i<4; i++){
// iterations<<i<<": Dist="<<d[i]<<"        Weight=: "<<w[i]<<endl;
// }
iterations<<"-----------------------------------------------------------------------"<<endl;
iterations<<endl;
iterations.close();

    
}


//General Functions
int MyTMINLP::round(double n){
int r;
if ( (n+0.5) >= (int(n)+1) )
	r = int(n) +1;
else
	r = int(n);

return r;
}	

int MyTMINLP::min_val(int size, double a[]){
    int index=0;
    double temp=a[0];
    for (int i=1; i<size; i++){
        if (a[i]==-1){
        }
        else if (a[i]<temp){
            temp=a[i];
            index=i;
        }
    }
    return index;
}
        
int MyTMINLP::max_val(int size, double a[]){
    int index=0;
    double temp=a[0];
    for (int i=1; i<size; i++){
        if (a[i] == -1){
        }
        else if (a[i]>temp){
            temp=a[i];
            index=i;
        }
    }
    return index;
}

int MyTMINLP::closest_zero(int size, double a[]){
    int index=0;
    double temp=a[0];
    for(int i=1; i<size;i++){
        if (a[i] < 0){
        }
        else if (a[i]<temp){
            temp=a[i];
            index=i;
        }
    }
    return index;
}

// void MyTMINLP::save_sol(const double* adr){
// 	
// 	for(int i=0;i<88;i++){
// 	sol[i] = adr[i];
// 	
// 	}
// }
// 
// void MyTMINLP::is_int_feasible(){
//     int ret=0;
//     int sum=0;
//     for(int i=0; i<18; i++){
//         if ((sol[i] == 1) || (sol[i] == 0)){
//             sum=sum+1;
//         }
//     }
//     
//     if (sum == 18){
//         ret = 1;
//     }
// }
        




void MyTMINLP::readminmax_gl(){
   
   minmax_gl[0][0] = 0;
   minmax_gl[0][1] = 300;
   minmax_gl[1][0] = 0;
   minmax_gl[1][1] = 300;
   minmax_gl[2][0] = 0;
   minmax_gl[2][1] = 300;
   minmax_gl[3][0] = 0;
   minmax_gl[3][1] = 300;
   minmax_gl[4][0] = 0;
   minmax_gl[4][1] = 300;
   minmax_gl[5][0] = 0;
   minmax_gl[5][1] = 300;
   
   minmax_gl[6][0] = 0;
   minmax_gl[6][1] = 300;
   minmax_gl[7][0] = 0;
   minmax_gl[7][1] = 300;
   minmax_gl[8][0] = 0;
   minmax_gl[8][1] = 300;
   minmax_gl[9][0] = 0;
   minmax_gl[9][1] = 300;
   minmax_gl[10][0] = 0;
   minmax_gl[10][1] = 300;
   minmax_gl[11][0] = 0;
   minmax_gl[11][1] = 300;
   minmax_gl[12][0] = 0;
   minmax_gl[12][1] = 300;
   minmax_gl[13][0] = 0;
   minmax_gl[13][1] = 300;
   minmax_gl[14][0] = 0;
   minmax_gl[14][1] = 300;
   minmax_gl[15][0] = 0;
   minmax_gl[15][1] = 300;   
}


void MyTMINLP::readminmax_p(){
   //gas 
   minmax_p[0][0][0] = 0;
   minmax_p[0][0][1] = 10000;
   minmax_p[1][0][0] = 0;
   minmax_p[1][0][1] = 10000;
   minmax_p[2][0][0] = 0;
   minmax_p[2][0][1] = 10000;
   minmax_p[3][0][0] = 0;
   minmax_p[3][0][1] = 10000;     
   
   //oil
   minmax_p[0][1][0] = 0;
   minmax_p[0][1][1] = 10000;
   minmax_p[1][1][0] = 0;
   minmax_p[1][1][1] = 10000;
   minmax_p[2][1][0] = 0;
   minmax_p[2][1][1] = 10000;
   minmax_p[3][1][0] = 0;
   minmax_p[3][1][1] = 10000;  
   
   //water
   minmax_p[0][2][0] = 0;
   minmax_p[0][2][1] = 12000;
   minmax_p[1][2][0] = 0;
   minmax_p[1][2][1] = 12000;
   minmax_p[2][2][0] = 0;
   minmax_p[2][2][1] = 12000;
   minmax_p[3][2][0] = 0;
   minmax_p[3][2][1] = 12000;
   
   //pressure
   minmax_p[0][3][0] = 0;
   minmax_p[0][3][1] = 300;
   minmax_p[1][3][0] = 0;
   minmax_p[1][3][1] = 300;
   minmax_p[2][3][0] = 0;
   minmax_p[2][3][1] = 300;
   minmax_p[3][3][0] = 0;
   minmax_p[3][3][1] = 300; 
}

//FEASIBILITY PUMP

void MyTMINLP::set_It(int It){
    It_nlp=It;
}

void MyTMINLP::setWW(int It){
    

if (It==0){WW=1;}			
			
// else if (It==		1	){
// WW=	0.95		;}
// 			
// else if (It==		2	){
// WW=	0.9		;}
// 			
// else if (It==		3	){
// WW=	0.8		;}
// 			
// else if (It==		4	){
// WW=	0.1		;}
// 			
// else if (It==		5	){
// WW=	0.09		;}
// 			
// else if (It==		6	){
// WW=	0.08		;}
// 			
// else if (It==		7	){
// WW=	0.07		;}
// 			
// else if (It==		8	){
// WW=	0.06		;}
// 			
// else if (It==		9	){
// WW=	0.05		;}
// 			
// else if (It==		10	){
// WW=	0.03		;}
// 			
// else if (It==		11	){
// WW=	0.01		;}
// 			
// else if (It==		12	){
// WW=	0.01		;}
// 			
// else if (It==		13	){
// WW=	0.01		;}
// 			
// else if (It==		14	){
// WW=	0.01		;}
// 			
// else if (It==		15	){
// WW=	0.01		;}
// 			
// else if (It==		16	){
// WW=	0.01		;}
// 			
// else if (It==		17	){
// WW=	0		;}
// 			
// else if (It==		18	){
// WW=	0		;}
// 			
// else if (It==		19	){
// WW=	0		;}



if (It==0){WW=1;}			
			
else if (It==		1	){
WW=	1		;}
			
else if (It==		2	){
WW=	1		;}
			
else if (It==		3	){
WW=	0.999		;}
			
else if (It==		4	){
WW=	0.99		;}
			
else if (It==		5	){
WW=	0.5	;}
						
else if (It==		6	){
WW=	0.1		;}
			
else if (It==		7	){
WW=	0.07		;}
			
else if (It==		8	){
WW=	0.05		;}
			
else if (It==		9	){
WW=	0.02		;}
			
else if (It==		10	){
WW=	0.005		;}
			
else if (It==		11	){
WW=	0.005		;}
			
else if (It==		12	){
WW=	0.001	;}
			
else if (It==		13	){
WW=		0.001		;}
			
else if (It==		14	){
WW=		0.001		;}
			
else if (It==		15	){
WW=		0.001		;}
			
else if (It==		16	){
WW=		0.001		;}
			
else if (It==		17	){
WW=	0		;}
			
else if (It==		18	){
WW=	0		;}
			
else if (It==		19	){
WW=	0		;}
    
    NND=1000;
			

			
			
// else if (It==		1	){
// WW=	0.95		;}
// 			
// else if (It==		2	){
// WW=	0.9		;}
// 			
// else if (It==		3	){
// WW=	0.8		;}
// 			
// else if (It==		4	){
// WW=	0.01		;}
// 			
// else if (It==		5	){
// WW=	0.009		;}
// 			
// else if (It==		6	){
// WW=	0.008		;}
// 			
// else if (It==		7	){
// WW=	0.007		;}
// 			
// else if (It==		8	){
// WW=	0.006		;}
// 			
// else if (It==		9	){
// WW=	0.005		;}
// 			
// else if (It==		10	){
// WW=	0.003		;}
// 			
// else if (It==		11	){
// WW=	0.001		;}
// 			
// else if (It==		12	){
// WW=	0.001		;}
// 			
// else if (It==		13	){
// WW=	0.001		;}
// 			
// else if (It==		14	){
// WW=	0.001		;}
// 			
// else if (It==		15	){
// WW=	0.001	;}
// 			
// else if (It==		16	){
// WW=	0.001		;}
// 			
// else if (It==		17	){
// WW=	0.001		;}
// 			
// else if (It==		18	){
// WW=	0.00		;}
// 			
// else if (It==		19	){
// WW=	0.00		;}    
//     NND=100;
//        
    
			
			
// else if (It==		1	){
// WW=	0.95		;}
// 			
// else if (It==		2	){
// WW=	0.9		;}
// 			
// else if (It==		3	){
// WW=	0.8		;}
// 			
// else if (It==		4	){
// WW=	0.001		;}
// 			
// else if (It==		5	){
// WW=	0.0009		;}
// 			
// else if (It==		6	){
// WW=	0.0008		;}
// 			
// else if (It==		7	){
// WW=	0.0007		;}
// 			
// else if (It==		8	){
// WW=	0.0006		;}
// 			
// else if (It==		9	){
// WW=	0.005		;}
// 			
// else if (It==		10	){
// WW=	0.0003		;}
// 			
// else if (It==		11	){
// WW=	0.0001		;}
// 			
// else if (It==		12	){
// WW=	0.0001		;}
// 			
// else if (It==		13	){
// WW=	0.0001		;}
// 			
// else if (It==		14	){
// WW=	0.0001		;}
// 			
// else if (It==		15	){
// WW=	0.0001	;}
// 			
// else if (It==		16	){
// WW=	0.0001		;}
// 			
// else if (It==		17	){
// WW=	0.0001		;}
// 			
// else if (It==		18	){
// WW=	0.00		;}
// 			
// else if (It==		19	){
// WW=	0.00		;}    
//     NND=10;
//     
// 
// 
// 
//     
//     NND=100;
    //cout<<"MILP WW: "<<WW<<endl;
    
}

void MyTMINLP::save_sol(const double* adr){
	
    if(milp==true){
    for(int i=0;i<50;i++){
    Parameter_f[i]=adr[i];
	} }
    
    if(nlp==true){
    for(int i=0; i<NV_MINLP; i++){ 
    Parameter_start[i]=adr[i];}
    }
}

void MyTMINLP::set_nlp(){
    nlp=true;
    milp=false;
}

void MyTMINLP::set_milp(){
    nlp=false;
    milp=true;
}

void MyTMINLP::init_tangentValues(){   
 
for (int i=0; i<150; i++){
     Parameter_f[i]=0;
 }

for (int i=0; i<MaxIt; i++){
  minDist[i]=0;
  maxOFV[i]=0;
};

Parameter_start[0]=	0.399981	;
Parameter_start[1]=	0.331844	;
Parameter_start[2]=	0.258307	;
Parameter_start[3]=	0.310693	;
Parameter_start[4]=	0.372671	;
Parameter_start[5]=	0.316487	;
Parameter_start[6]=	0.0054004	;
Parameter_start[7]=	0.00541736	;
Parameter_start[8]=	0.00541621	;
Parameter_start[9]=	0.254324	;
Parameter_start[10]=	0.28068	;
Parameter_start[11]=	0.262696	;
Parameter_start[12]=	0.310228	;
Parameter_start[13]=	0.372374	;
Parameter_start[14]=	0.316673	;
Parameter_start[15]=	0.304287	;
Parameter_start[16]=	0.367074	;
Parameter_start[17]=	0.324827	;
Parameter_start[18]=	0.482855	;
Parameter_start[19]=	0.516805	;
Parameter_start[20]=	0.00150094	;
Parameter_start[21]=	0.00135808	;
Parameter_start[22]=	0.482301	;
Parameter_start[23]=	0.514888	;
Parameter_start[24]=	0.57484	;
Parameter_start[25]=	0.424988	;
Parameter_start[26]=	0.574499	;
Parameter_start[27]=	0.425284	;
Parameter_start[28]=	0.482884	;
Parameter_start[29]=	0.516834	;
Parameter_start[30]=	0.495958	;
Parameter_start[31]=	0.503908	;
Parameter_start[32]=	0.420056	;
Parameter_start[33]=	0.573814	;
Parameter_start[34]=	0.608675	;
Parameter_start[35]=	0.391275	;
Parameter_start[36]=	0.00212601	;
Parameter_start[37]=	0.00223641	;
Parameter_start[38]=	0.402324	;
Parameter_start[39]=	0.333372	;
Parameter_start[40]=	0.264304	;
Parameter_start[41]=	0.402405	;
Parameter_start[42]=	0.333368	;
Parameter_start[43]=	0.264227	;
Parameter_start[44]=	0.405833	;
Parameter_start[45]=	0.3337	;
Parameter_start[46]=	0.260467	;
Parameter_start[47]=	0.405469	;
Parameter_start[48]=	0.33369	;
Parameter_start[49]=	0.260841	;
Parameter_start[50]=	9.9359	;
Parameter_start[51]=	343.011	;
Parameter_start[52]=	82.5229	;
Parameter_start[53]=	41.449	;
Parameter_start[54]=	210.402	;
Parameter_start[55]=	113.743	;
Parameter_start[56]=	80.9461	;
Parameter_start[57]=	1334.98	;
Parameter_start[58]=	240.542	;
Parameter_start[59]=	261.841	;
Parameter_start[60]=	735	;
Parameter_start[61]=	506.194	;
Parameter_start[62]=	127.142	;
Parameter_start[63]=	1159.84	;
Parameter_start[64]=	529.932	;
Parameter_start[65]=	532.097	;
Parameter_start[66]=	1154.46	;
Parameter_start[67]=	960.185	;
Parameter_start[68]=	144.018	;
Parameter_start[69]=	99.4759	;
Parameter_start[70]=	65.3866	;
Parameter_start[71]=	276.233	;
Parameter_start[72]=	130.016	;
Parameter_start[73]=	166.347	;
Parameter_start[74]=	964.923	;
Parameter_start[75]=	31.9035	;
Parameter_start[76]=	324.393	;
Parameter_start[77]=	1335.59	;
Parameter_start[78]=	1255.85	;
Parameter_start[79]=	1139.52	;
Parameter_start[80]=	244.709	;
Parameter_start[81]=	120.018	;
Parameter_start[82]=	196.218	;
Parameter_start[83]=	293.178	;
Parameter_start[84]=	480.43	;
Parameter_start[85]=	288.987	;
Parameter_start[86]=	236.474	;
Parameter_start[87]=	48.9388	;
Parameter_start[88]=	171.563	;
Parameter_start[89]=	93.1238	;
Parameter_start[90]=	1389.14	;
Parameter_start[91]=	362.038	;
Parameter_start[92]=	2423.59	;
Parameter_start[93]=	141.617	;
Parameter_start[94]=	665.802	;
Parameter_start[95]=	580.77	;
Parameter_start[96]=	223.118	;
Parameter_start[97]=	353.201	;
Parameter_start[98]=	52.7317	;
Parameter_start[99]=	237.948	;
Parameter_start[100]=	58.2522	;
Parameter_start[101]=	19.6639	;
Parameter_start[102]=	140.43	;
Parameter_start[103]=	78.3093	;
Parameter_start[104]=	59.8766	;
Parameter_start[105]=	96.7641	;
Parameter_start[106]=	40.4083	;
Parameter_start[107]=	169.386	;
Parameter_start[108]=	10.0819	;
Parameter_start[109]=	66.981	;
Parameter_start[110]=	123.953	;
Parameter_start[111]=	33.2263	;
Parameter_start[112]=	0.215152	;
Parameter_start[113]=	85.2782	;
Parameter_start[114]=	415.035	;
Parameter_start[115]=	366.894	;
Parameter_start[116]=	2661.92	;
Parameter_start[117]=	2356.39	;
Parameter_start[118]=	797.06	;
Parameter_start[119]=	705.935	;
Parameter_start[120]=	242.462	;
Parameter_start[121]=	214.579	;
Parameter_start[122]=	2316.51	;
Parameter_start[123]=	1856.35	;
Parameter_start[124]=	710.723	;
Parameter_start[125]=	756.847	;
Parameter_start[126]=	6.30532	;
Parameter_start[127]=	10.0142	;
Parameter_start[128]=	44.1963	;
Parameter_start[129]=	15.3967	;
Parameter_start[130]=	10.0709	;
Parameter_start[131]=	12.1043	;
Parameter_start[132]=	41.6337	;
Parameter_start[133]=	150.397	;
Parameter_start[134]=	41.874	;
Parameter_start[135]=	50.0071	;
Parameter_start[136]=	50.0151	;
Parameter_start[137]=	41.6285	;
Parameter_start[138]=	30.0553	;
Parameter_start[139]=	40.4227	;
Parameter_start[140]=	40.0061	;
Parameter_start[141]=	108.467	;
Parameter_start[142]=	86.0947	;
Parameter_start[143]=	80.4375	;
Parameter_start[144]=	60.4321	;
Parameter_start[145]=	59.4959	;
Parameter_start[146]=	4.15342	;
Parameter_start[147]=	4.15853	;
Parameter_start[148]=	4.48858	;
Parameter_start[149]=	4.4594	;






 for(int i=0; i<MaxIt; i++){    
        for (int j=0; j<I+J; j++){
        tangent_w [j][0][i] = 0;        //Pressure
        tangent_w [j][1][i] = 0;        //Gas Lift
        tangent_w [j][2][i] = 1500;     //Oil
        tangent_jacw [j][0][i] = 0;     //Gradient
        tangent_jacw [j][1][i] =  0;     //Gradient
        }           
        for (int j=0; j<L; j++){
        tangent_p [j][0][i] = 0;      //Gas
        tangent_p [j][1][i] = 0;     //Oil
        tangent_p [j][2][i] = 0;     //Water
        tangent_p [j][3][i] = 0;       //Pressure Drop
        tangent_jacp [j][0][i] =0;     //Gradient
        tangent_jacp [j][1][i] =0;     //Gradient
        tangent_jacp [j][2][i] =0;     //Gradient
        }   
    }
}

void MyTMINLP::lock_bounds(const double* x){
    
    
    //Generell Lsning
    if(It_nlp>2){
    for (int i=0; i<NB; i++){
    if(x[i]>0.9){
        l_bound[i]=1;
    }}}

    if(It_nlp>4){
    for (int i=0; i<NB; i++){
    if(x[i]>0.8){
        l_bound[i]=1;
    }}}
    
    if(It_nlp>6){
    for (int i=0; i<NB; i++){
    if(x[i]>0.6){
        l_bound[i]=1;
    }}}
    
    if(It_nlp>8){
    for (int i=0; i<NB; i++){
    if(x[i]>0.5){
        l_bound[i]=1;
    }}}
    
    if(It_nlp<2){
    for (int i=18; i<NB; i++){
    if(x[i]<0.2){
        u_bound[i]=0;
    }}}
    
    if(It_nlp>2){
    for (int i=18; i<NB; i++){
    if(x[i]<0.3){
        u_bound[i]=0;
    }}}
    
    if(It_nlp>8){
    for (int i=0; i<38; i++){
    if(x[i]<0.4){
        u_bound[i]=0;
    }}}
    
   
    
    
    //Subsea Brnner
    int i1=0;
    int i2=0;
    int s=18;
    
    for (int i=0; i<J1; i=i+2){
        if(u_bound[s+i==1]){
         i1++;   
        }     
    }
    
    for (int i=0; i<J1; i=i+2){
        if(u_bound[s+i+1==1]){
         i2++;   
        }     
    }
    
    if(It_nlp>3){
    for (int i=0; i<J1; i++){
    if(x[s]>0.5 && x[s+1]>0.4){
        if(i1<=3){
        l_bound[s]=1;
        u_bound[s+1]=0;
        i1++;}
    }
    
    if(x[s]>0.4 && x[s+1]>0.5){
        if(i2<=3){
        l_bound[s+1]=1;
        u_bound[s]=0;
        i2++;}
    }
    
    if(x[s]<0.45 && x[s+1]<0.45){
        l_bound[s+1]=0;
        u_bound[s]=0;
    }
    
    s=s+2;
}}
    
    //Subsea Manifold 2
    int i3=0;
    int i4=0;
    s=30;
    
    //Teller hvor mange brnner som er lst til hver 
    for (int i=0; i<J2; i=i+2){
        if(u_bound[s+i==1]){
         i3++;   
        }     
        if(u_bound[s+i+1==1]){
         i4++;   
        }  
    }
    
    
    if(l_bound[30]>0.99){
     u_bound[34]=0; 
     l_bound[35]=0;
    }
    else if(l_bound[31]>0.99){
     u_bound[35]=0; 
     l_bound[35]=0;
    }
    else if(l_bound[34]>0.99){
     u_bound[30]=0; 
     l_bound[30]=0;
    }
    else if(l_bound[35]>0.99){
     u_bound[31]=0; 
     l_bound[31]=0;
    }
    
    if(It_nlp>3){
    for (int i=0; i<J2; i++){
    if(x[s+1]>x[s]){
        if(i3<=2){
        l_bound[s]=0;
        u_bound[s+1]=1;
        i1++;}
        
    }
    
    if(x[s]>x[s+1]){
        if(i4<=2){
        l_bound[s+1]=0;
        u_bound[s]=1;
        i2++;}
    }
    
    if(x[s]<0.45 && x[s+1]<0.45){
        l_bound[s+1]=0;
        u_bound[s]=0;
    }
    s=s+2;
}}
    
    
     //Separator Routing Line
    if(It_nlp==0){
    int MM=0;
    int teller=0;
    for (int i=38; i<NB; i++){
        if(x[i]>MM){
         MM=x[i];
         teller=i;
        }
    }
        l_bound[teller]=1;
    }
    
    i1=0; 
    i2=0;
    if(It_nlp==0){
        for (int i=38; i<NB; i=i+3){
        l_bound[i1+i]=1;
        if(i2==0 || i2==2){i1++;}
        i2++;
        }
    }  
          
    
    
    
    if(It_nlp>8){
    for (int i=38; i<NB; i++){
    if(x[i]<0.3){
        u_bound[i]=0;
    }}}
    
    if(It_nlp>10){
    for (int i=38; i<NB; i=i+3){
    if(x[i]<0.4 && x[i+1]<0.4 && x[i+2]<0.4){
        if(x[i]>x[i+1] && x[i]>x[i+2]){
        l_bound[i]=1;}
        if(x[i+1]>x[i] && x[i]>x[i+2]){
        l_bound[i+1]=1;}
        if(x[i+2]>x[i+1] && x[i]>x[i]){
        l_bound[i+2]=1;}
    }}}
    
    
    
    //Topside brnner
    if(It_nlp>5){
    for(int i=0; i<18; i++){
     
     if(x[i]<0.1){
      if(l_bound[i]==0){
      u_bound[i]=0;}   
     }}}
        

    
    if(It_nlp>10){
    for(int i=0; i<18; i++){
     
     if(x[i]<0.5){
      if(l_bound[i]==0){
      u_bound[i]=0;}   
     }}}
        
    if(It_nlp>5){
    for(int i=0; i<18; i++){
     
     if(x[i]>0.5){
      if(u_bound[i]==1){
      l_bound[i]=1;}   
     }}}
    
    
    save_bounds();
        
}

void MyTMINLP::save_bounds(){
    for (int i=0; i<NB; i++){
    u[i]=u_bound[i];
    l[i]=l_bound[i];}
}

void MyTMINLP::restore_bounds(){
    for (int i=0; i<NB; i++){
    u_bound[i]=u[i];
    l_bound[i]=l[i];}
    
    for (int i=0; i<NV_MINLP; i++){
    Parameter_start[i]=dummy_start[i];}
}
    
void MyTMINLP::set_bounds(){
    
    for (int i=0; i<NB; i++){
        l[i]=0;
        u[i]=1;
    }
    
    for (int i=0; i<NB; i++){
        l_bound[i]=0;
        u_bound[i]=1;
    }
    
    }

void MyTMINLP::lock_BoundPH1(double milp[NB]){
    
    for (int i=0; i<NB; i++){
        l_bound[i]=milp[i];
        u_bound[i]=milp[i];
    }
    
}


void MyTMINLP::intSol(const double* milp){
    
    for (int i=0; i<NB; i++){
        l_bound[i]=milp[i];
        u_bound[i]=milp[i];
    }
}

void MyTMINLP::set_boundsmilp(double minlp [NB]){
    
    for (int i=0; i<NB; i++){
        l_bound[i]=minlp[i];
        u_bound[i]=minlp[i];
            }
    
    
    for (int i=0; i<NV_MINLP; i++){
        dummy_start[i]=Parameter_start[i];
       }
            
    for (int i=0; i<NV_MINLP; i++){
        Parameter_start[i]=minlp[i];
            }
//     for (int i=0; i<NB; i++){
//     cout<<l_bound[i]<<endl;
//     cout<<u_bound[i]<<endl;}
}

void MyTMINLP::print_solValues(const double* x){ 

ofstream myfile ("oilproductionNLP.txt");    
    
if (myfile.is_open()){   
    
   tot_prod=0;
   
   tot_prod =   (x[56]*(x[0]+x[1]+x[2]))+(x[57]*(x[3]+x[4]+x[5]))+ (x[58]*(x[6]+x[7]+x[8]))+ (x[59]*(x[9]+x[10]+x[11]))+ (x[60]*(x[12]+x[13]+x[14]))+ (x[61]*(x[15]+x[16]+x[17])) + (x[116]*(x[38]+x[39]+x[40])) + (x[117]*(x[41]+x[42]+x[43]))+ (x[122]*(x[44]+x[45]+x[46])) + (x[123]*(x[47]+x[48]+x[49]));
    
   myfile <<"Oil production from wells"<<endl;
        myfile<<endl;
        myfile<<"Total Production: "<<tot_prod<<endl;
        myfile<<endl;
        myfile <<"Topside Wells"<<endl;
        for (int i=0; i<I; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Production: "<<x[56+i]<<endl;}
        for (int i=0; i<I; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Gas: "<<x[50+i]<<endl;}
        for (int i=0; i<I; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Water: "<<x[62+i]<<endl;
        }
        myfile<<endl;
        myfile <<"Subsea Wells"<<endl;
        
        for (int i=0; i<J1; i++){ 
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Production: "<<x[74+i]<<endl;}
        for (int i=0; i<J1; i++){ 
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Gas: "<<x[68+i]<<endl;}
        for (int i=0; i<J1; i++){ 
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Water: "<<x[80+i]<<endl;
         }
        
        myfile<<endl;
        for (int i=0; i<J2; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Production: "<<x[90+i]<<endl;}
        for (int i=0; i<J2; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Gas: "<<x[86+i]<<endl;}
        for (int i=0; i<J2; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Water: "<<x[94+i]<<endl;
        }
        
        myfile<<endl; 
           //Gas Lift Capacity: (12) in Problem Description File
        double tot_gaslift=0;
        tot_gaslift = 
            x[98]*(x[0]+x[1]+x[2]) + x[99]*(x[3]+x[4]+x[5])
            +x[100]*(x[6]+x[7]+x[8])+x[101]*(x[9]+x[10]+x[11])
            +x[102]*(x[12]+x[13]+x[14])+ x[103]*(x[15]+x[16]+x[17])
            +x[104]*(x[18]+x[19]) + x[105]*(x[20]+x[21])
            +x[106]*(x[22]+x[23]) + x[107]*(x[24]+x[25])
            +x[108]*(x[26]+x[27]) + x[109]*(x[28]+x[29])
            +x[110]*(x[30]+x[31]) + x[111]*(x[32]+x[33])
            +x[112]*(x[34]+x[35]) + x[113]*(x[36]+x[37]);
        
        myfile<<"Tot GasLift: "<<tot_gaslift<<endl;
        myfile<<endl;
        double tot_gas =0;
        tot_gas=x[50]*(x[0]+x[1]+x[2]) + x[51]*(x[3]+x[4]+x[5])
            +x[52]*(x[6]+x[7]+x[8]) + x[53]*(x[9]+x[10]+x[11])
            +x[54]*(x[12]+x[13]+x[14]) + x[55]*(x[15]+x[16]+x[17])
            +x[114]+x[115]+x[120]+x[121];
   
        myfile<<"Tot Gas: "<<tot_gas<<endl;
        myfile<<endl;
    //Water Production Capacity: (14) in Problem Description File
    double tot_WaterA=0;
    double tot_WaterB=0;
    double tot_WaterC=0;
    //Separator A
   
    tot_WaterA =    x[62]*x[0] + x[63]*x[3] + x[64]*x[6] + x[65]*x[9] + x[66]*x[12] + x[67]*x[15]
            +x[118]*x[38] + x[119]*x[41] + x[124]*x[44] + x[125]*x[47];
    myfile<<"Tot WaterA: "<<tot_WaterA<<endl;
    myfile<<endl;
    
    //Separator B
    tot_WaterB=    x[62]*x[1] + x[63]*x[4] + x[64]*x[7] + x[65]*x[10] + x[66]*x[13] + x[67]*x[16]
            +x[118]*x[39] + x[119]*x[42] + x[124]*x[45] + x[125]*x[48];
    myfile<<"Tot WaterB: "<<tot_WaterB<<endl;
    myfile<<endl;
    
    //Separator C
    tot_WaterC=    x[62]*x[2] + x[63]*x[5] + x[64]*x[8] + x[65]*x[11] + x[66]*x[14] + x[67]*x[17]
            +x[118]*x[40] + x[119]*x[43] + x[124]*x[46] + x[125]*x[49];
    myfile<<"Tot WaterC: "<<tot_WaterC<<endl;
    myfile<<endl;
        
        myfile<<endl;
        for (int i=0; i<I+J; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" GasLift: "<<x[98+i]<<endl;}
        
        myfile<<endl;
        for (int i=0; i<I+J; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Pressure: "<<x[126+i]<<endl;}
        
        myfile<<endl;
        for (int i=0; i<L; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Pressure Manifold: "<<x[142+i]<<endl;}
        
        myfile<<endl;
        for (int i=0; i<L; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Pressure Platform: "<<x[146+i]<<endl;}
        
        int t=1;
        myfile<<endl;
        for (int i=0; i<I*3; i++ ){
        myfile<<" Binary well topside "<<t<<": "<<x[i]<<" "<<x[i+1]<<" "<<x[i+2]<<endl;
        i=i+2;
        t++;
        
        }
        
        
        myfile<<endl;
        t=1;
        int s=18;
        int e=s+J*2;
        for (int i=s; i<e; i++ ){
        myfile<<" Binary well subsea "<<t<<": "<<x[i]<<" "<<x[i+1]<<endl;
        i=i+1;
        t++;
        }
        
        myfile<<endl;
        t=1;
        s=38;
        e=s+L*3;
        for (int i=s; i<e; i++ ){
        myfile<<" Binary well line "<<t<<": "<<x[i]<<" "<<x[i+1]<<" "<<x[i+2]<<endl;
        i=i+2;
        t++;
        }
        myfile<<endl;
        
        myfile<<"Gas line 1"<<": "<<x[114]<<endl;
        myfile<<"Gas line 2"<<": "<<x[115]<<endl;
        myfile<<"Gas line 3"<<": "<<x[120]<<endl;
        myfile<<"Gas line 4"<<": "<<x[121]<<endl;
        myfile<<endl;
        
        myfile.close();
}

//


minDist[It_nlp]= (1-WW)*((x[0]*x[0]+Parameter_f[0]*Parameter_f[0]-2*x[0]*Parameter_f[0])
                +(x[1]*x[1]+Parameter_f[1]*Parameter_f[1]-2*x[1]*Parameter_f[1])
                +(x[2]*x[2]+Parameter_f[2]*Parameter_f[2]-2*x[2]*Parameter_f[2])
                +(x[3]*x[3]+Parameter_f[3]*Parameter_f[3]-2*x[3]*Parameter_f[3])
                +(x[4]*x[4]+Parameter_f[4]*Parameter_f[4]-2*x[4]*Parameter_f[4])
                +(x[5]*x[5]+Parameter_f[5]*Parameter_f[5]-2*x[5]*Parameter_f[5])
                +(x[6]*x[6]+Parameter_f[6]*Parameter_f[6]-2*x[6]*Parameter_f[6])
                +(x[7]*x[7]+Parameter_f[7]*Parameter_f[7]-2*x[7]*Parameter_f[7])
                +(x[8]*x[8]+Parameter_f[8]*Parameter_f[8]-2*x[8]*Parameter_f[8])
                +(x[9]*x[9]+Parameter_f[9]*Parameter_f[9]-2*x[9]*Parameter_f[9])
                +(x[10]*x[10]+Parameter_f[10]*Parameter_f[10]-2*x[10]*Parameter_f[10])
                +(x[11]*x[11]+Parameter_f[11]*Parameter_f[11]-2*x[11]*Parameter_f[11])
                +(x[12]*x[12]+Parameter_f[12]*Parameter_f[12]-2*x[12]*Parameter_f[12])
                +(x[13]*x[13]+Parameter_f[13]*Parameter_f[13]-2*x[13]*Parameter_f[13])
                +(x[14]*x[14]+Parameter_f[14]*Parameter_f[14]-2*x[14]*Parameter_f[14])
                +(x[15]*x[15]+Parameter_f[15]*Parameter_f[15]-2*x[15]*Parameter_f[15])
                +(x[16]*x[16]+Parameter_f[16]*Parameter_f[16]-2*x[16]*Parameter_f[16])
                +(x[17]*x[17]+Parameter_f[17]*Parameter_f[17]-2*x[17]*Parameter_f[17])
                +(x[18]*x[18]+Parameter_f[18]*Parameter_f[18]-2*x[18]*Parameter_f[18])
                +(x[19]*x[19]+Parameter_f[19]*Parameter_f[19]-2*x[19]*Parameter_f[19])
                +(x[20]*x[20]+Parameter_f[20]*Parameter_f[20]-2*x[20]*Parameter_f[20])
                +(x[21]*x[21]+Parameter_f[21]*Parameter_f[21]-2*x[21]*Parameter_f[21])
                +(x[22]*x[22]+Parameter_f[22]*Parameter_f[22]-2*x[22]*Parameter_f[22])
                +(x[23]*x[23]+Parameter_f[23]*Parameter_f[23]-2*x[23]*Parameter_f[23])
                +(x[24]*x[24]+Parameter_f[24]*Parameter_f[24]-2*x[24]*Parameter_f[24])
                +(x[25]*x[25]+Parameter_f[25]*Parameter_f[25]-2*x[25]*Parameter_f[25])
                +(x[26]*x[26]+Parameter_f[26]*Parameter_f[26]-2*x[26]*Parameter_f[26])
                +(x[27]*x[27]+Parameter_f[27]*Parameter_f[27]-2*x[27]*Parameter_f[27])
                +(x[28]*x[28]+Parameter_f[28]*Parameter_f[28]-2*x[28]*Parameter_f[28])
                +(x[29]*x[29]+Parameter_f[29]*Parameter_f[29]-2*x[29]*Parameter_f[29])
                +(x[30]*x[30]+Parameter_f[30]*Parameter_f[30]-2*x[30]*Parameter_f[30])
                +(x[31]*x[31]+Parameter_f[31]*Parameter_f[31]-2*x[31]*Parameter_f[31])
                +(x[32]*x[32]+Parameter_f[32]*Parameter_f[32]-2*x[32]*Parameter_f[32])
                +(x[33]*x[33]+Parameter_f[33]*Parameter_f[33]-2*x[33]*Parameter_f[33])
                +(x[34]*x[34]+Parameter_f[34]*Parameter_f[34]-2*x[34]*Parameter_f[34])
                +(x[35]*x[35]+Parameter_f[35]*Parameter_f[35]-2*x[35]*Parameter_f[35])
                +(x[36]*x[36]+Parameter_f[36]*Parameter_f[36]-2*x[36]*Parameter_f[36])
                +(x[37]*x[37]+Parameter_f[37]*Parameter_f[37]-2*x[37]*Parameter_f[37])
                +(x[38]*x[38]+Parameter_f[38]*Parameter_f[38]-2*x[38]*Parameter_f[38])
                +(x[39]*x[39]+Parameter_f[39]*Parameter_f[39]-2*x[39]*Parameter_f[39])
                +(x[40]*x[40]+Parameter_f[40]*Parameter_f[40]-2*x[40]*Parameter_f[40])
                +(x[41]*x[41]+Parameter_f[41]*Parameter_f[41]-2*x[41]*Parameter_f[41])
                +(x[42]*x[42]+Parameter_f[42]*Parameter_f[42]-2*x[42]*Parameter_f[42])
                +(x[43]*x[43]+Parameter_f[43]*Parameter_f[43]-2*x[43]*Parameter_f[43])
                +(x[44]*x[44]+Parameter_f[44]*Parameter_f[44]-2*x[44]*Parameter_f[44])
                +(x[45]*x[45]+Parameter_f[45]*Parameter_f[45]-2*x[45]*Parameter_f[45])
                +(x[46]*x[46]+Parameter_f[46]*Parameter_f[46]-2*x[46]*Parameter_f[46])
                +(x[47]*x[47]+Parameter_f[47]*Parameter_f[47]-2*x[47]*Parameter_f[47])
                +(x[48]*x[48]+Parameter_f[48]*Parameter_f[48]-2*x[48]*Parameter_f[48])
                +(x[49]*x[49]+Parameter_f[49]*Parameter_f[49]-2*x[49]*Parameter_f[49]));
              
                maxOFV[It_nlp]= (WW/NND)*(x[56]*(x[0]+x[1]+x[2]))
                 +(WW/NND)*(x[57]*(x[3]+x[4]+x[5]))
                 +(WW/NND)*(x[58]*(x[6]+x[7]+x[8]))
                 +(WW/NND)*(x[59]*(x[9]+x[10]+x[11]))
                 +(WW/NND)*(x[60]*(x[12]+x[13]+x[14]))
                 +(WW/NND)*(x[61]*(x[15]+x[16]+x[17]))                
                 +(WW/NND)*(x[116]*(x[38]+x[39]+x[40])) 
                 +(WW/NND)*(x[117]*(x[41]+x[42]+x[43]))
                 +(WW/NND)*(x[122]*(x[44]+x[45]+x[46]))
                 +(WW/NND)*(x[123]*(x[47]+x[48]+x[49]));



ofstream mfile ("obj.txt");    
    
if (mfile.is_open()){  
     
            mfile<<"WW"<<WW<<endl;
            mfile<<"Parameter[0]"<<Parameter_f[0]<<endl;
            for(int i=0; i<MaxIt; i++){
            mfile<<endl;
            mfile<<" Minimizing distance "<<minDist[i]<<endl;
            mfile<<endl;
            mfile<<" Maximizing obj "<<maxOFV[i]<<endl;
            mfile<<endl;
            }

       mfile.close();
}


}


