// (C) Copyright Carnegie Mellon University 2006
// All Rights Reserved.
// This code is published under the Common Public License.
//
// Authors :
// P. Bonami, Carnegie Mellon University
//
// Date :  03/17/2006
#include "MyTMINLP.hpp"
#include "BonAmplInterface.hpp"
using namespace std;



void ProblemHeuristic1::save_nlp(const double* x) {
    for (int i=0; i<NB; i++){
     nlp[i]=x[i];   
    }
    
    
}

void ProblemHeuristic1::set_CapacityS (){
  CapacityS[0]=2200;
  CapacityS[1]=2000;
  CapacityS[2]=1800;
  
   for (int i=0; i<12; i++){
        sorted_PipeSep[i]=0;
    }
  
  for (int i=0; i<20; i++){
        sorted_WellPipe[i]=0;
    }
  
  for (int i=0; i<18; i++){
        sorted_WellSep[i]=0;
    }
  
  for (int i=0; i<NB; i++){
        roundedSol[i]=0;
    }
  
  for (int i=0; i<NB; i++){
        binary_evaluate[i]=true;
    }
  
  
}

void ProblemHeuristic1::evaluate_nlp() {
    int s=0;
    int e=0;
    int i1=0;
    int i2=0;
    
    
    //Lage sorteringstabellen
    s=0;
    e=18;
    i1=0;
    for (int i=s; i<e; i=i+3){
        sorted_WellSep[(PriorityManifold[i1]-1)*3]=nlp[i];
        sorted_WellSep[(PriorityManifold[i1]-1)*3+1]=nlp[i+1];
        sorted_WellSep[(PriorityManifold[i1]-1)*3+2]=nlp[i+2];
        i1++;
    }
    
    for(int i=0; i<18; i++){
     cout<<"sorted_WellSep["<<i<<"]: "<<sorted_WellSep[i]<<endl;
    }
    
    
    s=18;
    e=30;
    i1=6;
    for (int i=s; i<e; i=i+2){
        sorted_WellPipe[(PriorityManifold[i1]-1)*2]=nlp[i];
        sorted_WellPipe[(PriorityManifold[i1]-1)*2+1]=nlp[i+1];
        i1++;
    }
    
    for(int i=0; i<12; i++){
     cout<<"sorted_WellPipe["<<i<<"]: "<<sorted_WellPipe[i]<<endl;
    }
    
    
    i1=12;
    s=30;
    e=38;
    for (int i=s; i<e; i=i+2){
        sorted_WellPipe[(PriorityManifold[i1]-1)*2+2*J1]=nlp[i];
        sorted_WellPipe[(PriorityManifold[i1]-1)*2+1+2*J1]=nlp[i+1];
        i1++;
    }
    
    for(int i=12; i<20; i++){
     cout<<"sorted_WellPipe["<<i<<"]: "<<sorted_WellPipe[i]<<endl;
    }
    
    i1=0;
    s=38;
    e=NB;
    for (int i=s; i<e; i=i+3){
        sorted_PipeSep[(PriorityPipe[i1]-1)*3]=nlp[i];
        sorted_PipeSep[(PriorityPipe[i1]-1)*3+1]=nlp[i+1];
        sorted_PipeSep[(PriorityPipe[i1]-1)*3+2]=nlp[i+2];
        i1++;
    }
    
    
    for(int i=0; i<12; i++){
     cout<<"sorted_PipeSep["<<i<<"]: "<<sorted_PipeSep[i]<<endl;
    }
    
    for(int i=0; i<NB; i++){
     cout<<"nlp["<<i<<"]: "<<nlp[i]<<endl;   
    }
    
    
    //Lage compare tabellen
    for (int i=0; i<NB; i++){
     roundedSol[i]=0;   
    }
    
    //Finne ut om binary variables allerede er lst
    
    s=0;
    e=18;
    for (int i=s; i<e; i=i+3){
        if(sorted_WellSep[i]>=0.99){
          sorted_WellSep[i]=1;
          sorted_WellSep[i+1]=0;
          sorted_WellSep[i+2]=0;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_WellSep[i+1]>=0.99){
          sorted_WellSep[i]=0;
          sorted_WellSep[i+1]=1;
          sorted_WellSep[i+2]=0;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_WellSep[i+2]>=0.99){
          sorted_WellSep[i]=0;
          sorted_WellSep[i+1]=0;
          sorted_WellSep[i+2]=1;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_WellSep[i]<=0.01 && sorted_WellSep[i+1]<=0.01 && sorted_WellSep[i+2]<=0.01){
          sorted_WellSep[i]=0;
          sorted_WellSep[i+1]=0; 
          sorted_WellSep[i+2]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_WellSep[i]<=0.01 && sorted_WellSep[i+1]<=0.01){
          sorted_WellSep[i]=0; 
          sorted_WellSep[i+1]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = true;
        }
        else if(sorted_WellSep[i]<=0.01 && sorted_WellSep[i+2]<=0.01){
          sorted_WellSep[i]=0; 
          sorted_WellSep[i+2]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = true;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_WellSep[i+1]<=0.01 && sorted_WellSep[i+2]<=0.01){
          sorted_WellSep[i+1]=0; 
          sorted_WellSep[i+2]=0; 
          binary_evaluate[i] = true;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_WellSep[i]<=0.01){
          sorted_WellSep[i]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = true;
          binary_evaluate[i+2] = true;
        }
        else if(sorted_WellSep[i+1]<=0.01){
          sorted_WellSep[i+1]=0; 
          binary_evaluate[i] = true;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = true;
        }
        else if(sorted_WellSep[i+2]<=0.01){
          sorted_WellSep[i+2]=0; 
          binary_evaluate[i] = true;
          binary_evaluate[i+1] = true;
          binary_evaluate[i+2] = false;
        }
    
    else{
        binary_evaluate[i] = true;
        binary_evaluate[i+1] = true;
        binary_evaluate[i+2] = true;
    }
    }

    
    
    
    s=18;
    e=30;
    i1=0;
    for (int i=s; i<e; i=i+2){
        if(sorted_WellPipe[i1]>=0.99){
          sorted_WellPipe[i1]=1;
          sorted_WellPipe[i1+1]=0;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
        }
        else if(sorted_WellPipe[i1+1]>=0.99){
          sorted_WellPipe[i1]=0;  
          sorted_WellPipe[i1+1]=1;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
        }
        else if (sorted_WellPipe[i1]<=0.01){
         sorted_WellPipe[i1]=0;  
         binary_evaluate[i] = false;
         binary_evaluate[i+1] = true;}
        
        else if (sorted_WellPipe[i1+1]<=0.01){
         sorted_WellPipe[i1+1]=0;
         binary_evaluate[i] = true;
         binary_evaluate[i+1] = false;}
    else{
        binary_evaluate[i] = true;
        binary_evaluate[i+1] = true;}
    i1=i1+2;
    }
    
    
    s=30;
    e=38;
    i1=12;
    for (int i=s; i<e; i=i+2){
    if(sorted_WellPipe[i1]>=0.99){
          sorted_WellPipe[i1]=1;
          sorted_WellPipe[i1+1]=0;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
        }
        else if(sorted_WellPipe[i1+1]>=0.99){
          sorted_WellPipe[i1]=0;  
          sorted_WellPipe[i1+1]=1;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
        }
        else if (sorted_WellPipe[i1]<=0.01){
         sorted_WellPipe[i1]=0;  
         binary_evaluate[i] = false;
         binary_evaluate[i+1] = true;}
        
        else if (sorted_WellPipe[i1+1]<=0.01){
         sorted_WellPipe[i1+1]=0;
         binary_evaluate[i] = true;
         binary_evaluate[i+1] = false;}
    else{
        binary_evaluate[i] = true;
        binary_evaluate[i+1] = true;}
    i1=i1+2;
    }
    
    
    s=38;
    e=NB;
    i1=0;
    for (int i=s; i<NB; i=i+3){
        if(sorted_PipeSep[i1]>=0.99){
          sorted_PipeSep[i1]=1;
          sorted_PipeSep[i1+1]=0;
          sorted_PipeSep[i1+2]=0;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_PipeSep[i1+1]>=0.99){
          sorted_PipeSep[i1]=0;
          sorted_PipeSep[i1+1]=1;
          sorted_PipeSep[i1+2]=0;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_PipeSep[i1+2]>=0.99){
          sorted_PipeSep[i1]=0;
          sorted_PipeSep[i1+1]=0;
          sorted_PipeSep[i1+2]=1;
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_PipeSep[i1]<=0.01 && sorted_PipeSep[i1+1]<=0.01 && sorted_PipeSep[i1+2]<=0.01){
          sorted_PipeSep[i1]=0;
          sorted_PipeSep[i1+1]=0; 
          sorted_PipeSep[i1+2]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_PipeSep[i1]<=0.01 && sorted_PipeSep[i1+1]<=0.01){
          sorted_PipeSep[i1]=0; 
          sorted_PipeSep[i1+1]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = true;
        }
        else if(sorted_PipeSep[i1]<=0.01 && sorted_PipeSep[i1+2]<=0.01){
          sorted_PipeSep[i1]=0; 
          sorted_PipeSep[i1+2]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = true;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_PipeSep[i1+1]<=0.01 && sorted_PipeSep[i1+2]<=0.01){
          sorted_PipeSep[i1+1]=0; 
          sorted_PipeSep[i1+2]=0; 
          binary_evaluate[i] = true;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = false;
        }
        else if(sorted_PipeSep[i1]<=0.01){
          sorted_PipeSep[i1]=0; 
          binary_evaluate[i] = false;
          binary_evaluate[i+1] = true;
          binary_evaluate[i+2] = true;
        }
        else if(sorted_PipeSep[i1+1]<=0.01){
          sorted_PipeSep[i1+1]=0; 
          binary_evaluate[i] = true;
          binary_evaluate[i+1] = false;
          binary_evaluate[i+2] = true;
        }
        else if(sorted_PipeSep[i1+2]<=0.01){
          sorted_PipeSep[i1+2]=0; 
          binary_evaluate[i] = true;
          binary_evaluate[i+1] = true;
          binary_evaluate[i+2] = false;
        }
    
    else{
        binary_evaluate[i] = true;
        binary_evaluate[i+1] = true;
        binary_evaluate[i+2] = true;
    }
        i1=i1+3;
   }
    
    //Lagre all binary variables som allerede er lst i roundedSol;
//     for(int i=0; i<NB; i++){
//       if(binary_evaluate[i] == false){
//       roundedSol[i]=nlp[i];
//       }  
//     }
    
    
    //COMPARE ARRAY
    
    //Create compare array for Subsea Manifold 1
    s=18;
    e=30;
    i1=0;
    for(int i=s; i<e; i=i+2){
        if(binary_evaluate[i] == false){
            compareSM1[0][WellS1Priority[i1]]=sorted_WellPipe[i1];
        }
        else if(binary_evaluate[i] == true){
            compareSM1[0][WellS1Priority[i1]]=2;
        }
        if(binary_evaluate[i+1] == false){
            compareSM1[1][WellS1Priority[i1]]=sorted_WellPipe[i1];
        }
        else if(binary_evaluate[i+1] == true){
            compareSM1[1][WellS1Priority[i1]]=2;
        }
        i1++;
        
    }
    
    for (int i=0; i<6; i++){
         cout<<"compareSM1[0]["<<i<<"]: "<<compareSM1[0][i]<<endl;
         cout<<"compareSM1[1]["<<i<<"]: "<<compareSM1[1][i]<<endl;
        
    }
    
    //Create compare array for Subsea Manifold 2
    s=30;
    e=38;
    i1=6;
    i2=0;
    for(int i=s; i<e; i=i+2){
        if(binary_evaluate[i] == false){
            compareSM2[0][WellS2Priority[i2]]=sorted_WellPipe[i1];
        }
        else if(binary_evaluate[i] == true){
            compareSM2[0][WellS2Priority[i2]]=2;
        }
        if(binary_evaluate[i+1] == false){
            compareSM2[1][WellS2Priority[i2]]=sorted_WellPipe[i1];
        }
        else if(binary_evaluate[i+1] == true){
            compareSM2[1][WellS2Priority[i2]]=2;
        }
        i1++;
        
    }
    
    for (int i=0; i<4; i++){
         cout<<"compareSM2[0]["<<i<<"]: "<<compareSM2[0][i]<<endl;
         cout<<"compareSM2[1]["<<i<<"]: "<<compareSM2[1][i]<<endl;;
        
    }

 //Create compare array for Sunsea Pipelines
    s=38;
    e=NB;
    i1=0;
    for(int i=s; i<e; i=i+3){
        if(binary_evaluate[i] == false){
            compareS[0][PipePriority[i1]]=sorted_PipeSep[i1];
        }
        else if(binary_evaluate[i] == true){
            compareS[0][PipePriority[i1]]=2;
        }
        if(binary_evaluate[i+1] == false){
            compareS[1][PipePriority[i1]]=sorted_PipeSep[i1];
        }
        else if(binary_evaluate[i+1] == true){
            compareS[1][PipePriority[i1]]=2;
        }
        
        if(binary_evaluate[i+2] == false){
            compareS[2][PipePriority[i1]]=sorted_PipeSep[i1];
        }
        else if(binary_evaluate[i+2] == true){
            compareS[2][PipePriority[i1]]=2;
        }
       i1++; 
    }

    for (int i=0; i<4; i++){
         cout<<"compareS[0]["<<i<<"]: "<<compareS[0][i]<<endl;
         cout<<"compareS[1]["<<i<<"]: "<<compareS[1][i]<<endl;
         cout<<"compareS[2]["<<i<<"]: "<<compareS[2][i]<<endl;
    }
    
     //Create compare array for Topside Wells
    s=0;
    e=18;
    i1=0;
    for(int i=s; i<e; i=i+3){
        if(binary_evaluate[i] == false){
            compareW[0][WellSepPriority[i1]]=sorted_WellSep[i1];
        }
        else if(binary_evaluate[i] == true){
            compareW[0][WellSepPriority[i1]]=2;
        }
        if(binary_evaluate[i+1] == false){
            compareW[1][WellSepPriority[i1]]=sorted_WellSep[i1];
        }
        else if(binary_evaluate[i+1] == true){
            compareW[1][WellSepPriority[i1]]=2;
        }
        
        if(binary_evaluate[i+2] == false){
            compareW[2][WellSepPriority[i1]]=sorted_WellSep[i1];
        }
        else if(binary_evaluate[i+2] == true){
            compareW[2][WellSepPriority[i1]]=2;
        }
       i1++; 
    }

    
    for (int i=0; i<4; i++){
         cout<<"compareW[0]["<<i<<"]: "<<compareW[0][i]<<endl;
         cout<<"compareW[1]["<<i<<"]: "<<compareW[1][i]<<endl;
         cout<<"compareW[2]["<<i<<"]: "<<compareW[2][i]<<endl;
    }
    
    for(int i=0; i<NB;i++){
        
     cout<<"binary_evaluate["<<i<<"]: "<< binary_evaluate[i]<<endl;  
    }

}

void ProblemHeuristic1::process_nlp() {
    
    
    //Subsea Manifold 
    //Minst de 4 beste brnnene m produsere
    
    routing_wellPipe();
    
    
    
    //Subsea Pipelines
    //Disse m routes til noe, kan ikke skrus av
    routing_pipeSeparator();
    
    
    
    //Topside wells
    routing_wellSeparator();
    
    get_roundedSol();
    
}

void ProblemHeuristic1::get_roundedSol(){
    
    //Lage sorteringstabellen
    int s=0;
    int e=0;
    int i1=0;
    
    
    
    for(int i=0; i<18; i++){
     cout<<"sorted_WellSep["<<i<<"]: "<<sorted_WellSep[i]<<endl;
    }
    
    for(int i=0; i<12; i++){
     cout<<"sorted_WellPipe["<<i<<"]: "<<sorted_WellPipe[i]<<endl;
    }
    
   
    for(int i=12; i<20; i++){
     cout<<"sorted_WellPipe["<<i<<"]: "<<sorted_WellPipe[i]<<endl;
    }
    
    
    for(int i=0; i<12; i++){
     cout<<"sorted_PipeSep["<<i<<"]: "<<sorted_PipeSep[i]<<endl;
    }
    
    
    
    s=0;
    e=18;
    i1=0;
    for (int i=s; i<e; i=i+3){
        roundedSol[i]=sorted_WellSep[(PriorityManifold[i1]-1)*3];
        roundedSol[i+1]=sorted_WellSep[(PriorityManifold[i1]-1)*3+1];
        roundedSol[i+2]=sorted_WellSep[(PriorityManifold[i1]-1)*3+2];
        i1++;
    }
    
    
    s=18;
    e=30;
    i1=6;
    for (int i=s; i<e; i=i+2){
        roundedSol[i]=sorted_WellPipe[(PriorityManifold[i1]-1)*2];
        roundedSol[i+1]=sorted_WellPipe[(PriorityManifold[i1]-1)*2+1];
        i1++;
    }
    
    i1=12;
    s=30;
    e=38;
    for (int i=s; i<e; i=i+2){
        roundedSol[i]=sorted_WellPipe[(PriorityManifold[i1]-1)*2+J1*2];
        roundedSol[i+1]=sorted_WellPipe[(PriorityManifold[i1]-1)*2+1+J1*2];
        i1++;
    }
    
    i1=0;
    s=38;
    e=NB;
    for (int i=s; i<e; i=i+3){
        roundedSol[i]=sorted_PipeSep[(PriorityPipe[i1]-1)*3];
        roundedSol[i+1]=sorted_PipeSep[(PriorityPipe[i1]-1)*3+1];
        roundedSol[i+2]=sorted_PipeSep[(PriorityPipe[i1]-1)*3+2];
        i1++;
    }
    
    
}

void ProblemHeuristic1::routing_wellPipe(){
    
    
    int s=0;
    int e=0;
    int i1=0;
    int i2=0;
    
    
   
    //Manifold 1:
    //Sjekke hvordan brnnene 1-4 er lst. 
    //Hvis ikke mindre enn to av dem er lst til hver pipeline. Srge for at max to av hver er lst til samme pipeline. Noen spesiell sammensetning? Hvordan skal det avgjres? Alle lse 1+4 2+3
    
    
    double m = 0.5;
    
    s=18;
    e=30;
    i1=0;
    i2=0;
    for(int i=s; i<e; i=i+2){
     if(binary_evaluate[i]==true || binary_evaluate[i+1]==true){
        if(i1+1==1 || i1+1==2 || i1+1==3 || i1+1==4 || i1+1==5){
         
             if(sorted_WellPipe[i2]<=sorted_WellPipe[i2+1]){
                compareSM1[0][WellS1Priority[i1]]=0;
                compareSM1[1][WellS1Priority[i1]]=1;
                
                if(illigalSM1(1,compareSM1)==true){ 
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=1;
                }
                else if(binary_evaluate[i]==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
                compareSM1[1][WellS1Priority[i1]]=0;    
                }
                else if(illigalSM1(1, compareSM1)==false){
                sorted_WellPipe[i2]=1;
                sorted_WellPipe[i2+1]=0;
                compareSM1[1][WellS1Priority[i1]]=0;
                compareSM1[0][WellS1Priority[i1]]=1;
                }
                }
            else if(sorted_WellPipe[i2]>sorted_WellPipe[i2+1]){
                 
                compareSM1[0][WellS1Priority[i1]]=1;
                compareSM1[1][WellS1Priority[i1]]=0;
                
                
                if(illigalSM1(0,compareSM1)==true){ 
                sorted_WellPipe[i2]=1;
                sorted_WellPipe[i2+1]=0;
                }
                else if(binary_evaluate[i+1]==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
                compareSM1[1][WellS1Priority[i1]]=0;    
                }
                else if(illigalSM1(0,compareSM1)==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=1;
                compareSM1[1][WellS1Priority[i1]]=1;
                compareSM1[0][WellS1Priority[i1]]=0;
                }
            }
     }
         
         if( i1+1==6){
         if(sorted_WellPipe[i2]< m && sorted_WellPipe[i2+1] < m){
          sorted_WellPipe[i2]=0;
          sorted_WellPipe[i2+1]=0;
         }
         else if (sorted_WellPipe[i2] > m){
                compareSM1[0][WellS1Priority[i1]]=1;
                compareSM1[1][WellS1Priority[i1]]=0;
                
                if(illigalSM1(0,compareSM1)==true){ 
                sorted_WellPipe[i2]=1;
                sorted_WellPipe[i2+1]=0;
                }
                else if(illigalSM1(0,compareSM1)==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[1][WellS1Priority[i1]]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
                }
                }
         else if (sorted_WellPipe[i2] > m){
                compareSM1[0][WellS1Priority[i1]]=0;
                compareSM1[1][WellS1Priority[i1]]=1;
                
                if(illigalSM1(1,compareSM1)==true){ 
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=1;
                }
                else if(illigalSM1(1,compareSM1)==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[1][WellS1Priority[i1]]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
                }
                }
         else {
             
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[1][WellS1Priority[i1]]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
            }
         
         
     }
     }
    i1++;
    i2=i2+2;
    }

 
    
    //Manifold 2:
    //Sjekke om 13 og 15 er lst til samme pipeline.
        //1. Hvis lst til samme pipeline.. dumt
        //2. Hvis ikke lst til samme pipeline, lses til hver sin pipeline
    
    
    s=30;
    e=38;
    i1=0;
    i2=12;
    for(int i=s; i<e; i=i+2){
     if(binary_evaluate[i]==true || binary_evaluate[i+1]==true){
         if(i1+1!=1 && i1+1!=2 && i1+1!=3){
         if(sorted_WellPipe[i2]< m && sorted_WellPipe[i2+1] < m){
          sorted_WellPipe[i2]=0;
          sorted_WellPipe[i2+1]=0;
         }
         
         else if (sorted_WellPipe[i2] > m){
                compareSM2[0][WellS2Priority[i1]]=1;
                compareSM2[1][WellS2Priority[i1]]=0;
                
                if(illigalSM2(0,compareSM2)==true){ 
                sorted_WellPipe[i2]=1;
                sorted_WellPipe[i2+1]=0;
                }
                else if(illigalSM2(0,compareSM2)==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM2[1][WellS2Priority[i1]]=0;
                compareSM2[0][WellS2Priority[i1]]=0;
                }
                }
         else if (sorted_WellPipe[i2+1] > m){
                compareSM2[0][WellS2Priority[i1]]=0;
                compareSM2[1][WellS2Priority[i1]]=1;
                
                if(illigalSM2(1, compareSM2)==true){ 
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=1;
                }
                else if(illigalSM2(1, compareSM2)==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM2[1][WellS2Priority[i1]]=0;
                compareSM2[0][WellS2Priority[i1]]=0;
                }
                }
         
         }
         
         if(i1+1==1 || i1+1==2 || i1+1==3){
         
             if(sorted_WellPipe[i2]<=sorted_WellPipe[i2+1]){
                compareSM2[1][WellS2Priority[i1]]=1;
                compareSM2[0][WellS2Priority[i1]]=0;
          
                if(illigalSM2(1,compareSM2)==true){ 
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=1;
                }
                else if(binary_evaluate[i+1]==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
                compareSM1[1][WellS1Priority[i1]]=0;    
                }
                else if(illigalSM2(1,compareSM2)==false){
                sorted_WellPipe[i2]=1;
                sorted_WellPipe[i2+1]=0;
                compareSM2[1][WellS2Priority[i1]]=0;
                compareSM2[0][WellS2Priority[i1]]=1;
                }
                }
            else if(sorted_WellPipe[i2]>sorted_WellPipe[i2+1]){
                compareSM2[1][WellS2Priority[i1]]=0;
                compareSM2[0][WellS2Priority[i1]]=1;
                                
                if(illigalSM2(0,compareSM2)==true){ 
                sorted_WellPipe[i2]=1;
                sorted_WellPipe[i2+1]=0;
                }
                else if(binary_evaluate[i+1]==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=0;
                compareSM1[0][WellS1Priority[i1]]=0;
                compareSM1[1][WellS1Priority[i1]]=0;    
                }
                else if(illigalSM2(0, compareSM2)==false){
                sorted_WellPipe[i2]=0;
                sorted_WellPipe[i2+1]=1;
                compareSM2[1][WellS2Priority[i1]]=1;
                compareSM2[0][WellS2Priority[i1]]=0;
                }
            }
     }
     }
     
    i1++;
    i2=i2+2;
}
}

void ProblemHeuristic1::routing_pipeSeparator(){
    //Avhengig av kapasitetene p separatorene
    //Avhengig av lste topsidebrnner
    
    //Sjekke hvor mange topsidebrnner some er lst p hver av dem og hviken prioritering de har

    int s=0;
    int e=0;
    int i1=0;
    int i2=0;
    
    s=38;
    e=NB;   
    i1=0;
    i2=0;
    
    for(int i=s; i<e; i=i+3){
     if(binary_evaluate[i]==true || binary_evaluate[i+1]==true || binary_evaluate[i+2]==true){
        
         if(i1+1==1 || i1+1==2){
             if(sorted_PipeSep[i2]>=sorted_PipeSep[i2+1] && sorted_PipeSep[i2]>=sorted_PipeSep[i2+2]){
                compareS[0][PipePriority[i1]]=1;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=0;
          
                if(illigalS(0,compareS)==true){ 
                sorted_PipeSep[i2]=1;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=0;
                            }
                else if(illigalS(0,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=1;
                compareS[2][PipePriority[i1]]=0;
                
                if(illigalS(1,compareS)==true){ 
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=1;
                sorted_PipeSep[i2+2]=0;
                             }
                else if(illigalS(1,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=1;
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=1;
               }
 } } 
             
             if(sorted_PipeSep[i2+1]>=sorted_PipeSep[i2] && sorted_PipeSep[i2+1]>=sorted_PipeSep[i2+2]){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=1;
                compareS[2][PipePriority[i1]]=0;
          
                if(illigalS(1,compareS)==true){ 
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=1;
                sorted_PipeSep[i2+2]=0;
            
                }
                else if(illigalS(1,compareS)==false){
                compareS[0][PipePriority[i1]]=1;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=0;
                
                if(illigalS(0,compareS)==true){ 
                sorted_PipeSep[i2]=1;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=0;
       
                }
                else if(illigalS(0,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=1;
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=1;
               }
 } }
             
             
             if(sorted_PipeSep[i2+2]>=sorted_PipeSep[i2] && sorted_PipeSep[i2+2]>=sorted_PipeSep[i2+1]){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=1;
          
                if(illigalS(2,compareS)==true){ 
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=1;
                }
                else if(illigalS(2,compareS)==false){
                compareS[0][PipePriority[i1]]=1;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=0;
                
                if(illigalS(0,compareS)==true){ 
                sorted_PipeSep[i2]=1;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=0;
                }
                else if(illigalS(0,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=1;
                compareS[2][PipePriority[i1]]=0;
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=1;
                sorted_PipeSep[i2+2]=0;
               }
 } }
             
         
         } 
         
              
             if(i1+1==3 || i1+1==4){
             if(sorted_PipeSep[i2]>=sorted_PipeSep[i2+1] && sorted_PipeSep[i2]>=sorted_PipeSep[i2+2]){
                compareS[0][PipePriority[i1]]=1;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=0;
          
                if(illigalS(0,compareS)==true){ 
                sorted_PipeSep[i2]=1;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=0;
                }
                else if(illigalS(0,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=1;
                compareS[2][PipePriority[i1]]=0;
                
                if(illigalS(1,compareS)==true){ 
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=1;
                sorted_PipeSep[i2+2]=0;
                }
                else if(illigalS(1,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=1;
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=1;
               }
 } } 
             
             if(sorted_PipeSep[i2+1]>=sorted_PipeSep[i2] && sorted_PipeSep[i2+1]>=sorted_PipeSep[i2+2]){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=1;
                compareS[2][PipePriority[i1]]=0;
          
                if(illigalS(1,compareS)==true){ 
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=1;
                sorted_PipeSep[i2+2]=0;
                }
                else if(illigalS(1,compareS)==false){
                compareS[0][PipePriority[i1]]=1;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=0;
                
                if(illigalS(0,compareS)==true){ 
                sorted_PipeSep[i2]=1;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=0;
                }
                else if(illigalS(0,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=1;
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=1;
               }
 } }
             
             
             if(sorted_PipeSep[i2+2]>=sorted_PipeSep[i2] && sorted_PipeSep[i2+2]>=sorted_PipeSep[i2+1]){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=1;
          
                if(illigalS(2,compareS)==true){ 
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=1;
                }
                else if(illigalS(2,compareS)==false){
                compareS[0][PipePriority[i1]]=1;
                compareS[1][PipePriority[i1]]=0;
                compareS[2][PipePriority[i1]]=0;
                
                if(illigalS(0,compareS)==true){ 
                sorted_PipeSep[i2]=1;
                sorted_PipeSep[i2+1]=0;
                sorted_PipeSep[i2+2]=0;
                }
                else if(illigalS(0,compareS)==false){
                compareS[0][PipePriority[i1]]=0;
                compareS[1][PipePriority[i1]]=1;
                compareS[2][PipePriority[i1]]=0;
                sorted_PipeSep[i2]=0;
                sorted_PipeSep[i2+1]=1;
                sorted_PipeSep[i2+2]=0;
               }
 } }
             
         
         } }
     
    i1++;
    i2=i2+3;
     }
               
     
}
    

void ProblemHeuristic1::routing_wellSeparator(){
    //Avhengig av kapasitetne p sepratorene
    //Avhengig av pipelines
    
    //Topside Wells
    //Minst de 4 beste topside wellsene m vre p
    int s=0;
    int e=0;
    int i1=0;
    int i2=0;
    double m=0;
    
    i1=0;
    i2=0;
    s=0;
    e=18;
    for(int i=s; i<e; i=i+3){
     if(binary_evaluate[i]==true || binary_evaluate[i+1]==true || binary_evaluate[i+2]==true){
     if(i1+1<=6){
           if(sorted_WellSep[i2]>=sorted_WellSep[i2+1] && sorted_WellSep[i2]>=sorted_WellSep[i2+2]){
                compareW[0][WellSepPriority[i1]]=1;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                //cout<<"1: "<<"Priority: "<<i1<<endl;
          
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=1;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;
                //cout<<"2: "<<"Priority: "<<i1<<endl;
                            }
                else if(illigalW(0,compareS,compareW)==false){
                if(binary_evaluate[i+1]==true){ 
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=1;
                compareW[2][WellSepPriority[i1]]=0;}
                //cout<<"3: "<<"Priority: "<<i1<<endl;
                
                if(illigalW(1,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=1;
                sorted_WellSep[i2+2]=0;
                //cout<<"4: "<<"Priority: "<<i1<<endl;
                             }
                else if(illigalW(1,compareS,compareW)==false){
                if(binary_evaluate[i+2]==true){ 
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=1;}
                if(illigalW(1,compareS,compareW)==true){
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=1;}
                else{
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;                     
                }
                //cout<<"5: "<<"Priority: "<<i1<<endl;
               }
            } } 
             
           else if(sorted_WellSep[i2+1]>=sorted_WellSep[i2] && sorted_WellSep[i2+1]>=sorted_WellSep[i2+2]){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=1;
                compareW[2][WellSepPriority[i1]]=0;
                //cout<<"5: "<<"Priority: "<<i1<<endl;
          
                if(illigalW(1,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=1;
                sorted_WellSep[i2+2]=0;
                //cout<<"6: "<<"Priority: "<<i1<<endl;
            
                }
                else if(illigalW(1,compareS,compareW)==false){
                if(binary_evaluate[i]==true){ 
                compareW[0][WellSepPriority[i1]]=1;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;}
                //cout<<"7: "<<"Priority: "<<i1<<endl;
                
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=1;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;
                //cout<<"8: "<<"Priority: "<<i1<<endl;
       
                }
                else if(illigalW(0,compareS,compareW)==false){
                if(binary_evaluate[i+2]==true){ 
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=1;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=1;}
                else {
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;    
                                      
                }
                //cout<<"9: "<<"Priority: "<<i1<<endl;
               }
 } }
             
             
           else if(sorted_WellSep[i2+2]>=sorted_WellSep[i2] && sorted_WellSep[i2+2]>=sorted_WellSep[i2+1]){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=1;
                //cout<<"10: "<<"Priority: "<<i1<<endl;
          
                if(illigalW(2,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=1;
                //cout<<"11: "<<"Priority: "<<i1<<endl;
                }
                else if(illigalW(2,compareS,compareW)==false){
                if(binary_evaluate[i]==true){ 
                compareW[0][WellSepPriority[i1]]=1;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;}
                //cout<<"12: "<<"Priority: "<<i1<<endl;
                
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=1;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;
                //cout<<"13: "<<"Priority: "<<i1<<endl;
                }
                else if(illigalW(0,compareS,compareW)==false){
                if(binary_evaluate[i+1]==true){ 
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=1;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=1;
                sorted_WellSep[i2+2]=0;}
                else{
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;}   
                //cout<<"14: "<<"Priority: "<<i1<<endl;
               }
 } }
             
         
         } 
     if(i1+1>5){
           if(sorted_WellSep[i2]>=sorted_WellSep[i2+1] && sorted_WellSep[i2]>=sorted_WellSep[i2+2]){
                compareW[0][WellSepPriority[i1]]=1;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                cout<<"1: "<<"Priority: "<<i1<<endl;
          
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=1;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;
                cout<<"2: "<<"Priority: "<<i1<<endl;
                            }
                else if(illigalW(0,compareS,compareW)==false){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=1;
                compareW[2][WellSepPriority[i1]]=0;
                cout<<"3: "<<"Priority: "<<i1<<endl;
                
                if(illigalW(1,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=1;
                sorted_WellSep[i2+2]=0;
                cout<<"4: "<<"Priority: "<<i1<<endl;
                             }
                else if(illigalW(1,compareS,compareW)==false){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=1;
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=1;
                cout<<"13: "<<"Priority: "<<i1<<endl;
                }
                else{
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;}
                cout<<"5: "<<"Priority: "<<i1<<endl;
               }
 } } 
             
           else if(sorted_WellSep[i2+1]>=sorted_WellSep[i2] && sorted_WellSep[i2+1]>=sorted_WellSep[i2+2]){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=1;
                compareW[2][WellSepPriority[i1]]=0;
                //cout<<"5: "<<"Priority: "<<i1<<endl;
          
                if(illigalW(1,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=1;
                sorted_WellSep[i2+2]=0;
                //cout<<"6: "<<"Priority: "<<i1<<endl;
            
                }
                else if(illigalW(1,compareS,compareW)==false){
                compareW[0][WellSepPriority[i1]]=1;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                //cout<<"7: "<<"Priority: "<<i1<<endl;
                
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=1;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;
                //cout<<"8: "<<"Priority: "<<i1<<endl;
       
                }
                else if(illigalW(0,compareS,compareW)==false){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=1;
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=1;
                //cout<<"13: "<<"Priority: "<<i1<<endl;
                }
                else{
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;}
                //cout<<"14: "<<"Priority: "<<i1<<endl;
                              }
 } }
             
             
           else if(sorted_WellSep[i2+2]>=sorted_WellSep[i2] && sorted_WellSep[i2+2]>=sorted_WellSep[i2+1]){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=1;
                //cout<<"10: "<<"Priority: "<<i1<<endl;
          
                if(illigalW(2,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=1;
                //cout<<"11: "<<"Priority: "<<i1<<endl;
                }
                else if(illigalW(2,compareS,compareW)==false){
                compareW[0][WellSepPriority[i1]]=1;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                //cout<<"12: "<<"Priority: "<<i1<<endl;
                
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=1;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;
                //cout<<"13: "<<"Priority: "<<i1<<endl;
                }
                else if(illigalW(0,compareS,compareW)==false){
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=1;
                compareW[2][WellSepPriority[i1]]=0;
                
                if(illigalW(0,compareS,compareW)==true){ 
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=1;
                sorted_WellSep[i2+2]=0;
                //cout<<"13: "<<"Priority: "<<i1<<endl;
                }
                else{
                compareW[0][WellSepPriority[i1]]=0;
                compareW[1][WellSepPriority[i1]]=0;
                compareW[2][WellSepPriority[i1]]=0;
                sorted_WellSep[i2]=0;
                sorted_WellSep[i2+1]=0;
                sorted_WellSep[i2+2]=0;}
                //cout<<"14: "<<"Priority: "<<i1<<endl;
               }
 } }
             
         
         } 
     }
    i1++;
    i2=i2+3;
     }
}

void ProblemHeuristic1::priorityWells (){
    //Lager en prioriteringsliste av brnnene
    PriorityManifold[0]=3;
    PriorityManifold[1]=1;
    PriorityManifold[2]=6;
    PriorityManifold[3]=5;
    PriorityManifold[4]=2;
    PriorityManifold[5]=4;
    
    PriorityManifold[6]=3;
    PriorityManifold[7]=6;
    PriorityManifold[8]=5;
    PriorityManifold[9]=1;
    PriorityManifold[10]=4;
    PriorityManifold[11]=2;
    
    PriorityManifold[12]=2;
    PriorityManifold[13]=3;
    PriorityManifold[14]=1;
    PriorityManifold[15]=4;
    
    WellSepPriority[0]=1;
    WellSepPriority[1]=4;
    WellSepPriority[2]=0;
    WellSepPriority[3]=5;
    WellSepPriority[4]=3;
    WellSepPriority[5]=2;
    
    WellS1Priority[0]=3;
    WellS1Priority[1]=5;
    WellS1Priority[2]=0;
    WellS1Priority[3]=4;
    WellS1Priority[4]=2;
    WellS1Priority[5]=1;
    
    WellS2Priority[0]=2;
    WellS2Priority[1]=0;
    WellS2Priority[2]=1;
    WellS2Priority[3]=3;
    
    PriorityTotal[0]=11;
    PriorityTotal[1]=7;
    PriorityTotal[2]=14;
    PriorityTotal[3]=13;
    PriorityTotal[4]=9;
    PriorityTotal[5]=12;
            
    PriorityTotal[6]=5;
    PriorityTotal[7]=16;
    PriorityTotal[8]=8;
    PriorityTotal[9]=2;
    PriorityTotal[10]=6;
    PriorityTotal[11]=4;
            
    PriorityTotal[12]=3;
    PriorityTotal[13]=10;
    PriorityTotal[14]=1;
    PriorityTotal[15]=15;
    
    PriorityPipe[0]=1;
    PriorityPipe[1]=3;
    PriorityPipe[2]=2;
    PriorityPipe[3]=4;
    
    PipePriority[0]=0;
    PipePriority[1]=2;
    PipePriority[2]=1;
    PipePriority[3]=3;
}

bool ProblemHeuristic1::illigalSM1(int l,double j[L1][J1]){
    //Brnn nummer m gis inn i stigende rekkeflge
    
    //Pipeline 1
    if(l==0){
    if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][3]==1 && j[0][4]==1 && j[0][5]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][3]==1 && j[0][4]== 1){
     return false;   
    }
    
    else if (j[0][1]==1 && j[0][2]==1 && j[0][3]==1 && j[0][4]==1 && j[0][5]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][2]==1 && j[0][3]==1 && j[0][4]==1 && j[0][5]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][1]==1 && j[0][3]==1 && j[0][4]==1 && j[0][5]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][4]==1 && j[0][5]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][3]==1 && j[0][5]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][3]==1 && j[0][4]==1){
     return false;   
    }
    
    else if (j[0][0]==1 && j[0][3]==1 && j[0][4]==1 && j[0][5]==1){
     return false;   
    }}
    
    
    
    //Pipeline 2
    if(l==1){
    if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][3]==1 && j[1][4]==1 && j[1][5]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][3]==1 && j[1][4]==1 ){
     return false;   
    }
    
    else if (j[1][1]==1 && j[1][2]==1 && j[1][3]==1 && j[1][4]==1 && j[1][5]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][2]==1 && j[1][3]==1 && j[1][4]==1 && j[1][5]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][1]==1 && j[1][3]==1 && j[1][4]==1 && j[1][5]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][4]==1 && j[1][5]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][3]==1 && j[1][5]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][3]==1 && j[1][4]==1){
     return false;   
    }
    
    else if (j[1][0]==1 && j[1][3]==1 && j[1][4]==1 && j[1][5]==1){
     return false;   
    }}
    
    return true;
   
}

bool ProblemHeuristic1::illigalSM2(int l,double j[L2][J2]){
    //Brnn nummer m gis inn i stigende rekkeflge
  
    if (l==0){
    if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][3]==1){
     return false;   
    }
    else if(j[0][0]==1 && j[0][2]==1){
     return false;   
    }}
    
    if(l==1){
    if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][3]==1){
     return false;   
    }
    else if(j[1][0]==1 && j[1][2]==1){
     return false;   
    }}
    
    
     return true;   
    
   
}

bool ProblemHeuristic1::illigalS(int s, double j[S][L]){
    
    //Separator 1
    if(s==0){
    if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 && j[0][3]==1){
     return false;   
    } 
    else if (j[0][0]==1 && j[0][1]==1 && j[0][2]==1 ){
     return false;   
    }
    else if (j[0][0]==1 && j[0][1]==1 && j[0][3]==1 ){
     return false;   
    }
    
     else if (j[0][0]==1 && j[0][2]==1 && j[0][3]==1 ){
     return false;   
    }
    else if (j[0][1]==1 && j[0][2]==1 && j[0][3]==1 ){
     return false;   
    }
   }
    
    //Separator 2
    if(s==1){
    if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 && j[1][3]==1){
     return false;   
    } 
    
    else if (j[1][0]==1 && j[1][1]==1 && j[1][2]==1 ){
     return false;   
    }
     else if (j[1][0]==1 && j[1][1]==1 && j[1][3]==1 ){
     return false;   
    }
    else if (j[1][0]==1 && j[1][2]==1 && j[1][3]==1 ){
     return false;   
    }
    else if (j[1][1]==1 && j[1][2]==1 && j[1][3]==1 ){
     return false;   
    }
    }
    
    //Separator 3
    if(s==2){
    if (j[2][0]==1 && j[2][1]==1 && j[2][2]==1 ){
     return false;   
    }
    
    else if (j[2][0]==1 && j[2][1]==1 && j[2][2]==1 && j[2][3]==1){
     return false;   
    }
    else if (j[2][0]==1 && j[2][1]==1 && j[2][3]==1 ){
     return false;   
    } 
    else if (j[2][0]==1 && j[2][2]==1 && j[2][3]==1 ){
     return false;
    }
    else if (j[2][1]==1 && j[2][2]==1 && j[2][3]==1 ){
     return false;
    }
   }
     
    return true;
    
    }

bool ProblemHeuristic1::illigalW(int s, double j[S][L], double k[S][I]){


double sumSep=0;
double sum1=0;
double sum2=0;

 for(int i=0; i<L; i++){
   if(j[s][i]<2){ 
   sum1=sum1+j[s][i];
   }
 }

for(int i=0; i<I; i++){
   if(k[s][i]<2){ 
   sum2=sum2+k[s][i];
   }
 }
     
 //sumSep=j[s][0]+j[s][1]+j[s][2]+j[s][3]+k[s][0]+k[s][1]+k[s][2]+k[s][3]+k[s][4]+k[s][5];
 
sumSep=sum1+sum2;

 cout<<"SumSep: "<<sumSep<<endl;
     
 if (sumSep>=4){
     return false;   
    }   
 
 return true;   
}


void ProblemHeuristic1::print_solValues(){ 

ofstream myfile ("ProblemHeuristic.txt");    
    
if (myfile.is_open()){   
    
   
        int t=1;
        myfile<<endl;
        for (int i=0; i<I*3; i++ ){
        myfile<<" Binary well topside "<<t<<": "<<roundedSol[i]<<" "<<roundedSol[i+1]<<" "<<roundedSol[i+2]<<endl;
       
        i=i+2;
        t++;
        }
        
        
        myfile<<endl;
        t=1;
        int s=18;
        int e=s+J*2;
        for (int i=s; i<e; i++ ){
        myfile<<" Binary well subsea "<<t<<": "<<roundedSol[i]<<" "<<roundedSol[i+1]<<endl;
       i=i+1;
        t++;
        }
        
        myfile<<endl;
        t=1;
        s=38;
        e=s+L*3;
        for (int i=s; i<e; i++ ){
        myfile<<" Binary well line "<<t<<": "<<roundedSol[i]<<" "<<roundedSol[i+1]<<" "<<roundedSol[i+2]<<endl;
       
        i=i+2;
        t++;
        }
        myfile<<endl;
        
        
       t=1;
        myfile<<endl;
        for (int i=0; i<I*3; i++ ){
        myfile<<" Continous well topside "<<t<<": "<<nlp[i]<<" "<<nlp[i+1]<<" "<<nlp[i+2]<<endl;
        
        i=i+2;
        t++;
        }
        
        
        myfile<<endl;
        t=1;
        s=18;
        e=s+J*2;
        for (int i=s; i<e; i++ ){
        myfile<<" Continous well subsea "<<t<<": "<<nlp[i]<<" "<<nlp[i+1]<<endl;
        i=i+1;
        t++;
        }
        
        myfile<<endl;
        t=1;
        s=38;
        e=s+L*3;
        for (int i=s; i<e; i++ ){
        myfile<<" Continous well line "<<t<<": "<<nlp[i]<<" "<<nlp[i+1]<<" "<<nlp[i+2]<<endl;
        
        i=i+2;
        t++;
        }
        myfile<<endl;
        myfile.close();
}
}