// (C) Copyright Carnegie Mellon University 2006
// All Rights Reserved.
// This code is published under the Common Public License.
//
// Authors :
// P. Bonami, Carnegie Mellon University
//
// Date :  03/17/2006
#include "MyTMINLP.hpp"
#include "BonAmplInterface.hpp"
using namespace std;

void Feasibility_Pump::init_Parameters(){
int s=0;
int e=0;

s=0;
e=I+J;
for(int i=s; i<e; i++){
    FParameter_f[i]=0;}
for(int i=0; i<MaxIt; i++){

          for(int j=0; j<I; j++){
           Jac_w [j][0][i]=0;
           Jac_w [j][1][i]=0;
           
           sol_w [j][0][i]=2000;
           sol_w [j][1][i]=0;  
           sol_w [j][2][i]=0;
           }
           
           for(int j=0; j<J1; j++){
           Jac_w [j+I][0][i]=0;
           Jac_w [j+I][1][i]=0;
           
           sol_w [j+I][0][i]=2000;
           sol_w [j+I][1][i]=0;  
           sol_w [j+I][2][i]=0;
           }
           
           for(int j=0; j<J2; j++){
           Jac_w [j+I+J1][0][i]=0;
           Jac_w [j+I+J1][1][i]=0;
           
           sol_w [j+I+J1][0][i]=2000;
           sol_w [j+I+J1][1][i]=0;  
           sol_w [j+I+J1][2][i]=0;
           }
           
           
           for(int j=0; j<L1; j++){
           Jac_p [j][0][i]=0;
           Jac_p [j][1][i]=0;
           Jac_p [j][2][i]=0;
           
           sol_p [j][0][i]=0;
           sol_p [j][1][i]=0;
           sol_p [j][2][i]=0;
           sol_p [j][3][i]=0;
           }
           
           for(int j=L1; j<L; j++){
           Jac_p [j][0][i]=0;
           Jac_p [j][1][i]=0;
           Jac_p [j][2][i]=0;
           
           sol_p [j][0][i]=0;
           sol_p [j][1][i]=0;
           sol_p [j][2][i]=0;
           sol_p [j][3][i]=0;
           }
  }
}

void Feasibility_Pump::save_sol_milp(const double* adr){
    for(int i=0; i<150; i++){
        sol_milp[i]=adr[i];
        //cout<<"sol_milp["<<i<<"]: "<<adr[i]<<endl;
    }

}

void Feasibility_Pump::save_best_minlp(){
        for(int i=0; i<NB; i++){
        minlp[i]=sol_milp[i];
    }
//          for(int i=0; i<NB; i++){
//         cout<<"minlp["<<i<<"]: "<<minlp[i]<<endl;}
}


void Feasibility_Pump::save_sol_nlp(int It,const double* adr){
        
    for (int i=0; i<150; i++){
        temp_sol[i]=adr[i];
    }
    for (int i=0; i<50; i++){
        FParameter_f[i]=temp_sol[i];
        //cout<<"FParameter_f["<<i<<"]: "<<FParameter_f[i]<<endl;
    }
    
           for(int j=0; j<I; j++){
           
           sol_w [j][0][It]=temp_sol[56+j];
           //cout<<"sol_w ["<<j<<"][0]["<<It<<"]: "<<sol_w [j][0][It]<<endl;
           sol_w [j][1][It]=temp_sol[126+j]; 
           //cout<<"sol_w [j][1][It]: "<<"j: "<<j<<" i: "<<It<<" "<<sol_w [j][1][It]<<endl;
           sol_w [j][2][It]=temp_sol[98+j];
           //cout<<"sol_w [j][2][It]: "<<sol_w [j][2][It]<<endl;
           }
           
           for(int j=0; j<J1; j++){
           
           sol_w [j+I][0][It]=temp_sol[74+j];
           //cout<<"sol_w [j+I][0][It] "<<sol_w [j+I][0][It]<<endl;
           sol_w [j+I][1][It]=temp_sol[132+j]; 
           //cout<<"sol_w [j+I][1][It] "<<sol_w [j+I][1][It]<<endl;
           sol_w [j+I][2][It]=temp_sol[104+j];
           //cout<<"sol_w [j+I][2][It] "<<sol_w [j+I][2][It]<<endl;
           }
           
           int i1 = 0;
           for(int j=0; j<J2; j++){
           sol_w [j+I+J1][0][It]=temp_sol[90+i1];
           //cout<<"sol_w [j+I+J1][0][It] "<<sol_w [j+I+J1][0][It]<<endl;
           sol_w [j+I+J1][1][It]=temp_sol[138+i1];
           //cout<<"sol_w [j+I+J1][1][It] "<<sol_w [j+I+J1][1][It]<<endl;
           sol_w [j+I+J1][2][It]=temp_sol[110+i1];
           //cout<<"sol_w [j+I+J1][22[It] "<<sol_w [j+I+J1][2][It]<<endl;
           i1++;
           }
           
           i1 = 0;
           for(int j=0; j<L1; j++){
           sol_p [j][0][It]=temp_sol[116+i1];
           //cout<<"sol_p [j][0][It] "<<sol_p [j][0][It]<<endl;
           sol_p [j][1][It]=temp_sol[114+i1];
           //cout<<"sol_p [j][1][It] "<<sol_p [j][1][It]<<endl;
           sol_p [j][2][It]=temp_sol[118+i1];
           //cout<<"sol_p [j][2][It] "<<sol_p [j][2][It]<<endl;
           sol_p [j][3][It]=temp_sol[142+i1]-temp_sol[146+i1];
           //cout<<"sol_p [j][3][It] "<<sol_p [j][3][It]<<endl;
           i1++;
           }
           
           i1 = 0;
           for(int j=L1; j<L; j++){
           
           sol_p [j][0][It]=temp_sol[122+i1];
           //cout<<"sol_p [j][0][It] "<<sol_p [j][0][It]<<endl;
           sol_p [j][1][It]=temp_sol[120+i1];
           //cout<<"sol_p [j][1][It] "<<sol_p [j][1][It]<<endl;
           sol_p [j][2][It]=temp_sol[124+i1];
           //cout<<"sol_p [j][2][It] "<<sol_p [j][2][It]<<endl;
           sol_p [j][3][It]=temp_sol[144+i1]-temp_sol[148+i1];
           //cout<<"sol_p [j][3][It] "<<sol_p [j][3][It]<<endl;
           i1++;
           }
}



bool Feasibility_Pump::test_int_feasibility(const double* adr) {
    int i1=0;
    
    for (int i=0; i<NB; i++){ 
    if(adr[i]>=0.98 || adr[i]<=0.01){
        i1++;}
    } 
   
    if(i1==50){
    return true;
    }
    else{
        return false;
    }
}


bool Feasibility_Pump::test_feasibility(){
    
    int i=0;
    double g[NV];
    
    
    SmartPtr<MyTMILP> tminlp = new MyTMILP;
     tminlp->readWells();
     tminlp->readPipes();
     tminlp->readminmax_gl();
     tminlp->readminmax_p();
 
   
     //-------------------------TOPSIDE WELLS-----------------------------
        
    //Topside Well Models: (2) a-b-c in Problem Description File
    int k=50;   //q^WI_ip
    int i1=48;  //q^GL_i
    int i2=76;  //p^WI_i
    int s=0;
    int e=I;
        //printf("(2) Platform Flowrate Constraints \n");
        //printf("%-5s %-15s %-15s %-15s \n", "Well", "Gas", "Oil", "Water");
    for(int j = s; j < e ; j++){
        double *psim = tminlp->ratesim(j,0, sol_milp[k+i2], sol_milp[k+i1], tminlp->parrptr[j]);
        //cout <<"Her"<<endl;
        g[i] = sol_milp[k] - (tminlp->wellspecI[j][1]*sol_milp[k+I] + sol_milp[k+i1]);                        //2b - gas
        g[i+I] = sol_milp[k+I] - psim[0];                                               //2a - oil
            //cout<<"Oil["<<j+1<<"]="<<sol_milp[k+I]<<endl;
            //cout<<"Gas["<<j+1<<"]="<<sol_milp[k]<<endl;
            //cout<<"Gas["<<j+1<<"]="<<sol_milp[k]<<endl;
            //cout<<"Water["<<j+1<<"]="<<sol_milp[k+2*I]<<endl;
            //cout<<"  PSIM="<<psim[0]<<endl;
        g[i+2*I] = sol_milp[k+2*I] - (sol_milp[k+I]*(tminlp->wellspecI[j][0]/(1-tminlp->wellspecI[j][0])));    //2c - water
        
        //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+I, g[i+I], i+2*I, g[i+2*I]);
        k++; i++;
    }
    i=P*I;
    //cout <<"Her"<<endl;
    
    //Topside Well Pressure Balance: (3) in Problem Description File
    k=126;
    s=0;
    e=I;
    //cout<<"Testing pressure values "<<sol_milp[72]<<"  "<<sol_milp[78]<<endl;
    for(int j = s; j < e ; j++){
    	g[i]    = sol_milp[k] - (sol_milp[j*3]*tminlp->PSEPA);
        g[i+I]  = sol_milp[k] - (sol_milp[(j*3)+1]*tminlp->PSEPB);
        g[i+2*I]= sol_milp[k] - (sol_milp[(j*3)+2]*tminlp->PSEPC);
                
        //printf("%-5d %-6.2f >= %-6.2f\n", j, sol_milp[k], sol_milp[j]*PSEP);
        k++; i++;
    }
    
    i=(P*I)+(S*I);
    
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        g[i] = sol_milp[(j*3)] + sol_milp[(j*3)+1] + sol_milp[(j*3)+2];
        i++;
    }
    //cout<<"Constraint check (42)=="<<i<<endl; 
    
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Manifold 1 Well Models: (5) a-b-c in Problem Description File
    k=68;
    i1=36;
    i2=64;
    s=0;
    e=J1;
            //printf("(4) Subsea Flowrate Constraints \n");
            //printf("%-5s %-15s %-15s %-15s \n", "Well", "Gas", "Oil", "Water");    
    for(int j = s; j < e ; j++){
        double *ssim = tminlp->ratesim(j,0, sol_milp[k+i2], sol_milp[k+i1], tminlp->sarrptr[j]);
        g[i] = sol_milp[k] - (tminlp->wellspecJ[j][1]*sol_milp[k+J1] + sol_milp[k+i1]);                         //4b - gas
        g[i+J1] = sol_milp[k+J1] - ssim[0];                                               //4a - oil
        g[i+2*J1] = sol_milp[k+(2*J1)] - (sol_milp[k+J1]*(tminlp->wellspecJ[j][0]/(1-tminlp->wellspecJ[j][0]))); //4c - water
        
            //cout<<"Oil["<<I+j+1<<"]="<<sol_milp[k+I]<<endl;
            //cout<<"Gas["<<I+j+1<<"]="<<sol_milp[k]<<endl;
            //cout<<"Gas["<<I+j+1<<"]="<<sol_milp[k]<<endl;
            //cout<<"Water["<<I+j+1<<"]="<<sol_milp[k+2*I]<<endl;
            //cout<<"  PSIM="<<ssim[0]<<endl;
            //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+J, g[i+J], i+2*J, g[i+2*J]);
        k++; i++;
    }
    i=(P*I)+(S*I)+I+(J1*P);
    
    //Subsea Manifold 2 Well Models: (5) a-b-c in Problem Description File
    k=86;
    i1=24;
    i2=52;
    s=J1;
    e=J;
    for(int j = s; j < e ; j++){
        double *ssim = tminlp->ratesim(j,0, sol_milp[k+i2], sol_milp[k+i1], tminlp->sarrptr[j]);
        g[i] = sol_milp[k] - (tminlp->wellspecJ[j][1]*sol_milp[k+J2] + sol_milp[k+i1]);                           //4b - gas
        g[i+J2] = sol_milp[k+J2] - ssim[0];                                                //4a - oil
        g[i+2*J2] = sol_milp[k+(2*J2)] - (sol_milp[k+J2]*(tminlp->wellspecJ[j][0]/(1-tminlp->wellspecJ[j][0])));   //4c - water
        
            //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+J, g[i+J], i+2*J, g[i+2*J]);
        k++; i++;
    }
    
    
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P);
    
    //Manifold 1 Pipeline Pressure Drop: (6) in Problem Description File
    double *pres1 = tminlp->PressureDrop(0,0, sol_milp[114], sol_milp[116], sol_milp[118], tminlp->dParrptr[0]); //Line 1
    double *pres2 = tminlp->PressureDrop(1,0, sol_milp[115], sol_milp[117], sol_milp[119], tminlp->dParrptr[1]); //Line 2
    g[i] = -sol_milp[146] + sol_milp[142] - pres1[0];    
    //cout<<"Pipe 1 g["<<i<<"]="<<g[i]<<"     pres1="<<pres1[0]<<endl;     
    i++;
    g[i] = -sol_milp[147] + sol_milp[143] - pres2[0];    
    //cout<<"Pipe 2 g["<<i<<"]="<<g[i]<<"     pres2="<<pres2[0]<<endl;     
    i++;
    
    //Manifold 2 Pipeline Pressure Drop: (6) in Problem Description File
    double *pres3 = tminlp->PressureDrop(2,0, sol_milp[120], sol_milp[122], sol_milp[124], tminlp->dParrptr[2]); //Line 1
    double *pres4 = tminlp->PressureDrop(3,0, sol_milp[121], sol_milp[123], sol_milp[125], tminlp->dParrptr[3]); //Line 2
    g[i] = -sol_milp[148] + sol_milp[144] - pres3[0];   
    //cout<<"Pipe 1 g["<<i<<"]="<<g[i]<<"     pres1="<<pres1[0]<<endl;     
    i++;
    g[i] = -sol_milp[149] + sol_milp[145] - pres4[0];    
    //cout<<"Pipe 2 g["<<i<<"]="<<g[i]<<"     pres2="<<pres2[0]<<endl;     
    i++;
    
    
    //Subsea Manifold 1 Well Pressure Balance: (7) in Problem Description File
    k = 132;
    i1 = 142;
    i2 = 18;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
    	g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]); //printf("%-4d %-6.2f >= %-6.2f", j,sol_milp[k], sol_milp[i1]*sol_milp[i2]);
        i2++;
        g[i+J1] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]); //printf(" ---  %-6.2f >= %-6.2f\n", sol_milp[k], sol_milp[i1+1]*sol_milp[i2]);
        i2++;       
        i++; k++;
    }
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1);
    
    //Subsea Manifold 2 Well Pressure Balance: (7) in Problem Description File
    k = 138;
    i1 = 144;
    i2 = 30;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
    	g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]); //printf("%-4d %-6.2f >= %-6.2f", j,sol_milp[k], sol_milp[i1]*sol_milp[i2]);
        i2++;
        g[i+J2] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]); //printf(" ---  %-6.2f >= %-6.2f\n", sol_milp[k], sol_milp[i1+1]*sol_milp[i2]);
        i2++;       
        i++; k++;
    }
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2);
    
    //Subsea Routing: (8) in Problem Description File
    k=18;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){ 
        g[i] = sol_milp[k] + sol_milp[k+1]; 
        k=k+2; i++;
    }
    
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2)+J;
    
    //Subsea Manifold 1 Mass Balances: (9) in Problem Description File
    k=114;   i1=18;   i2=68;
    g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]) - (sol_milp[i1+2]*sol_milp[i2+1]) - (sol_milp[i1+4]*sol_milp[i2+2]) - (sol_milp[i1+6]*sol_milp[i2+3]) - (sol_milp[i1+8]*sol_milp[i2+4]) - (sol_milp[i1+10]*sol_milp[i2+5]);
    //cout<<"Line 1 gas g["<<i<<"]="<<g[i]<<endl;
    i++;    k++;
    g[i] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]) - (sol_milp[i1+3]*sol_milp[i2+1]) - (sol_milp[i1+5]*sol_milp[i2+2]) - (sol_milp[i1+7]*sol_milp[i2+3]) - (sol_milp[i1+9]*sol_milp[i2+4]) - (sol_milp[i1+11]*sol_milp[i2+5]);
   // cout<<"Line 2 gas g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J1;
    g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]) - (sol_milp[i1+2]*sol_milp[i2+1]) - (sol_milp[i1+4]*sol_milp[i2+2]) - (sol_milp[i1+6]*sol_milp[i2+3]) - (sol_milp[i1+8]*sol_milp[i2+4]) - (sol_milp[i1+10]*sol_milp[i2+5]);
    // cout<<"Line 1 oil g["<<i<<"]="<<g[i]<<endl;
    i++;    k++;
    g[i] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]) - (sol_milp[i1+3]*sol_milp[i2+1]) - (sol_milp[i1+5]*sol_milp[i2+2]) - (sol_milp[i1+7]*sol_milp[i2+3]) - (sol_milp[i1+9]*sol_milp[i2+4]) - (sol_milp[i1+11]*sol_milp[i2+5]);
    // cout<<"Line 2 oil g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J1;
    g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]) - (sol_milp[i1+2]*sol_milp[i2+1]) - (sol_milp[i1+4]*sol_milp[i2+2]) - (sol_milp[i1+6]*sol_milp[i2+3]) - (sol_milp[i1+8]*sol_milp[i2+4]) - (sol_milp[i1+10]*sol_milp[i2+5]);
    // cout<<"Line 1 wat g["<<i<<"]="<<g[i]<<endl;

    i++;    k++;
    g[i] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]) - (sol_milp[i1+3]*sol_milp[i2+1]) - (sol_milp[i1+5]*sol_milp[i2+2]) - (sol_milp[i1+7]*sol_milp[i2+3]) - (sol_milp[i1+9]*sol_milp[i2+4]) - (sol_milp[i1+11]*sol_milp[i2+5]);
    //  cout<<"Line 2 wat g["<<i<<"]="<<g[i]<<endl;
    i++;
    
    //Subsea Manifold 2 Mass Balances: (9) in Problem Description File
    k=120;   i1=30;   i2=86;
    g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]) - (sol_milp[i1+2]*sol_milp[i2+1]) - (sol_milp[i1+4]*sol_milp[i2+2]) - (sol_milp[i1+6]*sol_milp[i2+3]);
    //cout<<"Line 3 gas g["<<i<<"]="<<g[i]<<endl;
    i++;    k++;
    g[i] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]) - (sol_milp[i1+3]*sol_milp[i2+1]) - (sol_milp[i1+5]*sol_milp[i2+2]) - (sol_milp[i1+7]*sol_milp[i2+3]);
   // cout<<"Line 4 gas g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J2;
    g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]) - (sol_milp[i1+2]*sol_milp[i2+1]) - (sol_milp[i1+4]*sol_milp[i2+2]) - (sol_milp[i1+6]*sol_milp[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1<<" -"<<i2<<" -"<<i1+2<<" -"<<i2+1<<" -"<<i1+4<<" -"<<i2+2<<endl;
    // cout<<"Line 3 oil g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;
    g[i] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]) - (sol_milp[i1+3]*sol_milp[i2+1]) - (sol_milp[i1+5]*sol_milp[i2+2]) - (sol_milp[i1+7]*sol_milp[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1+1<<" -"<<i2<<" -"<<i1+3<<" -"<<i2+1<<" -"<<i1+5<<" -"<<i2+2<<endl;
    // cout<<"Line 4 oil g["<<i<<"]="<<g[i]<<endl;
    
    i++;    k++;    i2=i2+J2;
    g[i] = sol_milp[k] - (sol_milp[i1]*sol_milp[i2]) - (sol_milp[i1+2]*sol_milp[i2+1]) - (sol_milp[i1+4]*sol_milp[i2+2]) - (sol_milp[i1+6]*sol_milp[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1<<" -"<<i2<<" -"<<i1+2<<" -"<<i2+1<<" -"<<i1+4<<" -"<<i2+2<<endl;    
    // cout<<"Line 3 wat g["<<i<<"]="<<g[i]<<endl;

    i++;    k++;
    g[i] = sol_milp[k] - (sol_milp[i1+1]*sol_milp[i2]) - (sol_milp[i1+3]*sol_milp[i2+1]) - (sol_milp[i1+5]*sol_milp[i2+2]) - (sol_milp[i1+7]*sol_milp[i2+3]);
    //cout<<"g["<<i<<"]:"<<k<<" -"<<i1+1<<" -"<<i2<<" -"<<i1+3<<" -"<<i2+1<<" -"<<i1+5<<" -"<<i2+2<<endl;
    //  cout<<"Line 4 wat g["<<i<<"]="<<g[i]<<endl;
    i++;    
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    k=146;
    i2=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
    	g[i] = sol_milp[k] - (sol_milp[i2]*tminlp->PSEPA); i2++;  i++;
        g[i] = sol_milp[k] - (sol_milp[i2]*tminlp->PSEPB); i2++;  i++;
        g[i] = sol_milp[k] - (sol_milp[i2]*tminlp->PSEPC); i2++;  i++;
        k++;
    }
    //i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2)+J+(P*L)+(S*L);


    //Separator Routing: (11) in Problem Description File
    k=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        g[i] = sol_milp[k] + sol_milp[k+1] + sol_milp[k+2];
        k=k+3;
        i++;
    }
    i=(P*I)+(S*I)+I+(J1*P)+(J2*P)+L+(2*J1)+(2*J2)+J+(P*L)+(S*L)+L;
    
        
    //-------------------------CAPACITIES--------------------------------

    //Gas Lift Capacity: (12) in Problem Description File
    g[i]=    sol_milp[98]*(sol_milp[0]+sol_milp[1]+sol_milp[2]) + sol_milp[99]*(sol_milp[3]+sol_milp[4]+sol_milp[5])
            +sol_milp[100]*(sol_milp[6]+sol_milp[7]+sol_milp[8]) + sol_milp[101]*(sol_milp[9]+sol_milp[10]+sol_milp[11])
            +sol_milp[102]*(sol_milp[12]+sol_milp[13]+sol_milp[14]) + sol_milp[103]*(sol_milp[15]+sol_milp[16]+sol_milp[17])
            
            +sol_milp[104]*(sol_milp[18]+sol_milp[19]) + sol_milp[105]*(sol_milp[20]+sol_milp[21])
            +sol_milp[106]*(sol_milp[22]+sol_milp[23]) + sol_milp[107]*(sol_milp[24]+sol_milp[25])
            +sol_milp[108]*(sol_milp[26]+sol_milp[27]) + sol_milp[109]*(sol_milp[28]+sol_milp[29])
            +sol_milp[110]*(sol_milp[30]+sol_milp[31]) + sol_milp[111]*(sol_milp[32]+sol_milp[33])
            +sol_milp[112]*(sol_milp[34]+sol_milp[35]) + sol_milp[113]*(sol_milp[36]+sol_milp[37]);
    i++;
    
    //Gas Production Capacity: (13) in Problem Description File
    g[i]=    sol_milp[50]*(sol_milp[0]+sol_milp[1]+sol_milp[2]) + sol_milp[51]*(sol_milp[3]+sol_milp[4]+sol_milp[5])
            +sol_milp[52]*(sol_milp[6]+sol_milp[7]+sol_milp[8]) + sol_milp[53]*(sol_milp[9]+sol_milp[10]+sol_milp[11])
            +sol_milp[54]*(sol_milp[12]+sol_milp[13]+sol_milp[14]) + sol_milp[55]*(sol_milp[15]+sol_milp[16]+sol_milp[17])
            +sol_milp[114]+sol_milp[115]+sol_milp[120]+sol_milp[121];
    i++;        
    
    //Water Production Capacity: (14) in Problem Description File
    
    //Separator A
    g[i]=    sol_milp[62]*sol_milp[0] + sol_milp[63]*sol_milp[3] + sol_milp[64]*sol_milp[6] + sol_milp[65]*sol_milp[9] + sol_milp[66]*sol_milp[12] + sol_milp[67]*sol_milp[15]
            +sol_milp[118]*sol_milp[38] + sol_milp[119]*sol_milp[41] + sol_milp[124]*sol_milp[44] + sol_milp[125]*sol_milp[47];
    i++;
    
    //Separator B
    g[i]=    sol_milp[62]*sol_milp[1] + sol_milp[63]*sol_milp[4] + sol_milp[64]*sol_milp[7] + sol_milp[65]*sol_milp[10] + sol_milp[66]*sol_milp[13] + sol_milp[67]*sol_milp[16]
            +sol_milp[118]*sol_milp[39] + sol_milp[119]*sol_milp[42] + sol_milp[124]*sol_milp[45] + sol_milp[125]*sol_milp[48];
    i++;
    
    //Separator C
    g[i]=    sol_milp[62]*sol_milp[2] + sol_milp[63]*sol_milp[5] + sol_milp[64]*sol_milp[8] + sol_milp[65]*sol_milp[11] + sol_milp[66]*sol_milp[14] + sol_milp[67]*sol_milp[17]
            +sol_milp[118]*sol_milp[40] + sol_milp[119]*sol_milp[43] + sol_milp[124]*sol_milp[46] + sol_milp[125]*sol_milp[49];
    i++;
 
    
    
//-----------------------------Test Feasibility-----------------------    

// upper and lower bound on constraints
    s=0;
    e=0;
    k=0; //brukes i minmasol_milp sammenheng, teller brnnnr
    i=0;
    
    // Binary: 18
    
    // sol_milp_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        if (sol_milp[i] < 0.0 || sol_milp[i] > 1.0){
        cout<<" sol_milp_is = 18 "<<endl;
        return false;
        }
    }
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
        if (sol_milp[i] < 0.0 || sol_milp[i] > 1.0){
        cout<<" y_mjl = 20 "<<endl;
        return false;
        }
    }
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
        if (sol_milp[i] < 0.0 || sol_milp[i] > 1.0){
        cout<<" z_mls = 18 "<<endl;
        return false;
        }
    }

    // Continuous: 95
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
        if (sol_milp[i] < 0.0){
        cout<<" q^WI_pi = 18 "<<endl;
        return false;}
    }
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		if (sol_milp[i] < 0.0){
        cout<<" q^WJ_mpj = 30 "<<endl;
        return false;}
    }
    
    // q^GLI_i = 6 and q^GLJ_j = 10
    s=e;
    e=s+I+J;
    k=0;
    for(int i = s ; i < e ; i++){
        //cout<<"sol_milp["<<i<<"]: "<< sol_milp[i]<<"tminlp->minmax_w["<<k<<"][0][0]: "<<tminlp->minmax_w[k][0][0]<<endl;
		if(sol_milp[i]< tminlp->minmax_w[k][0][0] || sol_milp[i] > tminlp->minmax_w[k][0][1]){
        //cout<<" q^GLI_i = 6 and q^GLJ_j = 10 "<<endl;
        return false;}   
        k++;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		 if (sol_milp[i] < 0.0){
        cout<<" q^L_mpl = 12 "<<endl;
        return false;}
    }
    
    // p^WI_i = 6 and p^WJ_j = 10
    s=e;
    e=s+I+J;
    k=0;
    for(int i = s ; i < e ; i++){
		if(sol_milp[i]< tminlp->minmax_w[k][1][0] || sol_milp[i] > tminlp->minmax_w[k][1][1]){
        cout<<" p^WI_i = 6 and p^WJ_j = 10 "<<endl;
        return false;}   
        k++;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		 if (sol_milp[i] < 0.0){
        cout<<" p^M_ml = 4 "<<endl;
        return false;} 
    }
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		 if (sol_milp[i] < 0.0){
        cout<<"p^P_ml = 4 "<<endl;
        return false;}      
    }

// upper and lower bound on constraints
    
    s=0; //start value for loops
    e=0; //end value for loops
    
    //-------------------------TOPSIDE WELLS-----------------------------
    
    //Topside Well Models: (2) in Problem Description File
    e=I*P;
    for(int i = s; i < e ; i++){	
        
        if(g[i]> 0.9 || g[i] < -0.9){
        cout << "Feil: Topside Well Models: (2)"<<endl;
        cout<<"g["<<i<<"]: "<<g[i]<<endl;
        return false;}
    }
    
    //Topside Well Pressure Balance: (3) in Problem Description File
    s=e;
    e=s+(I*S);
    for(int i = s; i < e ; i++){
        if (g[i] < -0.1){
        cout << "Topside Well Pressure Balance: (3)"<<endl;
        return false;}
    }
    
    //Topside Well Routing: (4) in Problem Description File
    s=e;
    e=s+I;
    for(int i = s; i < e ; i++){
        if(g[i] < -0.1 || g[i] > 1.1){
        cout << "Topside Well Routing: (4)"<<endl;
        return false;}
    }
    
    
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Subsea Well Models: (5) in Problem Description File
    s=e;
    e=s+(J*P);
    for(int i = s; i < e ; i++){
        if(g[i] > 2 || g[i] < -2){
        //cout<<"g["<<i<<"]: "<<g[i]<<endl;
        cout << "Subsea Well Models: (5)"<<endl;
        return false;}
    }
    
    
    //-------------------------PRESSURE DROP-------------------------------
    //Pipeline Pressure Drop: (6) in Problem Description File
     s=e;
     e=s+L;
    for(int i = s; i < e ; i++){
        //cout<<"g["<<i<<"]: "<<g[i]<<endl;
        if(g[i]> 2|| g[i] < -2){
        cout << "Pipeline Pressure Drop: (6)"<<endl;
        return false;}
    }
    
    //Subsea Well Pressure Balance: (7) in Problem Description File
     s=e;
     e=s+(J*2);
    for(int i = s; i < e ; i++){ 
        if (g[i] < -0.1){
        cout << "Subsea Well Pressure Balance: (7)"<<endl;
        return false;}
    }

    //Subsea Routing: (8) in Problem Description File
    s=e;
    e=s+J;
    for(int i = s; i < e ; i++){
        if(g[i] < -0.1 || g[i] > 1.1){
        cout<<"g["<<i<<"]: "<<g[i]<<endl;
        cout << "Subsea Routing: (8)"<<endl;
        return false;}
    }
    
    //Subsea Mass Balance: (9) in Problem Description File
    s=e;
    e=s+(L*P);
    for(int i = s; i < e ; i++){
        if(g[i]> 0.9 || g[i] < -0.9){
        cout << "Subsea Mass Balance: (9)"<<endl;
        return false;}
    }
    
    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=e;
    e=s+(L*S);
    for(int i = s; i < e ; i++){
        if (g[i] < -0.1){
        cout << "Separator Pressure Balance: (10)"<<endl;
        return false;}
    }
    //Separator Routing: (11) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++){
        if(g[i] < -0.1 || g[i] > 1.1){
        cout << "Separator Routing: (11)"<<endl;
        return false;}
    }
     

    //-------------------------CAPACITIES--------------------------------
    
    //Gas Lift Capacity: (12) in Problem Description File
    if (g[e] < -1 || g[e] > 10000){
        cout << "Gas Lift Capacity: (12) "<<g[e]<<endl;
        return false;}
    e++;
    
    //Gas Production Capacity: (13) in Problem Description File
    if (g[e] < -1 || g[e] > 15000){
        cout << "Gas Production Capacity: (13)"<<g[e]<<endl;
        return false;}
    e++;
    
    //Water Production Capacity: (14) in Problem Description File
    if (g[e] < -1 || g[e] > 6000){
        cout << "Water Production Capacity: (14)"<<g[e]<<endl;
        return false;}
    e++;
    
    if (g[e] < -1 || g[e] > 6000){
        cout << "Water Production Capacity: (14)"<<g[e]<<endl;
        return false;}
    e++;
    
    if (g[e] < -1 || g[e] > 6000){
        cout << "Water Production Capacity: (14)"<<g[e]<<endl;
        return false;}
    e++;
        

//    cout<<"ferdig get_bounds_info"<<endl;
  return true;  
}



