// (C) Copyright Carnegie Mellon University 2006
// All Rights Reserved.
// This code is published under the Common Public License.
//
// Authors :
// P. Bonami, Carnegie Mellon University
//
// Date :  03/17/2006
#include "MyTMINLP.hpp"
#include "BonAmplInterface.hpp"
using namespace std;

//typedef double(*vdtbl)[gdim][pdim][ddim];


//MILP PROBELM
bool 
MyTMILP::get_variables_types(Index n, VariableType* var_types)
{
    //cout<<"start get_var_types"<<endl;  
	// defines the type of variables i.e. all variables are listed in one long vector
    
   
    
    int s=0; //Use these to set start and ending values in the creation of the variables in the for-loops
    int e=0;
   
    // Binary: 50
    
    // x_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        var_types[i] = INTEGER;}
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
		var_types[i] = INTEGER;}
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
		var_types[i] = INTEGER;}
   
    // Continuous: 277
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^GLI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^GLJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // p^WI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}

    // p^WJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}   
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
    //p^WJ_mjlp = 36 m = 1
    s=e;
    e=s+J1*P*L1;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}   
    
   //p^WJ_mjlp = 18 m = 2
    s=e;
    e=s+J2*P*L1;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}   
    
   //q^WJ_mlps = 36 
    s=e;
    e=s+L*P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}   
    
   //q^WI_jps = 54 
    s=e;
    e=s+I*P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;} 

   //q^WI_tps = 9 
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;} 
    
  //q^WI_mps = 9 m = 1
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
  //q^WI_mps = 9 m = 2
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
  
  //--------Extra binary variables for Feasibility Pump-----
  //x/y/z=w1-w2 for all binary variables
    s=e;
    e=s+2*NB;
    for(int i = s ; i < e ; i++){
		var_types[i] = CONTINUOUS;}
    
//cout<<"Number of vars: "<<e<<endl;   
   
//cout<<"ferdig get_var_types"<<endl;   
  return true; 
}


bool 
MyTMILP::get_variables_linearity(Index n, Ipopt::TNLP::LinearityType* var_types)
{ // sett NON_LINEAR hvis variabelen inngr i uliner constraint
    //cout<<"starter get_var_linearity------";  
    
    
    int s=0; //Use these to set start and ending values in the creation of the variables in the for-loops
    int e=0;
   
    // ------------Binary: 50
    
    // x_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
   
    // -----------------Continuous: 277
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // q^GLI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // q^GLJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // p^WI_i = 6
    s=e;
    e=s+I;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}

    // p^WJ_j = 10
    s=e;
    e=s+J;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}   
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;} 
    
        //p^WJ_mjlp = 36 m = 1
    s=e;
    e=s+J1*P*L1;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}   
    
   //p^WJ_mjlp = 18 m = 2
    s=e;
    e=s+J2*P*L1;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}   
    
   //q^WJ_mlps = 36 
    s=e;
    e=s+L*P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}   
    
   //q^WI_jps = 54 
    s=e;
    e=s+I*P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;} 

   //q^WI_tps = 9 
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;} 
    
  //q^WI_mps = 9 m = 1
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
  //q^WI_mps = 9 m = 2
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
  //--------Extra binary variables for Feasibility Pump-----
  //x/y/z=w1-w2 for all binary variables
    s=e;
    e=s+2*NB;
    for(int i = s ; i < e ; i++){
		var_types[i] = Ipopt::TNLP::LINEAR;}
    
 //cout<<"Number of variables: "<<e<<endl;

	
//  alternatives
//  var_types[0] = Ipopt::TNLP::LINEAR;
//  var_types[1] = Ipopt::TNLP::NON_LINEAR;
//cout<<"ferdig get_var_lin"<<endl;
  return true;
}

bool 
MyTMILP::get_constraints_linearity(Index m, Ipopt::TNLP::LinearityType* const_types)
{
    //cout<<"starter get_const_linearity------";  
    
    assert(m==MC_MILP);
        
    int s=0; //start value for loops
    
    for(int i=s; i<MC_MILP; i++){
    const_types[i]= Ipopt::TNLP::LINEAR;}   

    
  //cout<<"Number of constraints: "<<e<<endl;  
  //alternatives
  //assert (m==2);
  //const_types[0] = Ipopt::TNLP::NON_LINEAR;
  //const_types[1] = Ipopt::TNLP::LINEAR;
  //std::cout<<"ferdig get_con_lin"<<std::endl;
  return true; 
}

bool 
MyTMILP::get_nlp_info(Index& n, Index&m, Index& nnz_jac_g,
                       Index& nnz_h_lag, TNLP::IndexStyleEnum& index_style)
{
  n = NV_MILP;           //number of variable
  m = MC_MILP;           //number of constraints
  nnz_jac_g = 2491;  //number of non zeroes in Jacobian
  nnz_h_lag = 0;    //number of non zeroes in Hessian of Lagrangean
  index_style = TNLP::C_STYLE;
	
	//approx_grad_f
	//eval_grad_f=approx_grad_f, 
	//index_style = TNLP::FORTRAN_STYLE;
  //cout<<"ferdig get_nlp_info"<<endl;
  return true;  
}

bool 
MyTMILP::get_bounds_info(Index n, Number* x_l, Number* x_u,
                            Index m, Number* g_l, Number* g_u)
{
 //cout<<"starter get_bounds-info------";  
  assert(n==NV_MILP);
  assert(m==MC_MILP);

// upper and lower bound on variables
    int s=0;
    int e=0;
    int k=0; //brukes i minmax sammenheng, teller brnnnr
    
   

    // Binary: 18
    
    // x_is = 18
    e=(S*I);
    for(int i = s ; i < e ; i++){
        x_l[i] = 0.0; x_u[i] = 1;}
    
    // y_mjl = 20
    s=e;
    e=s+(J*2);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = 1.0;}
    
    // z_mls = 18
    s=e;
    e=s+(L*S);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = 1.0;}

    // Continuous: 95
    
    // q^WI_pi = 18
    s=e;
    e=s+(P*I);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    //x_l[56]=54;
    
    // q^WJ_mpj = 30
    s=e;
    e=s+(P*J);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    // q^GLI_i = 6 and q^GLJ_j = 10
    s=e;
    e=s+I+J;
    for(int i = s ; i < e ; i++){
		x_l[i] = minmax_w[k][0][0]; x_u[i] = minmax_w[k][0][1];
        k++;}
    
    // q^L_mpl = 12
    s=e;
    e=s+(L*P);
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    // p^WI_i = 6 and p^WJ_j = 10
    s=e;
    e=s+I+J;
    k=0;
    for(int i = s ; i < e ; i++){
		x_l[i] = minmax_w[k][1][0]; x_u[i] = minmax_w[k][1][1];
        k++;}
    
    // p^M_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}   
    
    // p^P_ml = 4
    s=e;
    e=s+L;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}    
    
        //p^WJ_mjlp = 36 m = 1
    s=e;
    e=s+J1*P*L1;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}   
    
   //p^WJ_mjlp = 18 m = 2
    s=e;
    e=s+J2*P*L1;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}   
    
   //q^WJ_mlps = 36 
    s=e;
    e=s+L*P*S;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}   
    
   //q^WI_jps = 54 
    s=e;
    e=s+I*P*S;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;} 

   //q^WI_tps = 9 
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;} 
    
  //q^WI_mps = 9 m = 1
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
  //q^WI_mps = 9 m = 2
    s=e;
    e=s+P*S;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = DBL_MAX;}
    
    
  //--------Extra binary variables for Feasibility Pump-----
  //x/y/z=w1-w2 for all binary variables
    
  s=e;
    e=s+NB*2;
    for(int i = s ; i < e ; i++){
		x_l[i] = 0.0; x_u[i] = 1;}     
    

//cout<<"Number of variables(Bounds): "<<e<<endl;
// upper and lower bound on constraints
    
    s=0; //start value for loops
    e=0; //end value for loops
    
    //-------------------------TOPSIDE WELLS-----------------------------

    
    //Topside Well Pressure Balance: (3) in Problem Description File
    s=e;
    e=P*I;
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;}
    //cout<<"e(18) "<<e<<endl;
    //Topside Well Routing: (4) in Problem Description File
    s=e;
    e=P*I+I;
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 1;}
    //cout<<"e(24) "<<e<<endl;
   
    
    //-------------------------SUBSEA WELL--------------------------------   
    //Subsea Well Pressure Balance: (7) in Problem Description File
    s=e;
    e=s+(2*J);
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;}
    //cout<<"e(44) "<<e<<endl;
    
    //Subsea Routing: (8) in Problem Description File
    s=e;
    e=s+J;
    for(int i = s; i < e ; i++){
        g_l[i]= 0; g_u[i]= 1;}
    //cout<<"e(54) "<<e<<endl;
    
    //-------------------------CAPACITIES--------------------------------
    
    //Gas Lift Capacity: (12) in Problem Description File
    g_l[e]= 0; g_u[e]= 1100;
    e++;
    //cout<<"e(55) "<<e<<endl;
    
    //Gas Production Capacity: (13) in Problem Description File
    g_l[e]= 0; g_u[e]= 2000;
    e++;
    //cout<<"e(56) "<<e<<endl;
    
    //Water Production Capacity: (14) in Problem Description FileP
    g_l[e]= 0; g_u[e]= 2400;
    e++;
    g_l[e]= 0; g_u[e]= 2400;
    e++;
    g_l[e]= 0; g_u[e]= 2000;
    e++;
    //cout<<"e(59) "<<e<<endl;

    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=e;
    e=s+(L*S);
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;}
    //cout<<"e(71) "<<e<<endl;
    
    //Separator Routing: (11) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++){
        g_l[i]= 1; g_u[i]= 1;} 
    //cout<<"e(75) "<<e<<endl;
    
        
    //-------------------------MASS BALANCE--------------------------------
    
       
    //cout<<"Subsea Well to Pipelines - Linearization Mass Balance: (15) in Problem Description File"<<endl;
    // Subsea Manifold 1
    s=e;
    e=s+P*J1;  
    for(int i = s; i < e ; i++){
      g_l[i]=0; g_u[i]= 0;
    }
  
    // Subsea Manifold 2
    s=e;
    e=s+P*J2;  
    for(int i = s; i < e ; i++){
      g_l[i]=0; g_u[i]= 0;
    }
    //cout<<"e(105) "<<e<<endl;
    //cout<< "Linearization Mass Balance: (16 og 17) in Problem Description File "<<endl;
    // Subsea Manifold 1 - Line 1
    s=e;
    e=s+P*J1;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }

    // Subsea Manifold 1 - Line 2
    s=e;
    e=s+P*J1;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }
 
    // Subsea Manifold 2 - Line 3
    s=e;
    e=s+P*J2;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }

    
    // Subsea Manifold 2 - Line 4
    s=e;
    e=s+P*J2;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    } 
    //cout<<"e(165) "<<e<<endl;
    
    // Linearization Mass Balance: (18) in Problem Description File  
    // Subsea Manifold 1
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
      g_l[i]= 0; g_u[i]= 0;
    }

    // Subsea Manifold 2
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
      g_l[i]= 0; g_u[i]= 0;
    }
    //cout<<"e(177) "<<e<<endl;
    
    // Subsea Pipeline to Separator - Linearization Mass Balance: (19) in Problem Description File 
    
    // Subsea Manifold 1
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
      g_l[i]= 0; g_u[i]= 0;
    }
    
    
    // Subsea Manifold 2
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
      g_l[i]= 0; g_u[i]= 0;
    }
    //cout<<"e(189) "<<e<<endl;
    
    // Linearization Mass Balance: (20) in Problem Description File  
    // Subsea Manifold 1 - Separator 1
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }
    
    // Subsea Manifold 1 - Separator 2  
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }  
    
    // Subsea Manifold 1 - Separator 3
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }
   
    // Subsea Manifold 2 - Separator 1
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }
    
    // Subsea Manifold 2 - Separator 2 
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    } 
    
    // Subsea Manifold 2 - Separator 3
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    }   
    //cout<<"e(225) "<<e<<endl;
    
    // Linearization Mass Balance: (21) in Problem Description File   
    // Subsea Manifold 1
    s=e;
    e=s+P*S;  
    for(int i = s; i < e ; i++){
     g_l[i]=0; g_u[i]= 0;
    }
    
    // Subsea Manifold 2
    s=e;
    e=s+P*S;  
    for(int i = s; i < e ; i++){
     g_l[i]=0; g_u[i]= 0;
    }
    //cout<<"e(243) "<<e<<endl;
    
    // Topsde Well To Separator - Linearization Mass Balance: (22) in Problem Description File         
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
     g_l[i]=0; g_u[i]= 0;
    }      
    //cout<<"e(261) "<<e<<endl;
    
	// Linearization Mass Balance: (23+24) in Problem Description File         
        
    // Separator 1
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]=  DBL_MAX;
    }   
    
    // Separator 2
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;
    } 
    
    
    // Separator 3
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]=  DBL_MAX;
    }
    //cout<<"e(315) "<<e<<endl; 
    
    // Linearization Mass Balance: (25) in Problem Description File   
    s=e;
    e=s+P*S;  
    for(int i = s; i < e ; i++){
     g_l[i]= 0; g_u[i]= 0;
    }
    //cout<<"e(324) "<<e<<endl;
        
    //-------------------------TOPSIDE WELLS----------------------------- 
    //Topside Well Models: (2) in Problem Description File
    s=e;
    e=s+I*2;
    for(int i = s; i < e ; i++){	
         g_l[i]= 0; g_u[i]= 0;
    }
   //cout<<"e(336) "<<e<<endl;


    //-------------------------SUBSEA WELLS-------------------------------
    //Gas and Water production
    //Subsea Manifold 1 Well Models: (5) a, c in Problem Description File
    s=e;
    e=s+J1*2;  
    for(int i = s; i < e ; i++){
     g_l[i]= 0; g_u[i]= 0;
    }
    
    //Subsea Manifold 2 Well Models: (5) a, c in Problem Description File
    s=e;
    e=s+J2*2;  
    for(int i = s; i < e ; i++){
      g_l[i]= 0; g_u[i]= 0;
    }   
    //cout<<"e(356) "<<e<<endl;
     //-------------------------TOPSIDE WELLS-----------------------------       
        
    //Well Model:  26(a)
    s=e;
    e=s+I*MaxIt;
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;}
    //cout<<"e(476) "<<e<<endl;     
      
    //-------------------------SUBSEA WELLS-------------------------------
    
    s=e;
    e=s+J*MaxIt;
    for(int i = s; i < e ; i++){
          g_l[i]= 0; g_u[i]= DBL_MAX;}
    //cout<<"e(676) "<<e<<endl;
    //-------------------------PIPELINES----------------------------------
     
    s=e;
    e=s+L*MaxIt;
    for(int i = s; i < e ; i++){
          g_l[i]= -DBL_MAX; g_u[i]= 0;}

    
    //-----------------------MILP BINARY FEASIBILITY PUMP---------------------
     
    s=e;
    e=s+NB;
    for(int i = s; i < e ; i++){
          g_l[i]=0; g_u[i]= 0;}
    
 
    
    
    
    //cout<<"Number of Constraints(Bounds): "<<e<<endl;
    
    //cout<<"ferdig get_bounds_info"<<endl;
  return true;    
 
}

bool 
MyTMILP::get_starting_point(Index n, bool init_x, Number* x,
                             bool init_z, Number* z_L, Number* z_U,
                             Index m, bool init_lambda,
                             Number* lambda)
{
  //cout<<"starter get_starting_point------";  
  assert(n==NV_MILP);
  assert(m==MC_MILP);
  
  assert(init_x);
  assert(!init_lambda);
  
if(It_nlp==0){
x[0] = 0.407377;
x[1] = 0.329798;
x[2] = 0.254939;
x[3] = 0.412497;
x[4] = 0.315952;
x[5] = 0.271394;
x[6] = 0.152380;
x[7] = 0.140948;
x[8] = 0.136490;
x[9] = 0.395623;
x[10] = 0.321691;
x[11] = 0.277036;
x[12] = 0.411643;
x[13] = 0.316022;
x[14] = 0.271695;
x[15] = 0.399385;
x[16] = 0.317016;
x[17] = 0.281578;
x[18] = 0.482326;
x[19] = 0.517265;
x[20] = 0.001623;
x[21] = 0.001528;
x[22] = 0.481327;
x[23] = 0.515167;
x[24] = 0.575965;
x[25] = 0.423841;
x[26] = 0.575550;
x[27] = 0.424204;
x[28] = 0.482377;
x[29] = 0.517305;
x[30] = 0.497485;
x[31] = 0.502386;
x[32] = 0.348753;
x[33] = 0.649228;
x[34] = 0.651471;
x[35] = 0.348474;
x[36] = 0.001715;
x[37] = 0.001877;
x[38] = 0.402551;
x[39] = 0.333291;
x[40] = 0.264157;
x[41] = 0.402694;
x[42] = 0.333290;
x[43] = 0.264015;
x[44] = 0.413219;
x[45] = 0.331693;
x[46] = 0.255088;
x[47] = 0.414163;
x[48] = 0.331265;
x[49] = 0.254572;
x[50] = 52.716841;
x[51] = 330.879033;
x[52] = 30.773253;
x[53] = 74.254828;
x[54] = 196.180602;
x[55] = 130.829946;
x[56] = 78.735408;
x[57] = 1331.873476;
x[58] = 289.076743;
x[59] = 356.859421;
x[60] = 730.276997;
x[61] = 521.837108;
x[62] = 123.669239;
x[63] = 1157.144420;
x[64] = 636.857732;
x[65] = 725.188550;
x[66] = 1147.041762;
x[67] = 989.857874;
x[68] = 144.344132;
x[69] = 95.372930;
x[70] = 65.406293;
x[71] = 275.895888;
x[72] = 130.019239;
x[73] = 163.847779;
x[74] = 965.758551;
x[75] = 32.906230;
x[76] = 324.678598;
x[77] = 1334.714899;
x[78] = 1255.794088;
x[79] = 1137.734673;
x[80] = 244.920340;
x[81] = 123.790105;
x[82] = 196.391211;
x[83] = 292.986197;
x[84] = 480.406780;
x[85] = 288.534191;
x[86] = 190.334636;
x[87] = 60.597552;
x[88] = 171.573430;
x[89] = 172.712499;
x[90] = 1378.136700;
x[91] = 375.913404;
x[92] = 2423.579149;
x[93] = 292.351954;
x[94] = 660.527057;
x[95] = 603.027752;
x[96] = 223.116438;
x[97] = 729.143344;
x[98] = 45.709390;
x[99] = 226.060591;
x[100] = 1.605410;
x[101] = 44.564124;
x[102] = 126.658232;
x[103] = 94.301348;
x[104] = 60.129987;
x[105] = 92.575900;
x[106] = 40.406041;
x[107] = 169.118696;
x[108] = 10.090903;
x[109] = 64.637316;
x[110] = 78.705563;
x[111] = 44.282911;
x[112] = 0.226384;
x[113] = 156.516201;
x[114] = 414.032841;
x[115] = 365.354931;
x[116] = 2662.478761;
x[117] = 2353.841763;
x[118] = 797.290928;
x[119] = 705.282033;
x[120] = 227.893690;
x[121] = 195.076109;
x[122] = 2396.097663;
x[123] = 1781.513241;
x[124] = 685.514744;
x[125] = 802.460653;
x[126] = 5.934587;
x[127] = 10.015186;
x[128] = 16.336894;
x[129] = 10.247163;
x[130] = 10.062855;
x[131] = 12.103966;
x[132] = 41.542525;
x[133] = 149.054333;
x[134] = 41.758492;
x[135] = 50.007894;
x[136] = 50.017270;
x[137] = 41.547609;
x[138] = 30.030504;
x[139] = 40.177459;
x[140] = 40.006676;
x[141] = 91.895781;
x[142] = 86.006017;
x[143] = 80.195512;
x[144] = 59.932637;
x[145] = 59.372552;
x[146] = 4.157310;
x[147] = 4.166520;
x[148] = 5.075888;
x[149] = 5.150273;

for (int i=150; i<NV_MILP; i++){   
      //cout<<"Parameter_start["<<i<<"]: "<<Parameter_start[i]<<endl;
      x[i] = 0;}   

}
  
else{
  
for (int i=0; i<150; i++){   
      //cout<<"Parameter_start["<<i<<"]: "<<Parameter_start[i]<<endl;
      x[i] = Parameter_start[i];}   
  
  for (int i=150; i<NV_MILP; i++){   
      //cout<<"Parameter_start["<<i<<"]: "<<Parameter_start[i]<<endl;
      x[i] = 0;}   }
   

// cout<<"ferdig get_start_point"<<endl;
  return true;
}

bool 
MyTMILP::eval_f(Index n, const Number* x, bool new_x, Number& obj_value)
{
   assert(n==NV_MILP);

    

        
   obj_value = ((1-WW))*x[327]
                +((1-WW))*x[328]
                +((1-WW))*x[329]
                +((1-WW))*x[330]
                +((1-WW))*x[331]
                +((1-WW))*x[332]
                +((1-WW))*x[333]
                +((1-WW))*x[334]
           +((1-WW))*x[335]
           +((1-WW))*x[336]
           +((1-WW))*x[337]
           +((1-WW))*x[338]
           +((1-WW))*x[339]
           +((1-WW))*x[340]
           +((1-WW))*x[341]
           +((1-WW))*x[342]
           +((1-WW))*x[343]
           +((1-WW))*x[344]
           +((1-WW))*x[345]
           +((1-WW))*x[346]
           +((1-WW))*x[347]
           +((1-WW))*x[348]
           +((1-WW))*x[349]
           +((1-WW))*x[350]
           +((1-WW))*x[351]
           +((1-WW))*x[352]
           +((1-WW))*x[353]
           +((1-WW))*x[354]
           +((1-WW))*x[355]
           +((1-WW))*x[356]
           +((1-WW))*x[357]
           +((1-WW))*x[358]
           +((1-WW))*x[359]
           +((1-WW))*x[360]
           +((1-WW))*x[361]
           +((1-WW))*x[362]
           +((1-WW))*x[363]
           +((1-WW))*x[364]
           +((1-WW))*x[365]
           +((1-WW))*x[366]
           +((1-WW))*x[367]
           +((1-WW))*x[368]
           +((1-WW))*x[369]
           +((1-WW))*x[370]
           +((1-WW))*x[371]
           +((1-WW))*x[372]
           +((1-WW))*x[373]
           +((1-WW))*x[374]
           +((1-WW))*x[375]
           +((1-WW))*x[376]
           +((1-WW))*x[377]
           +((1-WW))*x[378]
           +((1-WW))*x[379]
           +((1-WW))*x[380]
           +((1-WW))*x[381]
           +((1-WW))*x[382]
           +((1-WW))*x[383]
           +((1-WW))*x[384]
           +((1-WW))*x[385]
           +((1-WW))*x[386]
           +((1-WW))*x[387]
           +((1-WW))*x[388]
           +((1-WW))*x[389]
           +((1-WW))*x[390]
           +((1-WW))*x[391]
           +((1-WW))*x[392]
           +((1-WW))*x[393]
           +((1-WW))*x[394]
           +((1-WW))*x[395]
           +((1-WW))*x[396]
           +((1-WW))*x[397]
           +((1-WW))*x[398]
           +((1-WW))*x[399]
           +((1-WW))*x[400]
           +((1-WW))*x[401]
           +((1-WW))*x[402]
           +((1-WW))*x[403]
           +((1-WW))*x[404]
           +((1-WW))*x[405]
           +((1-WW))*x[406]
           +((1-WW))*x[407]
           +((1-WW))*x[408]
           +((1-WW))*x[409]
           +((1-WW))*x[410]
           +((1-WW))*x[411]
           +((1-WW))*x[412]
           +((1-WW))*x[413]
           +((1-WW))*x[414]
           +((1-WW))*x[415]
           +((1-WW))*x[416]
           +((1-WW))*x[417]
           +((1-WW))*x[418]
           +((1-WW))*x[419]
           +((1-WW))*x[420]
           +((1-WW))*x[421]
           +((1-WW))*x[422]
           +((1-WW))*x[423]
           +((1-WW))*x[424]
           +((1-WW))*x[425]
           +((1-WW))*x[426]
          
          
                
                - (WW/NND)*x[303]
                - (WW/NND)*x[304]
                - (WW/NND)*x[305]
                - (WW/NND)*x[312] 
                - (WW/NND)*x[313]
                - (WW/NND)*x[314]
                - (WW/NND)*x[321]
                - (WW/NND)*x[322]
                - (WW/NND)*x[323];
   
 // cout <<"Obj_grad_f: "<<((1-WW/10000))<<endl;

//    cout<<"XXXXXXX OBJECTIVE VALUE:"<<obj_value<<" XXXXXXXXXX"<<endl;
//    cout<<"ferdig eval_f"<<endl;
  return true;
}

bool
MyTMILP::eval_grad_f(Index n, const Number* x, bool new_x, Number* grad_f)
{
 //cout<<"starter eval_grad_f------"<<endl;  
 
 
 assert(n==NV_MILP);
 
 
for(int i = 0 ; i < 427 ; i++){grad_f[i] = 0;}
     
     
    grad_f[327]=((1-WW));
    
  //  cout <<"Grad_f: "<<grad_f[327]<<endl;
    
    grad_f[328]=((1-WW));
    grad_f[329]=((1-WW));
    grad_f[330]=((1-WW));
    grad_f[331]=((1-WW));
    grad_f[332]=((1-WW));
    grad_f[333]=((1-WW));
    grad_f[334]=((1-WW));
    grad_f[335]=((1-WW));
    grad_f[336]=((1-WW));
    grad_f[337]=((1-WW));
    grad_f[338]=((1-WW));
    grad_f[339]=((1-WW));
    grad_f[340]=((1-WW));
    grad_f[341]=((1-WW));
    grad_f[342]=((1-WW));
    grad_f[343]=((1-WW));
    grad_f[344]=((1-WW));
    grad_f[345]=((1-WW));
    grad_f[346]=((1-WW));
    grad_f[347]=((1-WW));
    grad_f[348]=((1-WW));
    grad_f[349]=((1-WW));
    grad_f[350]=((1-WW));
    grad_f[351]=((1-WW));
    grad_f[352]=((1-WW));
    grad_f[353]=((1-WW));
    grad_f[354]=((1-WW));
    grad_f[355]=((1-WW));
    grad_f[356]=((1-WW));
    grad_f[357]=((1-WW));
    grad_f[358]=((1-WW));
    grad_f[359]=((1-WW));
    grad_f[360]=((1-WW));
    grad_f[361]=((1-WW));
    grad_f[362]=((1-WW));
    grad_f[363]=((1-WW));
    grad_f[364]=((1-WW));
    grad_f[365]=((1-WW));
    grad_f[366]=((1-WW));
    grad_f[367]=((1-WW));
    grad_f[368]=((1-WW));
    grad_f[369]=((1-WW));
    grad_f[370]=((1-WW));
    grad_f[371]=((1-WW));
    grad_f[372]=((1-WW));
    grad_f[373]=((1-WW));
    grad_f[374]=((1-WW));
    grad_f[375]=((1-WW));
    grad_f[376]=((1-WW));
    grad_f[377]=((1-WW));
    grad_f[378]=((1-WW));
    grad_f[379]=((1-WW));
    grad_f[380]=((1-WW));
    grad_f[381]=((1-WW));
    grad_f[382]=((1-WW));
    grad_f[383]=((1-WW));
    grad_f[384]=((1-WW));
    grad_f[385]=((1-WW));
    grad_f[386]=((1-WW));
    grad_f[387]=((1-WW));
    grad_f[388]=((1-WW));
    grad_f[389]=((1-WW));
    grad_f[390]=((1-WW));
    grad_f[391]=((1-WW));
    grad_f[392]=((1-WW));
    grad_f[393]=((1-WW));
    grad_f[394]=((1-WW));
    grad_f[395]=((1-WW));
    grad_f[396]=((1-WW));
    grad_f[397]=((1-WW));
    grad_f[398]=((1-WW));
    grad_f[399]=((1-WW));
    grad_f[400]=((1-WW));
    grad_f[401]=((1-WW));
    grad_f[402]=((1-WW));
    grad_f[403]=((1-WW));
    grad_f[404]=((1-WW));
    grad_f[405]=((1-WW));
    grad_f[406]=((1-WW));
    grad_f[407]=((1-WW));
    grad_f[408]=((1-WW));
    grad_f[409]=((1-WW));
    grad_f[410]=((1-WW));
    grad_f[411]=((1-WW));
    grad_f[412]=((1-WW));
    grad_f[413]=((1-WW));
    grad_f[414]=((1-WW));
    grad_f[415]=((1-WW));
    grad_f[416]=((1-WW));
    grad_f[417]=((1-WW));
    grad_f[418]=((1-WW));
    grad_f[419]=((1-WW));
    grad_f[420]=((1-WW));
    grad_f[421]=((1-WW));
    grad_f[422]=((1-WW));
    grad_f[423]=((1-WW));
    grad_f[424]=((1-WW));
    grad_f[425]=((1-WW));
    grad_f[426]=((1-WW));

     grad_f[303]=  - (WW/NND);
     grad_f[304]=  - (WW/NND);
     grad_f[305]=  - (WW/NND);
     grad_f[312]=  - (WW/NND);
     grad_f[313]=  - (WW/NND);
     grad_f[314]=  - (WW/NND);
     grad_f[321]=  - (WW/NND);
     grad_f[322]=  - (WW/NND);
     grad_f[323]=  - (WW/NND);
     
//     
//cout<<"ferdig eval_grad_f"<<endl;
  return true;
}

bool
MyTMILP::eval_g(Index n, const Number* x, bool new_x, Index m, Number* g)
{

  //cout<<"Starting eval_g------"<<endl;
//   cout<<x[54]<<"  "<<x[60]<<"  "<<x[72]<<"  "<<x[78]<<endl;
//   cout<<x[55]<<"  "<<x[61]<<"  "<<x[73]<<"  "<<x[79]<<endl;
//   cout<<x[56]<<"  "<<x[62]<<"  "<<x[74]<<"  "<<x[80]<<endl;
//   cout<<x[57]<<"  "<<x[63]<<"  "<<x[75]<<"  "<<x[81]<<endl;
//   cout<<x[58]<<"  "<<x[64]<<"  "<<x[76]<<"  "<<x[82]<<endl;
//   cout<<x[59]<<"  "<<x[65]<<"  "<<x[77]<<"  "<<x[83]<<endl;
  
//   printf("Binaries\n");
//   printf("Platform Wells:  %-4.1f %-4.1f %-4.1f %-4.1f %-4.1f %-4.1f\n", x[0], x[1], x[2], x[3], x[4], x[5]);
//   printf("Subsea Wells:  %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f\n", x[6], x[8], x[10], x[12], x[14], x[16]);
//   printf("Subsea Wells:  %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f %-6.1f\n", x[7], x[9], x[11], x[13], x[15], x[17]);
  
  assert(n==NV_MILP); //variables
  assert(m==MC_MILP);  //constraints
    
    int s=0;  //start value for loops
    int e=0;  //end value for loops
    int i=0;  //constraint counter
    int i1=0; //constraint counter
    int i2=0; //constraint counter
    int i3=0; //constraint counter
    int k=0;
    
 
    //-------------------------TOPSIDE WELL--------------------------------   
    //Topside Well Pressure Balance: (3) in Problem Description File
    k=126;
    s=0;
    e=I;
    //cout<<"Testing pressure values "<<x[72]<<"  "<<x[78]<<endl;
    for(int j = s; j < e ; j++){
    	g[i]    = x[k] - (x[j*3]*PSEPA);
        g[i+I]  = x[k] - (x[(j*3)+1]*PSEPB);
        g[i+2*I]= x[k] - (x[(j*3)+2]*PSEPC);
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
                
        //printf("%-5d %-6.2f >= %-6.2f\n", j, x[k], x[j]*PSEP);
        k++; i++;
    }
    i=P*I;
    //cout<<"Constraint check 3 (18)=="<<i<<endl;
    
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        g[i] = x[(j*3)] + x[(j*3)+1] + x[(j*3)+2];
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i++;
    }
    i=P*I+I;
    //cout<<"Constraint check 4 ()=="<<i<<endl;
    //cout<<"Constraint check (42)=="<<i<<endl; 
    
   
    
    //-------------------------SUBSEA WELL--------------------------------   
    //Subsea Manifold 1 Well Pressure Balance: (7) in Problem Description File
    k = 132;
    i1 = 142;
    i2 = 18;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<1<<" "<<i1<<" "<<-1<<" "<<i2<<" "<<-minmax_p[0][3][1]<<endl;
    	g[i] = x[k] - x[i1]+(minmax_p[0][3][1]*(1-x[i2])); //printf("%-4d %-6.2f >= %-6.2f", j,x[k], x[i1]*x[i2]);
        i2++;
        //cout<<"Betingelse: "<<i+J1<<" Variabel: "<<k<<" "<<1<<" "<<i1+1<<" "<<-1<<" "<<i2<<" "<<-minmax_p[1][3][1]<<endl;
        g[i+J1] = x[k] - x[i1+1] +(minmax_p[1][3][1]*(1-x[i2])); //printf(" ---  %-6.2f >= %-6.2f\n", x[k], x[i1+1]*x[i2]);
        i2++;    
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i++; k++;
    }
    //cout<<"Constraint check 7 ()=="<<i<<endl;
    i=P*I+I+(2*J1);
    //cout<<"Constraint check 7 ()=="<<i<<endl;
    
    //Subsea Manifold 2 Well Pressure Balance: (7) in Problem Description File
    k = 138;
    i1 = 144;
    i2 = 30;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<1<<" "<<i1<<" "<<-1<<" "<<i2<<" "<<-minmax_p[0][2][1]<<endl;
    	g[i] = x[k] - x[i1] + (minmax_p[2][3][1]*(1-x[i2])); //printf("%-4d %-6.2f >= %-6.2f", j,x[k], x[i1]*x[i2]);
        i2++;
        //cout<<"Betingelse: "<<i+J2<<" Variabel: "<<k<<" "<<1<<" "<<i1+1<<" "<<-1<<" "<<i2<<" "<<-minmax_p[3][3][1]<<endl;
        g[i+J2] = x[k] - x[i1+1] + (minmax_p[3][3][1]*(1-x[i2])); //printf(" ---  %-6.2f >= %-6.2f\n", x[k], x[i1+1]*x[i2]);
        i2++;     
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i++; k++;
    }
    //cout<<"Constraint check 7 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2); //3*6+6+2*6+2*4
    //cout<<"Constraint check 7 ()=="<<i<<endl;
    
    //Subsea Routing: (8) in Problem Description File
    k=18;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){ 
        g[i] = x[k] + x[k+1]; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k=k+2; i++;
    }
    //cout<<"Constraint check 8 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2;
    //cout<<"Constraint check 8 ()=="<<i<<endl;
    
    //-------------------------CAPACITIES--------------------------------

    //cout<<"Gas Lift Capacity: (12) in Problem Description File"<<endl;
    g[i]=   x[98]+ x[99] + x[100] + x[101]
            + x[102] + x[103] + x[104]+ x[105]
            + x[106] + x[107] + x[108] + x[109]
            + x[110]+ x[111] + x[112] + x[113];
    //cout<<g[i]<<endl;
    i++;
    //cout<<"Constraint check 12 ()=="<<i<<endl;
    
    //cout<<"Gas Production Capacity: (13) in Problem Description File"<<endl;
    g[i]=    x[114]+x[115]+x[120]+x[121]
            + x[300] + x[301] + x[302];
    //cout<<g[i]<<endl;      
    i++;        
    //cout<<"Constraint check 13 ()=="<<i<<endl;
    
    //Water Production Capacity: (14) in Problem Description File
    
    //Separator A
    //cout<<"Water Production Capacity Separator A: (14) in Problem Description File"<<endl;
    g[i]=   x[306] + x[315] + x[324];
    //cout<<g[i]<<endl;
    i++;
    
    //Separator B
    //cout<<"Water Production Capacity Separator B: (14) in Problem Description File"<<endl;
    g[i]=   x[307] + x[316] + x[325];
    //cout<<g[i]<<endl;
    i++;
    
    //Separator C
    //cout<<"Water Production Capacity Separator C: (14) in Problem Description File"<<endl;
    g[i]=   x[308] + x[317] + x[326];
    //cout<<g[i]<<endl;
    i++;
     //cout<<"g["<<i<<"]:"<<g[i]<<endl;      
    //cout<<"Constraint check 14 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5;
    //cout<<"Constraint check 14 ()=="<<i<<endl; 
    //-------------------------SEPARATORS--------------------------------
    
    //cout<<"Separator Pressure Balance: (10) in Problem Description File"<<endl;
    k=146;
    i2=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
    	g[i] = x[k] - (x[i2]*PSEPA); i2++;  i++;
        g[i] = x[k] - (x[i2]*PSEPB); i2++;  i++;
        g[i] = x[k] - (x[i2]*PSEPC); i2++;  i++;
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;
    }
    //cout<<"Constraint check 10 ()=="<<i<<endl;
    //cout<<"Separator Routing: (11) in Problem Description File"<<endl;
    k=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        g[i] = x[k] + x[k+1] + x[k+2];
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k=k+3;
        i++;
    }
    
    //cout<<"Constraint check 11 ()=="<<i<<endl; 
        
    //-------------------------MASS BALANCE--------------------------------
    
       
   // cout<<" Subsea Well to Pipelines - Linearization Mass Balance: (15) in Problem Description File"<<endl;
    // Subsea Manifold 1
    k=150;   i1=18;   i2=68; 
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        g[i] = - x[i2] + x[k] + x[k+i1]; i++; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        g[i] = - x[i2+J1] + x[k+J1] + x[k+i1+J1]; i++;
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        g[i] = - x[i2+2*J1] + x[k+2*J1] + x[k+i1+2*J1]; i++;    
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i2++; k++;
    }
    //cout<<"Constraint check 15 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1;
    //cout<<"Constraint check 15 ()=="<<i<<endl;
    
    // Subsea Manifold 2
    k=186;   i1=12;   i2=86;
    s=0;
    e=J2;  
    for(int j = s; j < e ; j++){
        g[i] = - x[i2] + x[k] + x[k+i1]; i++; 
        g[i] = - x[i2+J2] + x[k+J2] + x[k+i1+J2]; i++;
        g[i] = - x[i2+2*J2] + x[k+2*J2] + x[k+i1+2*J2]; i++;    
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i2++; k++;
    }
    //cout<<"Constraint check 15 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2; 
    //cout<<"Constraint check 15 ()=="<<i<<endl;

    // Linearization Mass Balance: (16 og 17) in Problem Description File 
    


// Subsea Manifold 1 - Line 1
    k=150;   i1=18;
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        g[i] = - x[k] + ((minmax_w[I+j][2][1]*wellspecJ[j][1]+minmax_gl[I+j][1])*x[i1]); i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k+J1] + (minmax_w[I+j][2][1]*x[i1]); i++;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+J1<<" "<<i1<<endl;
        g[i] = - x[k+2*J1] +  (minmax_w[I+j][2][1]*(wellspecJ[j][0]/(1-wellspecJ[j][0]))* x[i1]); i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<" "<<k+2*J1<<" "<<i1<<endl;
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+2; k++;
    } 
   
    

//cout<<"Constraint check 16/17 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1;
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;
    


// Subsea Manifold 1 - Line 2
    k=168;   i1=19;  
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + ((minmax_w[I+j][2][1]*wellspecJ[j][1]+minmax_gl[I+j][1])*x[i1]); i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+J1<<" "<<i1<<endl;
        g[i] = - x[k+J1] + (minmax_w[I+j][2][1]*x[i1]); i++;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*J1<<" "<<i1<<endl;
        g[i] = - x[k+2*J1] +  (minmax_w[I+j][2][1]*(wellspecJ[j][0]/(1-wellspecJ[j][0]))* x[i1]); i++; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+2; k++;
    }
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1; 
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;
    
    // Subsea Manifold 2 - Line 3
    k=186;   i1=30;   
    s=0;
    e=J2;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<(minmax_w[I+J1+j][2][1]*wellspecJ[j][0]+minmax_gl[I+J1+j][1])<<endl;
        g[i] = - x[k] + ((minmax_w[I+J1+j][2][1]*wellspecJ[j+J1][1]+minmax_gl[I+J1+j][1])*x[i1]); i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<minmax_w[I+J1+j][2][1]<<endl;
        g[i] = - x[k+J2] + (minmax_w[I+J1+j][2][1]*x[i1]); i++;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<minmax_w[I+J1+j][2][1]*(wellspecJ[j][1]/(1-wellspecJ[j][1]))<<endl;
        g[i] = - x[k+2*J2] +  (minmax_w[I+J1+j][2][1]*(wellspecJ[j+J1][0]/(1-wellspecJ[j+J1][0]))* x[i1]); i++; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+2; k++;
    } 
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2; 
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;
    
    // Subsea Manifold 2 - Line 4
    k=198;   i1=31;    
    s=0;
    e=J2;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<(minmax_w[I+J1+j][2][1]*wellspecJ[j][0]+minmax_gl[I+J1+j][1])<<endl;
        g[i] = - x[k] + ((minmax_w[I+J1+j][2][1]*wellspecJ[j+J1][1]+minmax_gl[I+J1+j][1])*x[i1]); i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<minmax_w[I+J1+j][2][1]<<endl;
        g[i] = - x[k+J2] + (minmax_w[I+J1+j][2][1]*x[i1]); i++;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<minmax_w[I+J1+j][2][1]*(wellspecJ[j][1]/(1-wellspecJ[j][1]))<<endl;
        g[i] = - x[k+2*J2] +  (minmax_w[I+J1+j][2][1]*(wellspecJ[j+J1][0]/(1-wellspecJ[j+J1][0]))* x[i1]); i++; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+2; k++;
    }
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2; 
    //cout<<"Constraint check 16/17 ()=="<<i<<endl;

    // Linearization Mass Balance: (18) in Problem Description File  
    // Subsea Manifold 1
    k=114;   i1=150;   i2=2;
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k]+x[i1]+x[i1+1]+x[i1+2]+x[i1+3]+x[i1+4]+x[i1+5]; i++; i1=i1+6;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+i2]+x[i1]+x[i1+1]+x[i1+2]+x[i1+3]+x[i1+4]+x[i1+5]; i++; i1=i1+6;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+2*i2]+x[i1]+x[i1+1]+x[i1+2]+x[i1+3]+x[i1+4]+x[i1+5]; i++; i1=i1+6;   
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;
    }
    //cout<<"Constraint check 18 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1;
    //cout<<"Constraint check 18 ()=="<<i<<endl;
    
    // Subsea Manifold 2
    k=120;   i1=186;   i2=2;
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        // cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k]+x[i1]+x[i1+1]+x[i1+2]+x[i1+3]; i++; i1=i1+4;
        // cout<<"Betingelse: "<<i<<" Variabel: "<<k+i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+i2]+x[i1]+x[i1+1]+x[i1+2]+x[i1+3]; i++; i1=i1+4;
        // cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+2*i2]+x[i1]+x[i1+1]+x[i1+2]+x[i1+3]; i++; i1=i1+4;   
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;
    }
    //cout<<"Constraint check 18 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2;
    //cout<<"Constraint check 18 ()=="<<i<<endl;
    
    // Subsea Pipeline to Separator - Linearization Mass Balance: (19) in Problem Description File 
    
    // Subsea Manifold 1
    k=114;   i1=210;   i2=2;
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k]+x[i1]+x[i1+1]+x[i1+2]; i++; i1=i1+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+i2]+x[i1]+x[i1+1]+x[i1+2]; i++; i1=i1+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+2*i2]+x[i1]+x[i1+1]+x[i1+2]; i++; i1=i1+3;  
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;
    }
    //cout<<"Constraint check 19 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1; 
    //cout<<"Constraint check 19 ()=="<<i<<endl;
    
    // Subsea Manifold 2
    k=120;   i1=228;   i2=2;
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k]+x[i1]+x[i1+1]+x[i1+2]; i++; i1=i1+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+i2]+x[i1]+x[i1+1]+x[i1+2]; i++; i1=i1+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i2<<" "<<i1<<" "<<i1+1<<" "<<i1+2<<" "<<endl;
        g[i] = -x[k+2*i2]+x[i1]+x[i1+1]+x[i1+2]; i++; i1=i1+3;   
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;
    }
    //cout<<"Constraint check 19 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2;  
    //cout<<"Constraint check 19 ()=="<<i<<endl;
    
    // Linearization Mass Balance: (20) in Problem Description File  
    // Subsea Manifold 1 - Separator 1
    k=210;   i1=38;  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][0][1]*x[i1]; i++;k=k+3; //gas
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][1][1]*x[i1]; i++;k=k+3; //oil
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][2][1]*x[i1]; i++;k=k+3; //water
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+3;
    }  
    
    // Subsea Manifold 1 - Separator 2  
    k=211;   i1=39;  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][0][1]*x[i1]; i++;k=k+3; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][1][1]*x[i1]; i++;k=k+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][2][1]*x[i1]; i++;k=k+3; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        
        i1=i1+3;
    }  
    
    // Subsea Manifold 1 - Separator 3
    k=212;   i1=40;  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][0][1]*x[i1]; i++;k=k+3; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][1][1]*x[i1]; i++;k=k+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[j][2][1]*x[i1]; i++;k=k+3; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+3;
    }
    //cout<<"Constraint check 20 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1;  
    //cout<<"Constraint check 20 ()=="<<i<<endl;
    
    // Subsea Manifold 2 - Separator 1
    k=228;   i1=44;  
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][0][1]*x[i1]; i++;k=k+3; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][1][1]*x[i1]; i++;k=k+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][2][1]*x[i1]; i++;k=k+3; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+3;
    }  
    
    // Subsea Manifold 2 - Separator 2 
    k=229;   i1=45;  
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][0][1]*x[i1]; i++;k=k+3; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][1][1]*x[i1]; i++;k=k+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][2][1]*x[i1]; i++;k=k+3; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        
        i1=i1+3;
    }  
    
    // Subsea Manifold 2 - Separator 3
    k=230;   i1=46;  
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][0][1]*x[i1]; i++;k=k+3; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][1][1]*x[i1]; i++;k=k+3;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + minmax_p[L1+j][2][1]*x[i1]; i++;k=k+3; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        i1=i1+3;
    } 
    //cout<<"Constraint check 20 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S; 
    //cout<<"Constraint check 20 ()=="<<i<<endl;
    
    
    // Linearization Mass Balance: (21) in Problem Description File   
    // Subsea Manifold 1
    k=309;   i1=210;  i2=219; i3=3;
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i2<<endl;
        g[i] = - x[k] + x[i1] + x[i2]; i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+i3<<" "<<i1+i3<<" "<<i2+i3<<endl;
        g[i] = - x[k+i3] + x[i1+i3] + x[i2+i3]; i++;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i3<<" "<<i1+2*i3<<" "<<i2+2*i3<<endl;
        g[i] = - x[k+2*i3] + x[i1+2*i3] + x[i2+2*i3]; i++;   
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;i1++;i2++;
    }
    
    // Subsea Manifold 2
    k=318;   i1=228;  i2=237; i3=3;
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i2<<endl;
        g[i] = - x[k] + x[i1] + x[i2]; i++; 
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+i3<<" "<<i1+i3<<" "<<i2+i3<<endl;
        g[i] = - x[k+i3] + x[i1+i3] + x[i2+i3]; i++;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i3<<" "<<i1+2*i3<<" "<<i2+2*i3<<endl;
        g[i] = - x[k+2*i3] + x[i1+2*i3] + x[i2+2*i3]; i++;    
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;i1++;i2++;
    }
    //cout<<"Constraint check 21 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M; 
    //cout<<"Constraint check 21 ()=="<<i<<endl; 
    


// Topsde Well To Separator - Linearization Mass Balance: (22) in Problem Description File         
        
    k=50;   i1=246;  i2=1; i3=1;
    s=0;
    e=I;  
    for(int j = s; j < e; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i1+i2<<" "<<i1+i2+i3<<endl;
        g[i] = - x[k] + x[i1] + x[i1+i2] + x[i1+i2+i3]; i++; i1=i1+i2+i3+1;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+I<<" "<<i1<<" "<<i1+i2<<" "<<i1+i2+i3<<endl;
        g[i] = - x[k+I] + x[i1] + x[i1+i2] + x[i1+i2+i3]; i++; i1=i1+i2+i3+1;
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*I<<" "<<i1<<" "<<i1+i2<<" "<<i1+i2+i3<<endl;
        g[i] = - x[k+2*I] + x[i1] + x[i1+i2] + x[i1+i2+i3]; i++; i1=i1+i2+i3+1;   
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++;
    }
    //cout<<"Constraint check 22 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I;  
	//cout<<"Constraint check 22 ()=="<<i<<endl;
// Linearization Mass Balance: (23+24) in Problem Description File         
        
    // Separator 1
    k=246;   i1=0;  i2=3; i3=3;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
        // cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + ((minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1])*x[i1]); i++; 
        //cout<<"Max Gas "<<(minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1])*x[i1]<<endl;
        // cout<<"Betingelse: "<<i<<" Variabel: "<<k+i3<<" "<<i1<<endl;
        g[i] = - x[k+i3] + (minmax_w[j][2][1]*x[i1]); i++;
        //cout<<"Max Oil "<<minmax_w[j][2][1]*x[i1]<<endl;
        // cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i3<<" "<<i1<<endl;
        g[i] = - x[k+2*i3] +  (minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]))* x[i1]); i++; 
        //cout<<"Max Water "<<  minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]))* x[i1]<<endl;      
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k=k+3*i3; i1=i1+i2;
    }   
    
    // Separator 2
    k=247;   i1=1;  i2=3; i3=3;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
       // cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + ((minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1])*x[i1]); i++; 
       // cout<<"Betingelse: "<<i<<" Variabel: "<<k+i3<<" "<<i1<<endl;
        g[i] = - x[k+i3] + (minmax_w[j][2][1]*x[i1]); i++;
       // cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i3<<" "<<i1<<endl;
        g[i] = - x[k+2*i3] +  (minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]))* x[i1]); i++; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k=k+3*i3; i1=i1+i2;
    } 
    
    
    // Separator 3
    k=248;   i1=2;  i2=3; i3=3;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
      //  cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<endl;
        g[i] = - x[k] + ((minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1])*x[i1]); i++; 
      //  cout<<"Betingelse: "<<i<<" Variabel: "<<k+i3<<" "<<i1<<endl;
        g[i] = - x[k+i3] + (minmax_w[j][2][1]*x[i1]); i++;
      //  cout<<"Betingelse: "<<i<<" Variabel: "<<k+2*i3<<" "<<i1<<endl;
        g[i] = - x[k+2*i3] +  (minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]))* x[i1]); i++; 
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k=k+3*i3; i1=i1+i2;
    }
    //cout<<"Constraint check 23/24 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P;  
    //cout<<"Constraint check 23/24 ()=="<<i<<endl;
    
    // Linearization Mass Balance: (25) in Problem Description File   
    k=300;   i1=246;  i2=9; i3=3;
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<i1<<" "<<i1+i2<<endl;
        g[i] = - x[k] + x[i1] + x[i1+i2] + x[i1+2*i2] + x[i1+3*i2] + x[i1+4*i2] + x[i1+5*i2]; i++;
        //cout<<"Variabel: "<<k<<" Verdi"<< x[i1] + x[i1+i2] + x[i1+2*i2] + x[i1+3*i2] + x[i1+4*i2] + x[i1+5*i2]<<endl;
        g[i] = - x[k+i3] + x[i1+i3] + x[i1+i2+i3] + x[i1+2*i2+i3] + x[i1+3*i2+i3] + x[i1+4*i2+i3] + x[i1+5*i2+i3]; i++; 
        //cout<<"Variabel: "<<k+i3<<" Verdi"<<x[i1+i3] + x[i1+i2+i3] + x[i1+2*i2+i3] + x[i1+3*i2+i3] + x[i1+4*i2+i3] + x[i1+5*i2+i3]<<endl;
        g[i] = - x[k+2*i3] + x[i1+2*i3] + x[i1+i2+2*i3] + x[i1+2*i2+2*i3] + x[i1+3*i2+2*i3] + x[i1+4*i2+2*i3] + x[i1+5*i2+2*i3]; i++;
        //cout<<"Variabel: "<<k+2*i3<<" Verdi"<<x[i1+2*i3] + x[i1+i2+2*i3] + x[i1+2*i2+2*i3] + x[i1+3*i2+2*i3] + x[i1+4*i2+2*i3] + x[i1+5*i2+2*i3]<<endl;
       
//         cout<<"Variabel: "<<i1+2*i3<<"Verdi "<<x[i1+2*i3]<<endl;
//         cout<<"Variabel: "<<i1+i2+2*i3<<"Verdi "<<x[i1+i2+2*i3]<<endl;
//         cout<<"Variabel: "<<i1+2*i2+2*i3<<"Verdi "<<x[i1+2*i2+2*i3]<<endl; 
//         cout<<"Variabel: "<<i1+3*i2+2*i3<<"Verdi "<<x[i1+3*i2+2*i3]<<endl; 
//         cout<<"Variabel: "<<i1+4*i2+2*i3<<"Verdi "<<x[i1+4*i2+2*i3]<<endl;
//         cout<<"Variabel: "<<i1+5*i2+2*i3<<"Verdi "<<x[i1+5*i2+2*i3]<<endl;
      
        
        k++;i1++;
    }
    //cout<<"Constraint check 25 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P;  
    //cout<<"Constraint check 25 ()=="<<i<<endl;    

        
    //-------------------------TOPSIDE WELLS----------------------------- 
    //Gas and Water production
    //Topside Well Models: (2) a-b-c in Problem Description File
    k=50;   //q^WI_ip
    i1=48;  //q^GL_i
    i2=76;  //p^WI_i
    e=I;
        //printf("(2) Gas and Water Production Topside \n");
        //printf("%-5s %-15s %-15s %-15s \n", "Well", "Gas", "Oil", "Water");
    for(int j = s; j < e ; j++){    
        //cout<<"Betingelse: "<<i<<" Variabel: "<<wellspecI[j][1]<<endl;
        g[i] = x[k] - (wellspecI[j][1]*x[k+I] + x[k+i1]);                        //2b - gas
        //cout<<"Betingelse: "<<i+I<<" Variabel: "<<" 1"<<" "<<wellspecI[j][0]/(1-wellspecI[j][0])<<endl;
        g[i+I] = x[k+2*I] - (x[k+I]*(wellspecI[j][0]/(1-wellspecI[j][0])));    //2c - water  
        //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+I, g[i+I], i+2*I, g[i+2*I]);
       //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++; i++;
    }
    //cout<<"Constraint check 2 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2;  
    //cout<<"Constraint check 2 ()=="<<i<<endl;
   


    //-------------------------SUBSEA WELLS-------------------------------
    //Gas and Water production
    //Subsea Manifold 1 Well Models: (5) a, c in Problem Description File
    k=68;
    i1=36;
    i2=64;
    s=0;
    e=J1;
            //printf("(4) Gas and Water Production Subsea \n");
            //printf("%-5s %-15s %-15s %-15s \n", "Well", "Gas", "Oil", "Water");    
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<k+J1<<" "<<k+i1<<endl;
        g[i] = x[k] - (wellspecJ[j][1]*x[k+J1] + x[k+i1]);                         //4b - gas
        //cout<<"Betingelse: "<<i+J1<<" Variabel: "<<k+2*J1<<" "<<k+J1<<endl;
        g[i+J1] = x[k+(2*J1)] - (x[k+J1]*(wellspecJ[j][0]/(1-wellspecJ[j][0]))); //4c - water
        
            //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+J, g[i+J], i+2*J, g[i+2*J]);
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++; i++;
    }
    //cout<<"Constraint check 5 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2;  
    //cout<<"Constraint check 5 ()=="<<i<<endl;
    
    //Subsea Manifold 2 Well Models: (5) a, c in Problem Description File
    k=86;
    i1=24;
    i2=52;
    s=J1;
    e=J;
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<i<<" Variabel: "<<k<<" "<<k+J2<<" "<<k+i1<<endl;
        g[i] = x[k] - (wellspecJ[j][1]*x[k+J2] + x[k+i1]);        
        //cout<<"Betingelse: "<<i+J2<<" Variabel: "<<k+2*J2<<" "<<k+J2<<endl;//4b - gas
        g[i+J2] = x[k+(2*J2)] - (x[k+J2]*(wellspecJ[j][0]/(1-wellspecJ[j][0])));   //4c - water
        
            //printf("%-5d g[%d]=%-10.2f g[%d]=%-10.2f g[%d]=%-10.2f \n", j, i, g[i], i+J, g[i+J], i+2*J, g[i+2*J]);
        //cout<<"g["<<i<<"]:"<<g[i]<<endl;
        k++; i++;
    }
    //cout<<"Constraint check 5 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2+J2*2;  
    //cout<<"Constraint check 5 ()=="<<i<<endl;
        
        
        
        
    //-------------------------TOPSIDE WELLS-----------------------------       
        
    //Well Model:  26(a)
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=56; i1=126; i2=98;
          //if(j==2){
          //cout<<"Tangent [0][2][j]"<<tangent_w [0][2][j]<<endl;
          g[i]=-x[k]+tangent_w [0][2][j]+(tangent_jacw [0][0][j]*(x[i1]-tangent_w [0][0][j]))+(tangent_jacw [0][1][j]*(x[i2]-tangent_w [0][1][j]));i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [1][2][j]+(tangent_jacw [1][0][j]*(x[i1]-tangent_w [1][0][j]))+tangent_jacw [1][1][j]*(x[i2]-tangent_w [1][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [2][2][j]+(tangent_jacw [2][0][j]*(x[i1]-tangent_w [2][0][j]))+tangent_jacw [2][1][j]*(x[i2]-tangent_w [2][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [3][2][j]+(tangent_jacw [3][0][j]*(x[i1]-tangent_w [3][0][j]))+tangent_jacw [3][1][j]*(x[i2]-tangent_w [3][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [4][2][j]+(tangent_jacw [4][0][j]*(x[i1]-tangent_w [4][0][j]))+tangent_jacw [4][1][j]*(x[i2]-tangent_w [4][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [5][2][j]+(tangent_jacw [5][0][j]*(x[i1]-tangent_w [5][0][j]))+tangent_jacw [5][1][j]*(x[i2]-tangent_w [5][1][j]); i++;
          // cout<<"g["<<i<<"]:"<<g[i]<<endl;
}
          
    
    
       //for(int j=0; j<2; j++){
       //cout<<"Oil Production"<<tangent_w [0][2][j]+(tangent_jacw [0][0][j]*(x[i1]-tangent_w [0][0][j]))+(tangent_jacw [0][1][j]*(x[i2]-tangent_w [0][1][j]))<<endl;
       //}  
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Well Model:  26(b)
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=74; i1=132; i2=104;
          g[i]=-x[k]+tangent_w [6][2][j]+tangent_jacw [6][0][j]*(x[i1]-tangent_w [6][0][j])+tangent_jacw [6][1][j]*(x[i2]-tangent_w [6][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [7][2][j]+tangent_jacw [7][0][j]*(x[i1]-tangent_w [7][0][j])+tangent_jacw [7][1][j]*(x[i2]-tangent_w [7][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [8][2][j]+tangent_jacw [8][0][j]*(x[i1]-tangent_w [8][0][j])+tangent_jacw [8][1][j]*(x[i2]-tangent_w [8][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [9][2][j]+tangent_jacw [9][0][j]*(x[i1]-tangent_w [9][0][j])+tangent_jacw [9][1][j]*(x[i2]-tangent_w [9][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [10][2][j]+tangent_jacw [10][0][j]*(x[i1]-tangent_w [10][0][j])+tangent_jacw[10][1][j]*(x[i2]-tangent_w [10][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [11][2][j]+tangent_jacw [11][0][j]*(x[i1]-tangent_w [11][0][j])+tangent_jacw [11][1][j]*(x[i2]-tangent_w [11][1][j]); i++;
          //cout<<"g["<<i<<"]:"<<g[i]<<endl;
    } 
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=90; i1=138; i2=110;
          g[i]=-x[k]+tangent_w [12][2][j]+tangent_jacw [12][0][j]*(x[i1]-tangent_w [12][0][j])+tangent_jacw [12][1][j]*(x[i2]-tangent_w [12][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [13][2][j]+tangent_jacw [13][0][j]*(x[i1]-tangent_w [13][0][j])+tangent_jacw [13][1][j]*(x[i2]-tangent_w [13][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [14][2][j]+tangent_jacw [14][0][j]*(x[i1]-tangent_w [14][0][j])+tangent_jacw [14][1][j]*(x[i2]-tangent_w [14][1][j]); i++; k++; i1++; i2++;
          g[i]=-x[k]+tangent_w [15][2][j]+tangent_jacw [15][0][j]*(x[i1]-tangent_w [15][0][j])+tangent_jacw [15][1][j]*(x[i2]-tangent_w [15][1][j]); i++; 
          //cout<<"g["<<i<<"]:"<<g[i]<<endl;  
    }
    //cout<<"Constraint check 26 ()=="<<i<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2+J2*2+(I+J)*MaxIt;  
    //cout<<"Constraint check 26 ()=="<<i<<endl;  
    


   //-------------------------PIPELINES-------------------------------
   //Pressure Drop:  27  
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=146; i1=114; i2=116; i3=118;
          g[i]=+x[k]-x[142]+tangent_p [0][3][j]+tangent_jacp [0][0][j]*(x[i1]-tangent_p [0][0][j])+tangent_jacp [0][1][j]*(x[i2]-tangent_p [0][1][j])+tangent_jacp [0][2][j]*(x[i3]-tangent_p [0][2][j]); i++; k++; i1++; i2++; i3++;
          g[i]=+x[k]-x[143]+tangent_p [1][3][j]+tangent_jacp [1][0][j]*(x[i1]-tangent_p [1][0][j])+tangent_jacp [1][1][j]*(x[i2]-tangent_p [1][1][j])+tangent_jacp [1][2][j]*(x[i3]-tangent_p [1][2][j]); i++; 
          //cout<<"g["<<i<<"]:"<<g[i]<<endl;
    }
    //cout<<"tangent:" <<tangent_p [0][3][It_nlp]+tangent_jacp [0][0][It_nlp]*(x[i1]-tangent_p [0][0][It_nlp])+tangent_jacp [0][1][It_nlp]*(x[i2]-tangent_p [0][1][It_nlp])+tangent_jacp [0][2][It_nlp]*(x[i3]-tangent_p [0][2][It_nlp]); i++; k++; i1++; i2++; i3++;
         
    //for (int j=0; j<2; j++){
     //cout<<"Pressure Drop Line 1 ()=="<<tangent_p [0][3][j]+tangent_jacp [0][0][j]*(x[i1]-tangent_p [0][0][j])+tangent_jacp [0][1][j]*(x[i2]-tangent_p [0][1][j])+tangent_jacp [0][2][j]*(x[i3]-tangent_p [0][2][j])<<endl;
     //cout<<"Pressure Drop Line 2 ()=="<<tangent_p [1][3][j]+tangent_jacp [1][0][j]*(x[i1]-tangent_p [1][0][j])+tangent_jacp [1][1][j]*(x[i2]-tangent_p [1][1][j])+tangent_jacp [1][2][j]*(x[i3]-tangent_p [1][2][j])<<endl;
    //}
    
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2+J2*2+(I+J)*MaxIt+L1*MaxIt;  
    //cout<<"Constraint check 27 ()=="<<i<<endl;
    
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
     k=148; i1=120; i2=122; i3=124;
     g[i]=+x[k]-x[144]+tangent_p [2][3][j]+tangent_jacp [2][0][j]*(x[i1]-tangent_p [2][0][j])+tangent_jacp [2][1][j]*(x[i2]-tangent_p [2][1][j])+tangent_jacp [2][2][j]*(x[i3]-tangent_p [2][2][j]); i++; k++; i1++; i2++; i3++;
     g[i]=+x[k]-x[145]+tangent_p [3][3][j]+tangent_jacp [3][0][j]*(x[i1]-tangent_p [3][0][j])+tangent_jacp [3][1][j]*(x[i2]-tangent_p [3][1][j])+tangent_jacp [3][2][j]*(x[i3]-tangent_p [3][2][j]); i++; 
    }
     
    //cout<<"tangent: "<<tangent_p [3][3][It_nlp]+tangent_jacp [3][0][It_nlp]*(x[i1]-tangent_p [3][0][It_nlp])+tangent_jacp [3][1][It_nlp]*(x[i2]-tangent_p [3][1][It_nlp])+tangent_jacp [3][2][It_nlp]*(x[i3]-tangent_p [3][2][It_nlp])<<endl;
    
    //for (int j=0; j<2; j++){ 
    //cout<<"Pressure Drop Line 3 ()=="<<tangent_jacp [2][0][j]*(x[i1]-tangent_p [2][0][j])+tangent_jacp [2][1][j]*(x[i2]-tangent_p [2][1][j])+tangent_jacp [2][2][j]*(x[i3]-tangent_p [2][2][j])<<endl;
    //cout<<"Pressure Drop Line 4 ()=="<<tangent_jacp [3][0][j]*(x[i1]-tangent_p [3][0][j])+tangent_jacp [3][1][j]*(x[i2]-tangent_p [3][1][j])+tangent_jacp [3][2][j]*(x[i3]-tangent_p [3][2][j])<<endl;
    //}
   
   //New Binary variables for objective function:  (28) in description file
   k=0; 
   i1=327;
   i2=328;
   s=0;
   e=NB;
   for(int j = s; j < e ; j++){
       g[i]=x[k]-Parameter_f[j]-x[i1]+x[i2];
       i++;
       k++;
       //cout<<"x["<<i1<<"]: "<<x[i1]<<endl;
       //cout<<"x["<<i2<<"]: "<<x[i2]<<endl;
       i1=i1+2;
       i2=i2+2;
       Parameter_f[j];
   //cout<<"g["<<i<<"]:"<<g[i]<<endl;
    } 
    
 
   
   ofstream myfile ("CONSTRAINTS.txt");   
   if (myfile.is_open()){ 
    s=0; //start value for loops
    e=0; //end value for loops
    //-------------------------TOPSIDE WELLS-----------------------------

    
    //Topside Well Pressure Balance: (3) in Problem Description File
    s=e;
    e=P*I;
    for(int i = s; i < e ; i++){
          myfile<<"Cinstraints (3) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(18) "<<e<<endl;
    //Topside Well Routing: (4) in Problem Description File
    s=e;
    e=P*I+I;
    for(int i = s; i < e ; i++){
         myfile<<"Cinstraints (4) "<<endl;
         myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(24) "<<e<<endl;
   
    
    //-------------------------SUBSEA WELL--------------------------------   
    //Subsea Well Pressure Balance: (7) in Problem Description File
    s=e;
    e=s+(2*J);
    for(int i = s; i < e ; i++){
          myfile<<"Cinstraints (7) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(44) "<<e<<endl;
    
    //Subsea Routing: (8) in Problem Description File
    s=e;
    e=s+J;
    for(int i = s; i < e ; i++){
         myfile<<"Cinstraints (8) "<<endl;
         myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(54) "<<e<<endl;
    
    //-------------------------CAPACITIES--------------------------------
    
    //Gas Lift Capacity: (12) in Problem Description File
     myfile<<"Cinstraints (12) "<<endl;
     myfile<<"g["<<e<<"] = "<<g[e]<<endl;
    e++;
    //cout<<"e(55) "<<e<<endl;
    
    //Gas Production Capacity: (13) in Problem Description File
     myfile<<"Cinstraints (13) "<<endl;
     myfile<<"g["<<e<<"] = "<<g[e]<<endl;
    e++;
    //cout<<"e(56) "<<e<<endl;
    
    //Water Production Capacity: (14) in Problem Description File
     myfile<<"Cinstraints (14) "<<endl;
     myfile<<"g["<<e<<"] = "<<g[e]<<endl;
    e++;
     myfile<<"Cinstraints (14) "<<endl;
     myfile<<"g["<<e<<"] = "<<g[e]<<endl;
    e++;
     myfile<<"Cinstraints (14) "<<endl;
     myfile<<"g["<<e<<"] = "<<g[e]<<endl;
    e++;
    //cout<<"e(59) "<<e<<endl;

    //-------------------------SEPARATORS--------------------------------
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=e;
     e=s+(L*S);
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (10) "<<endl;
           myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(71) "<<e<<endl;
    
    //Separator Routing: (11) in Problem Description File
    s=e;
    e=s+L;
    for(int i = s; i < e ; i++){
         myfile<<"Cinstraints (11) "<<endl;
         myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(75) "<<e<<endl;
    
        
    //-------------------------MASS BALANCE--------------------------------
    
       
    //cout<<"Subsea Well to Pipelines - Linearization Mass Balance: (15) in Problem Description File"<<endl;
    // Subsea Manifold 1
    s=e;
    e=s+P*J1;  
    for(int i = s; i < e ; i++){
       myfile<<"Cinstraints (15) "<<endl;
       myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
  
    // Subsea Manifold 2
    s=e;
    e=s+P*J2;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (15) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(105) "<<e<<endl;
    //cout<< "Linearization Mass Balance: (16 og 17) in Problem Description File "<<endl;
    // Subsea Manifold 1 - Line 1
    s=e;
    e=s+P*J1;  
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (16/17) "<<endl;
           myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    // Subsea Manifold 1 - Line 2
    s=e;
    e=s+P*J1;  
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (16/17) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
 
    // Subsea Manifold 2 - Line 3
    s=e;
    e=s+P*J2;  
    for(int i = s; i < e ; i++){
          myfile<<"Cinstraints (16/17) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}

    
    // Subsea Manifold 2 - Line 4
    s=e;
    e=s+P*J2;  
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (16/17) "<<endl;
           myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(165) "<<e<<endl;
    
    // Linearization Mass Balance: (18) in Problem Description File  
    // Subsea Manifold 1
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
       myfile<<"Cinstraints (18) "<<endl;
       myfile<<"g["<<i<<"] = "<<g[i]<<endl;}

    // Subsea Manifold 2
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
       myfile<<"Cinstraints (18) "<<endl;
       myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(177) "<<e<<endl;
    
    // Subsea Pipeline to Separator - Linearization Mass Balance: (19) in Problem Description File 
    
    // Subsea Manifold 1
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
       myfile<<"Cinstraints (19) "<<endl;
          myfile<<"g["<<i<<"]"<<endl;}
    
    
    // Subsea Manifold 2
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
       myfile<<"Cinstraints (19) "<<endl;
       myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(189) "<<e<<endl;
    
    // Linearization Mass Balance: (20) in Problem Description File  
    // Subsea Manifold 1 - Separator 1
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (20) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    // Subsea Manifold 1 - Separator 2  
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
          myfile<<"Cinstraints (20) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    // Subsea Manifold 1 - Separator 3
    s=e;
    e=s+P*L1;  
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (20) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    // Subsea Manifold 2 - Separator 1
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
         myfile<<"Cinstraints (20) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    // Subsea Manifold 2 - Separator 2 
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
        myfile<<"Cinstraints (20) "<<endl;
          myfile<<"g["<<i<<"]"<<endl;}
    
    // Subsea Manifold 2 - Separator 3
    s=e;
    e=s+P*L2;  
    for(int i = s; i < e ; i++){
           myfile<<"Cinstraints (20) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(225) "<<e<<endl;
    
    // Linearization Mass Balance: (21) in Problem Description File   
    // Subsea Manifold 1
    s=e;
    e=s+P*S;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (21) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    // Subsea Manifold 2
    s=e;
    e=s+P*S;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (21) "<<endl;
          myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(243) "<<e<<endl;
    
    // Topsde Well To Separator - Linearization Mass Balance: (22) in Problem Description File         
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (22) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(261) "<<e<<endl;
    
	// Linearization Mass Balance: (23+24) in Problem Description File         
        
    // Separator 1
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (23/24) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}   
    
    // Separator 2
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
     myfile<<"Cinstraints (23/24) "<<endl;
     myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    
    // Separator 3
    s=e;
    e=s+P*I;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (23/24) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(315) "<<e<<endl; 
    
    // Linearization Mass Balance: (25) in Problem Description File   
    s=e;
    e=s+P*S;  
    for(int i = s; i < e ; i++){
     myfile<<"Cinstraints (25) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    //cout<<"e(324) "<<e<<endl;
        
    //-------------------------TOPSIDE WELLS----------------------------- 
    //Topside Well Models: (2) in Problem Description File
    s=e;
    e=s+I*2;
    for(int i = s; i < e ; i++){	
      myfile<<"Cinstraints (2) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
   //cout<<"e(336) "<<e<<endl;


    //-------------------------SUBSEA WELLS-------------------------------
    //Gas and Water production
    //Subsea Manifold 1 Well Models: (5) a, c in Problem Description File
    s=e;
    e=s+J1*2;  
    for(int i = s; i < e ; i++){
    myfile<<"Cinstraints (5) "<<endl;
    myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    //Subsea Manifold 2 Well Models: (5) a, c in Problem Description File
    s=e;
    e=s+J2*2;  
    for(int i = s; i < e ; i++){
      myfile<<"Cinstraints (5) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}  
    //cout<<"e(356) "<<e<<endl;
     //-------------------------TOPSIDE WELLS-----------------------------       
        
    //Well Model:  26(a)
    s=e;
    e=s+I*MaxIt;
    for(int i = s; i < e ; i++){
          myfile<<"Cinstraints (26) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}  
    //cout<<"e(476) "<<e<<endl;     
      
    //-------------------------SUBSEA WELLS-------------------------------
    
    s=e;
    e=s+J*MaxIt;
    for(int i = s; i < e ; i++){
        myfile<<"Cinstraints (26) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}  
    //cout<<"e(676) "<<e<<endl;
    //-------------------------PIPELINES----------------------------------
     
    s=e;
    e=s+L*MaxIt;
    for(int i = s; i < e ; i++){
         myfile<<"Cinstraints (27) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}  

    
    //-----------------------MILP BINARY FEASIBILITY PUMP---------------------
     
    s=e;
    e=s+NB;
    for(int i = s; i < e ; i++){
        myfile<<"Cinstraints (28) "<<endl;
      myfile<<"g["<<i<<"] = "<<g[i]<<endl;}
    
    
        
        
        myfile.close();
        }
    
  //cout<<"Constraints: "<<i<<endl;  
  //cout<<"ferdig eval_g"<<endl;<<<<<<<<<
  return true;
}

bool
MyTMILP::eval_jac_g(Index n, const Number* x, bool new_x,
                     Index m, Index nnz_jac, Index* iRow, Index *jCol,
                     Number* values){
    
    // send in approaximations of derivatives
    
  assert(n==NV_MILP);
  assert(nnz_jac == 2491);

if(values == NULL) {
//cout<<"Starting eval_jac_g IF LOOP------"<<endl;

    int nz=0; //non-zero counter
    int s=0;  //start value for loops
    int e=0;  //end value for loops
    int i=0;  //constraint counter
    int k=0;
    int i1=0;
    int i2=0;
    int i3=0;
  
    //Topside Well Pressure Balance: (3) in Problem Description File
    k=126;
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){ 
        //cout<<"Constraints: "<<i<<" og variabel: "<<k<<" og: "<<(j*3)<<endl;
        iRow[nz] = i;               //Separator A: g[0] - g[5]
        jCol[nz] = k;       nz++;
        iRow[nz] = i;
        jCol[nz] = (j*3);   nz++;
        k++;    i++;
    }
    k=126;
    for(int j = s; j < e ; j++){    
        //cout<<"Constraints: "<<i<<" og variabel: "<<k<<" og: "<<(j*3)<<endl;
        iRow[nz] = i;           //Separator B: g[6] - g[11]
        jCol[nz] = k;       nz++;
        iRow[nz] = i;
        jCol[nz] = (j*3)+1; nz++;
        k++;    i++;
    }
    k=126;
    for(int j = s; j < e ; j++){    
        //cout<<"Constraints: "<<i<<" og variabel: "<<k<<" og: "<<(j*3)<<endl;
        iRow[nz] = i;       //Separator C: g[12] - g[17]
        jCol[nz] = k;       nz++;
        iRow[nz] = i;
        jCol[nz] = (j*3)+2; nz++;
        k++;    i++;
    }
    i=P*I;
    //cout<<"nz(36)="<<nz<<endl; 
   
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I;
    k=0;
    for(int j = s; j < e ; j++){   //Routing: g[18] - g[35]
        //cout<<"Constraints: "<<i<<" og variabel: "<<k<<endl;
        iRow[nz] = i;
        jCol[nz] = k;   nz++;   k++;
        //cout<<"Constraints: "<<i<<" og variabel: "<<k<<endl;
        iRow[nz] = i;
        jCol[nz] = k;   nz++;   k++;
        //cout<<"Constraints: "<<i<<" og variabel: "<<k<<endl;
        iRow[nz] = i;
        jCol[nz] = k;   nz++;   k++;    i++;
    }
   i=P*I+I;
   //cout<<"nz(54)="<<nz<<endl; 
 
    
    
     //-------------------------SUBSEA WELL--------------------------------   
    //Subsea Manifold 1 Well Pressure Balance: (7) in Problem Description File

    
    //Subsea Well Pressure Balance: (7) in Problem Description File
    //Manifold 1 Line 1
    k = 132;
    i1 = 142;
    i2 = 18;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<"nz: "<<nz<<" "<<iRow[nz]<<" Variabel: "<<jCol[nz]<<endl;
        iRow[nz] = i;       jCol[nz] = k;       nz++; 
        //cout<<"Betingelse: "<<"nz: "<<nz<<" "<<iRow[nz]<<" Variabel: "<<jCol[nz]<<endl;
        iRow[nz] = i;       jCol[nz] = i1;     nz++;
        //cout<<"Betingelse: "<<"nz: "<<nz<<" "<<iRow[nz]<<" Variabel: "<<jCol[nz]<<endl;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
   
    
    //Manifold 1 Line 2
    k = 132;
    i1 = 143;
    i2 = 19;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){
        //cout<<"Betingelse: "<<"nz: "<<nz<<" "<<iRow[nz]<<" Variabel: "<<jCol[nz]<<endl;
        iRow[nz] = i;       jCol[nz] = k;       nz++;
        //cout<<"Betingelse: "<<"nz: "<<nz<<" "<<iRow[nz]<<" Variabel: "<<jCol[nz]<<endl;
        iRow[nz] = i;       jCol[nz] = i1;     nz++;
        //cout<<"Betingelse: "<<"nz: "<<nz<<" "<<iRow[nz]<<" Variabel: "<<jCol[nz]<<endl;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    i=P*I+I+(2*J1);

    //Manifold 2 Line 3
    k = 138;
    i2 = 30;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = 144;     nz++;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    
    //Manifold 2 Line 4
    k = 138;
    i2 = 31;
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = 145;     nz++;
        iRow[nz] = i;       jCol[nz] = i2;      nz++;   
        k++;    i++;    i2=i2+2;
    }
    //cout<<"nz(114)="<<nz<<endl;   
    i=P*I+I+(2*J1)+(2*J2);
       
    //Subsea Routing: (8) in Problem Description File
    k=18;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++;
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++;    
        i++;
    }
    //cout<<"nz(134)="<<nz<<endl;
    i=P*I+I+(2*J1)+(2*J2)+J1+J2;   

    
     //-------------------------CAPACITIES--------------------------------
    
    //Gas Lift Capacity: (12) in Problem Description File
    i1=98;
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;           jCol[nz] = i1;         nz++;    i1++;
     }
    
    i1=104;
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;           jCol[nz] = i1;          nz++;   i1++;
    } 
    i++;
    //cout<<"nz(150)="<<nz<<endl;
   // cout<<"nz()="<<nz<<endl;  

   //Gas Production Capacity: (13) in Problem Description File
    k=0;
    i1=300;
    s=0;
    e=S;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;           jCol[nz] = i1;         nz++;
        i1++;
    }
    
        iRow[nz] = i;           jCol[nz] = 114;          nz++;
        iRow[nz] = i;           jCol[nz] = 115;          nz++;    
        iRow[nz] = i;           jCol[nz] = 120;          nz++;   
        iRow[nz] = i;           jCol[nz] = 121;          nz++;  
        
    i++;  
    //cout<<"nz(157)="<<nz<<endl;
   
    //Water Production Capacity: (14) in Problem Description File
    
    //Separator A
        iRow[nz] = i;           jCol[nz] = 306;          nz++;
        iRow[nz] = i;           jCol[nz] = 315;          nz++;    
        iRow[nz] = i;           jCol[nz] = 324;          nz++;   
      
        
    i++;    
    
    //Separator B
        iRow[nz] = i;           jCol[nz] = 307;          nz++;
        iRow[nz] = i;           jCol[nz] = 316;          nz++;    
        iRow[nz] = i;           jCol[nz] = 325;          nz++;   

        
    i++; 
    
    //Separator C
        iRow[nz] = i;           jCol[nz] = 308;          nz++;
        iRow[nz] = i;           jCol[nz] = 317;          nz++;    
        iRow[nz] = i;           jCol[nz] = 326;          nz++;   

        
    i++; 
    
    //cout<<"nz(166)="<<nz<<endl;   
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5; 

    //-------------------------SEPARATORS--------------------------------
    //Separator Pressure Balance: (10) in Problem Description File
    k=146;
    i1=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = i1;      nz++;   i1++;   i++;
 
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = i1;      nz++;   i1++;   i++;
        
        //cout<<"nz:"<<nz<<"   iRow:"<<i<<"    jCol:"<<k<<"    jCol:"<<i1<<endl;
        iRow[nz] = i;       jCol[nz] = k;       nz++;   
        iRow[nz] = i;       jCol[nz] = i1;      nz++;   i1++;   i++;
        k++;    
    }
    //cout<<"nz(190)="<<nz<<endl; 
  
    //Separator Routing: (11) in Problem Description File
    k=38;
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++; 
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++; 
        iRow[nz] = i;       jCol[nz] = k;       nz++;   k++; 
        i++;
    }
    //cout<<"nz(202)="<<nz<<endl; 
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L;

    
    //-------------------------MASS BALANCE--------------------------------
    // SUBSEA WELL MANIFOLD TO LINE  
    //Linearization Mass Balance: (15) in Problem Description File
 
    // Subsea Manifold 1
    k=150;   i1=18;   i2=68;
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = i2;            nz++;  
        iRow[nz] = i;       jCol[nz] = k;             nz++;  
        iRow[nz] = i;       jCol[nz] = k+i1;          nz++; i++; 
        iRow[nz] = i;       jCol[nz] = i2+J1;         nz++;  
        iRow[nz] = i;       jCol[nz] = k+J1;          nz++;  
        iRow[nz] = i;       jCol[nz] = k+i1+J1;       nz++; i++; 
        iRow[nz] = i;       jCol[nz] = i2+2*J1;       nz++;  
        iRow[nz] = i;       jCol[nz] = k+2*J1;        nz++;  
        iRow[nz] = i;       jCol[nz] = k+i1+2*J1;     nz++; i++; 
        i2++; k++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1;
  
  
    // Subsea Manifold 2
    k=186;   i1=12;   i2=86;
    s=0;
    e=J2;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = i2;            nz++;  
        iRow[nz] = i;       jCol[nz] = k;             nz++;  
        iRow[nz] = i;       jCol[nz] = k+i1;          nz++; i++; 
        iRow[nz] = i;       jCol[nz] = i2+J2;         nz++;  
        iRow[nz] = i;       jCol[nz] = k+J2;          nz++;  
        iRow[nz] = i;       jCol[nz] = k+i1+J2;       nz++; i++; 
        iRow[nz] = i;       jCol[nz] = i2+2*J2;       nz++;  
        iRow[nz] = i;       jCol[nz] = k+2*J2;        nz++;  
        iRow[nz] = i;       jCol[nz] = k+i1+2*J2;     nz++; i++; 
        i2++; k++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2; 
    //cout<<"nz(292)="<<nz<<endl;
  
    // Linearization Mass Balance: (16 og 17) in Problem Description File  
    // Subsea Manifold 1 - Line 1
    k=150;   i1=18;
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;  
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        iRow[nz] = i;       jCol[nz] = k+J1;          nz++;  
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        iRow[nz] = i;       jCol[nz] = k+2*J1;        nz++;  
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        i1=i1+2; k++;
    } 
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1;
           
   
    // Subsea Manifold 1 - Line 2
    k=168;   i1=19; 
    s=0;
    e=J1; 
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;  
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        iRow[nz] = i;       jCol[nz] = k+J1;          nz++;  
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        iRow[nz] = i;       jCol[nz] = k+2*J1;        nz++;  
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        i1=i1+2; k++;
    } 
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1; 
   
    // Subsea Manifold 2 - Line 3
    k=186;   i1=30;   
    s=0;
    e=J2;  
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = k+J2;          nz++;  
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = k+2*J2;        nz++;  
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        i1=i1+2; k++;
    } 
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2; 
    
   
    // Subsea Manifold 2 - Line 4
    k=198;   i1=31;    
    s=0;
    e=J2; 
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;  
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = k+J2;          nz++; 
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = k+2*J2;        nz++;  
        //cout<<"Jacobian: "<<"nz: "<<nz<<" Betingelse: "<<i<<endl;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; i++; 
        i1=i1+2; k++;
    } 
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2; 
    //cout<<"nz(412)="<<nz<<endl;
    
    // Linearization Mass Balance: (18) in Problem Description File  
    // Subsea Manifold 1
    k=114;   i1=150;   i2=2; 
    s=0;
    e=L1;
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+3;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+4;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+5;          nz++; i++; i1=i1+6;
        iRow[nz] = i;       jCol[nz] = k+i2;          nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+3;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+4;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+5;          nz++; i++; i1=i1+6;
        iRow[nz] = i;       jCol[nz] = k+2*i2;        nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+3;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+4;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+5;          nz++; i++; i1=i1+6;
        k++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1;
  
   // Subsea Manifold 2
   k=120;   i1=186;   i2=2; 
   s=0;
   e=L2;  
   for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+3;          nz++;i++; i1=i1+4; 
        iRow[nz] = i;       jCol[nz] = k+i2;          nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+3;          nz++;i++; i1=i1+4; 
        iRow[nz] = i;       jCol[nz] = k+2*i2;        nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+3;          nz++;i++; i1=i1+4; 
        k++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2;
    //cout<<"nz(484)="<<nz<<endl;
    
    

   // SUBSEA WELL LINE TO SEPARATOR 
   // Linearization Mass Balance: (19) in Problem Description File 
    
   // Subsea Manifold 1
    k=114;   i1=210;   i2=2;
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){  
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; i++; i1=i1+3;
        iRow[nz] = i;       jCol[nz] = k+i2;          nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; i++; i1=i1+3;
        iRow[nz] = i;       jCol[nz] = k+2*i2;        nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; i++; i1=i1+3;
        k++;
    }    
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1; 
    
    
    // Subsea Manifold 2
    k=120;   i1=228;   i2=2;
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; i++; i1=i1+3;
        iRow[nz] = i;       jCol[nz] = k+i2;          nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; i++; i1=i1+3;
        iRow[nz] = i;       jCol[nz] = k+2*i2;        nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++; 
        iRow[nz] = i;       jCol[nz] = i1+1;          nz++; 
        iRow[nz] = i;       jCol[nz] = i1+2;          nz++; i++; i1=i1+3;
        k++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2;  
    //cout<<"nz(532)="<<nz<<endl;
    
    // Linearization Mass Balance: (20) in Problem Description File  
    // Subsea Manifold 1 - Separator 1
    k=210;   i1=38;  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        i1=i1+3;
    }  
    
    // Subsea Manifold 1 - Separator 2  
    k=211;   i1=39;  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        i1=i1+3;
    }  
    
    // Subsea Manifold 1 - Separator 3
    k=212;   i1=40;  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        i1=i1+3;
    }  
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1;  
   
    // Subsea Manifold 2 - Separator 1
    k=228;   i1=44;  
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        i1=i1+3;
    }  
    
    // Subsea Manifold 2 - Separator 2
    k=229;   i1=45;  
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        i1=i1+3;
    }  
    
    // Subsea Manifold 2 - Separator 3
    k=230;   i1=46;  
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        iRow[nz] = i;       jCol[nz] = k;             nz++; 
        iRow[nz] = i;       jCol[nz] = i1;            nz++;  i++; k=k+3; 
        i1=i1+3;
    }   
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S; 
    //cout<<"nz(604)="<<nz<<endl;
    
    // Linearization Mass Balance: (21) in Problem Description File   
    // Subsea Manifold 1
    k=309;   i1=210;  i2=219; i3=3;
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;   
        iRow[nz] = i;       jCol[nz] = i2;            nz++;  i++;   
        iRow[nz] = i;       jCol[nz] = k+i3;          nz++;
        iRow[nz] = i;       jCol[nz] = i1+i3;         nz++;   
        iRow[nz] = i;       jCol[nz] = i2+i3;         nz++;  i++;   
        iRow[nz] = i;       jCol[nz] = k+2*i3;        nz++;
        iRow[nz] = i;       jCol[nz] = i1+2*i3;       nz++;   
        iRow[nz] = i;       jCol[nz] = i2+2*i3;       nz++;  i++;   
        k++;i1++;i2++;
    }
    
    // Subsea Manifold 2
    k=318;   i1=228;  i2=237; i3=3;
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;   
        iRow[nz] = i;       jCol[nz] = i2;            nz++;  i++;   
        iRow[nz] = i;       jCol[nz] = k+i3;          nz++;
        iRow[nz] = i;       jCol[nz] = i1+i3;         nz++;   
        iRow[nz] = i;       jCol[nz] = i2+i3;         nz++;  i++;   
        iRow[nz] = i;       jCol[nz] = k+2*i3;        nz++;
        iRow[nz] = i;       jCol[nz] = i1+2*i3;       nz++;   
        iRow[nz] = i;       jCol[nz] = i2+2*i3;       nz++;  i++;   
        k++;i1++;i2++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M;      
    //cout<<"nz(658)="<<nz<<endl;
         
    // TOPSIDE WELL TO SEPARATOR        
    // Linearization Mass Balance: (22) in Problem Description File                
    k=50;   i1=246;  i2=1; i3=1;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
        iRow[nz] = i;       jCol[nz] = k;             nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;
        iRow[nz] = i;       jCol[nz] = i1+i2;         nz++;
        iRow[nz] = i;       jCol[nz] = i1+i2+i3;      nz++; i++; i1=i1+i2+i3+1;
        iRow[nz] = i;       jCol[nz] = k+I;           nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;
        iRow[nz] = i;       jCol[nz] = i1+i2;         nz++;
        iRow[nz] = i;       jCol[nz] = i1+i2+i3;      nz++; i++; i1=i1+i2+i3+1;
        iRow[nz] = i;       jCol[nz] = k+2*I;         nz++;
        iRow[nz] = i;       jCol[nz] = i1;            nz++;
        iRow[nz] = i;       jCol[nz] = i1+i2;         nz++;
        iRow[nz] = i;       jCol[nz] = i1+i2+i3;      nz++; i++; i1=i1+i2+i3+1;
        k++;
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I;
    //cout<<"nz(730)="<<nz<<endl;
    
    // Linearization Mass Balance: (23+24) in Problem Description File         
    // Separator 1
    k=246;   i1=0;  i2=3; i3=3;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
       iRow[nz] = i;       jCol[nz] = k;         nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++;       
       iRow[nz] = i;       jCol[nz] = k+i3;      nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++;         
       iRow[nz] = i;       jCol[nz] = k+2*i3;    nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++; 
       k=k+3*i3; i1=i1+i2;
    }   
    
    // Separator 2
    k=247;   i1=1;  i2=3; i3=3;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
       iRow[nz] = i;       jCol[nz] = k;         nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++;       
       iRow[nz] = i;       jCol[nz] = k+i3;      nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++;         
       iRow[nz] = i;       jCol[nz] = k+2*i3;    nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++; 
       k=k+3*i3; i1=i1+i2;
    } 
     
    // Separator 3
    k=248;   i1=2;  i2=3; i3=3;
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
       iRow[nz] = i;       jCol[nz] = k;         nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++;       
       iRow[nz] = i;       jCol[nz] = k+i3;      nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++;         
       iRow[nz] = i;       jCol[nz] = k+2*i3;    nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; i++; 
       k=k+3*i3; i1=i1+i2;
    }    
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P;  
    //cout<<"nz(838)="<<nz<<endl;
    
    // Linearization Mass Balance: (25) in Problem Description File   
    k=300;   i1=246;  i2=9; i3=3;
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
       iRow[nz] = i;       jCol[nz] = k;         nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++; 
       iRow[nz] = i;       jCol[nz] = i1+i2;     nz++;
       iRow[nz] = i;       jCol[nz] = i1+2*i2;   nz++;        
       iRow[nz] = i;       jCol[nz] = i1+3*i2;   nz++; 
       iRow[nz] = i;       jCol[nz] = i1+4*i2;   nz++;        
       iRow[nz] = i;       jCol[nz] = i1+5*i2;   nz++; i++;         
       iRow[nz] = i;       jCol[nz] = k+i3;      nz++;
       iRow[nz] = i;       jCol[nz] = i1+i3;        nz++; 
       iRow[nz] = i;       jCol[nz] = i1+i2+i3;     nz++;
       iRow[nz] = i;       jCol[nz] = i1+2*i2+i3;   nz++;        
       iRow[nz] = i;       jCol[nz] = i1+3*i2+i3;   nz++; 
       iRow[nz] = i;       jCol[nz] = i1+4*i2+i3;     nz++;        
       iRow[nz] = i;       jCol[nz] = i1+5*i2+i3;     nz++; i++;   
       iRow[nz] = i;       jCol[nz] = k+2*i3;         nz++;
       iRow[nz] = i;       jCol[nz] = i1+2*i3;        nz++; 
       iRow[nz] = i;       jCol[nz] = i1+i2+2*i3;     nz++;
       iRow[nz] = i;       jCol[nz] = i1+2*i2+2*i3;   nz++;        
       iRow[nz] = i;       jCol[nz] = i1+3*i2+2*i3;   nz++; 
       iRow[nz] = i;       jCol[nz] = i1+4*i2+2*i3;   nz++;        
       iRow[nz] = i;       jCol[nz] = i1+5*i2+2*i3;   nz++; i++;       
       k++;i1++;
    } 
   

//cout<<"nz(901)="<<nz<<endl;           
   //-------------------------TOPSIDE WELLS----------------------------- 
    //Gas and Water production
    //Topside Well Models: (2) a-b-c in Problem Description File
    k=50;   i1=48;  i2=76;  
    s=0;
    e=I;
    for(int j = s; j < e ; j++){  
        //cout<<"Jacobian "<<"nz: "<<nz<<endl;
        iRow[nz] = i;       jCol[nz] = k;         nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<endl;
        iRow[nz] = i;       jCol[nz] = k+I;       nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<endl;
        iRow[nz] = i;       jCol[nz] = k+i1;      nz++;
        k++; i++;
    }
    
    for(int j = s; j < e ; j++){  
        //cout<<"Jacobian "<<"nz: "<<nz<<endl;
        iRow[nz] = i;       jCol[nz] = k+I;         nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<endl;
        iRow[nz] = i;       jCol[nz] = k;       nz++; 
        k++; i++;
    }
    
  

    
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2;  
    //cout<<"nz(931)="<<nz<<endl;
 
    //-------------------------SUBSEA WELLS-------------------------------
    //Gas and Water production
    //Subsea Manifold 1 Well Models: (5) a, c in Problem Description File
    k=68;
    i1=36;
    i2=64;
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){  
        iRow[nz] = i;       jCol[nz] = k;         nz++;
        iRow[nz] = i;       jCol[nz] = k+J1;       nz++;
        iRow[nz] = i;       jCol[nz] = k+i1;      nz++;
        k++; i++;
    }
    
    for(int j = s; j < e ; j++){  
        iRow[nz] = i;       jCol[nz] = k+J1;       nz++; 
        iRow[nz] = i;       jCol[nz] = k;       nz++; 
        k++; i++;
    }       
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2;  
    
    
    //Subsea Manifold 2 Well Models: (5) a, c in Problem Description File
    k=86;
    i1=24;
    i2=52;
    s=J1;
    e=J;
    for(int j = s; j < e ; j++){  
        iRow[nz] = i;       jCol[nz] = k;         nz++;
        iRow[nz] = i;       jCol[nz] = k+J2;      nz++;
        iRow[nz] = i;       jCol[nz] = k+i1;      nz++;
        k++; i++;
    }
    
    for(int j = s; j < e ; j++){  
        iRow[nz] = i;       jCol[nz] = k+J2;     nz++; 
        iRow[nz] = i;       jCol[nz] = k;       nz++; 
        k++; i++;
    } 
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2+J2*2;  
    //cout<<"nz(981)="<<nz<<endl;    
 //-------------------------TOPSIDE WELLS-----------------------------       
        
    //Well Model:  26(a)
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=56; i1=126; i2=98;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; 
      }
      //cout<<"nz(1341)="<<nz<<endl;    
      
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Well Model:  26(b)
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=74; i1=132; i2=104;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; 
      } 
   //Well Model:  26(b)
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=90; i1=138; i2=110;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; k++; i1++; i2++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++; i++; 
    }
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2+J2*2+(I+J)*MaxIt;  
    //cout<<"nz(1941)="<<nz<<endl;
    
    //-------------------------PIPELINES-------------------------------
     
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          k=146; i1=114; i2=116; i3=118;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = 142;        nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++;
          iRow[nz] = i;       jCol[nz] = i3;         nz++; i++; k++; i1++; i2++; i3++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = 143;        nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++;
          iRow[nz] = i;       jCol[nz] = i3;         nz++; i++;
    }      
    i=P*I+I+(2*J1)+(2*J2)+J1+J2+5+L*S+L+P*J1+P*J2+P*J1+P*J1+P*J2+P*J2+P*L1+P*L2+P*L1+P*L2+P*S*L1+P*L2*S+P*S*M+P*I+S*I*P+S*P+I*2+J1*2+J2*2+(I+J)*MaxIt+L1*MaxIt;  
    
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
     k=148; i1=120; i2=122; i3=124;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = 144;        nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++;
          iRow[nz] = i;       jCol[nz] = i3;         nz++; i++; k++; i1++; i2++; i3++;
          iRow[nz] = i;       jCol[nz] = k;          nz++;
          iRow[nz] = i;       jCol[nz] = 145;        nz++;
          iRow[nz] = i;       jCol[nz] = i1;         nz++;
          iRow[nz] = i;       jCol[nz] = i2;         nz++;
          iRow[nz] = i;       jCol[nz] = i3;         nz++; i++;
    }
   
   //New Binary variables for objective function:  (28) in description file 
   k=0; 
   i1=327;
   i2=328;
   s=0;
   e=NB;
   for(int j = s; j < e ; j++){
       iRow[nz] = i;       jCol[nz] = k;          nz++;
       iRow[nz] = i;       jCol[nz] = i1;        nz++;
       iRow[nz] = i;       jCol[nz] = i2;         nz++;
       i++;
       i1=i1+2;
       i2=i2+2;
       k++;
   //cout<<"g["<<i<<"]:"<<g[i]<<endl;
    } 
   
  
    
//cout<<"nz(2591)="<<nz<<endl;

//cout<<"Jac:"<<nz<<endl;
//cout<<"Constraints:"<<i<<endl;
//cout<<"Ending eval_jac_g IF LOOP"<<endl;

        
	return true;
  }
    else {
     //cout<<"Starting eval_jac_g ELSE LOOP------"<<endl;
    int nz=0; //non-zero counter
    int s=0;  //start value for loops
    int e=0;  //end value for loops
    
    
    //Topside Well Pressure Balance: (3) in Problem Description File
    //s=0;
    //e=I; 
    //for(int j = s; j < e ; j++){
    //    values[nz] = 1;   
    //    values[nz+12] = 1;
    //    values[nz+24] = 1;
    //    nz++;
    //    values[nz] = -PSEPA;    
    //    values[nz+12] = -PSEPB;
    //    values[nz+24] = -PSEPC;
    //    nz++;
    //}
    
        //Topside Well Pressure Balance: (3) in Problem Description File
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){    
        values[nz] = 1;    nz++;          //Separator A: g[0] - g[5] 
        values[nz] = -PSEPA; nz++;
    }
    
    //cout<<"Nz1: "<<nz<<endl;
    
    for(int j = s; j < e ; j++){    
        values[nz] = 1;    nz++;          //Separator B: g[6] - g[11]
        values[nz] = -PSEPB; nz++; 
    }
    //cout<<"Nz2: "<<nz<<endl;
     for(int j = s; j < e ; j++){    
        values[nz] = 1;    nz++;          //Separator C: g[12] - g[17]
        values[nz] = -PSEPC; nz++;
    }
    //cout<<"Nz3: "<<nz<<endl;
    
    
    //cout<<"nz(36)="<<nz<<endl;         
//     PSEPA = 10.0;
//     PSEPB = 12.0;
//     PSEPC = 15.0;
        
    //Topside Well Routing: (4) in Problem Description File
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
    }  
    //cout<<"nz(54)="<<nz<<endl;
    //Subsea Well Pressure Balance: (7) in Problem Description File
    //Manifold 1 Line 1
    s=0;
    e=J1;
    
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = 1;                         nz++;  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                        nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -minmax_p[0][3][1];         nz++;   
    }
    //Manifold 1 Line 2
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = 1;                         nz++;  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                        nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -minmax_p[1][3][1];         nz++;   
    }
    //Manifold 2 Line 3
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = 1;                         nz++; 
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                        nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -minmax_p[2][3][1];         nz++;  
    }
    //Manifold 2 Line 4
    s=0;
    e=J2;
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = 1;                         nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                        nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -minmax_p[3][3][1];         nz++;  
    }
    //cout<<"nz(114)="<<nz<<endl;   
    
    //Subsea Routing: (8) in Problem Description File
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        values[nz]=1;   nz++;
        values[nz]=1;   nz++;
    }
    //cout<<"nz(134)="<<nz<<endl;
   //-------------------------CAPACITIES--------------------------------
    //Gas Lift Capacity: (12) in Problem Description File 
    s=0;
    e=I;
    for(int j = s; j < e ; j++){
        values[nz] = 1;    nz++;
    }
    s=0;
    e=J;
    for(int j = s; j < e ; j++){
        values[nz] = 1;    nz++;
    }
    //cout<<"nz(150)="<<nz<<endl;
    //Gas Production Capacity: (13) in Problem Description File
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        values[nz] = 1;    nz++;
    }
    s=0;
    e=S;
    for(int j = s; j < e ; j++){
        values[nz] =1;    nz++;
    }
    //cout<<"nz(157)="<<nz<<endl;   
    
    //Water Production Capacity: (14) in Problem Description File
    //Separator A
    values[nz]=1;     nz++;
    values[nz]=1;     nz++;
    values[nz]=1;     nz++;

    
    //Separator B
    values[nz]=1;     nz++;
    values[nz]=1;     nz++;
    values[nz]=1;     nz++;

    
    //Separator C
    values[nz]=1;     nz++;
    values[nz]=1;     nz++;
    values[nz]=1;     nz++;
    //cout<<"nz(166)="<<nz<<endl;  
    
    //Separator Pressure Balance: (10) in Problem Description File
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        values[nz] = 1;         nz++;
        values[nz] = -PSEPA;    nz++;
        values[nz] = 1;         nz++;
        values[nz] = -PSEPB;    nz++;
        values[nz] = 1;         nz++;
        values[nz] = -PSEPC;    nz++;
      }
      //cout<<"nz(190)="<<nz<<endl;
      
    //Separator Routing: (11) in Problem Description File
    s=0;
    e=L;
    for(int j = s; j < e ; j++){
        values[nz] = 1;         nz++;
        values[nz] = 1;         nz++;
        values[nz] = 1;         nz++;
    }
    //cout<<"nz(202)="<<nz<<endl;
    
    //-------------------------MASS BALANCE--------------------------------
   
    // SUBSEA WELL MANIFOLD TO LINE  
    //Linearization Mass Balance: (15) in Problem Description File
    // Subsea Manifold 1
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;    nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = -1;    nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = -1;    nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = 1;     nz++; 
    }
    
    // Subsea Manifold 2
    s=0;
    e=J2;   
    for(int j = s; j < e ; j++){
        values[nz] = -1;    nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = -1;    nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = -1;    nz++; 
        values[nz] = 1;     nz++; 
        values[nz] = 1;     nz++; 
    }
    //cout<<"nz(292)="<<nz<<endl;
    
    // Linearization Mass Balance: (16 og 17) in Problem Description File  
    // Subsea Manifold 1 - Line 1
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                                                            nz++;  
        values[nz] =(minmax_w[I+j][2][1]*wellspecJ[j][1]+minmax_gl[I+j][1]);        nz++;  
        values[nz] = -1;                                                            nz++;  
        values[nz] =(minmax_w[I+j][2][1]);                                          nz++; 
        values[nz] = -1;                                                            nz++;  
        values[nz] =(minmax_w[I+j][2][1]*(wellspecJ[j][0]/(1-wellspecJ[j][0])));    nz++; 
    } 
    
    // Subsea Manifold 1 - Line 2
    s=0;
    e=J1;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                                                            nz++;  
        values[nz] =(minmax_w[I+j][2][1]*wellspecJ[j][1]+minmax_gl[I+j][1]);        nz++;  
        values[nz] = -1;                                                            nz++;  
        values[nz] =(minmax_w[I+j][2][1]);                                          nz++; 
        values[nz] = -1;                                                            nz++;  
        values[nz] =(minmax_w[I+j][2][1]*(wellspecJ[j][0]/(1-wellspecJ[j][0])));    nz++; 
    } 
  
    // Subsea Manifold 2 - Line 3
    s=0;
    e=J2;  
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                                                            nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;  
        values[nz] =(minmax_w[J1+I+j][2][1]*wellspecJ[j+J1][1]+minmax_gl[J1+I+j][1]);  nz++;  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                                                            nz++;             
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] =(minmax_w[J1+I+j][2][1]);                                       nz++; 
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                                                            nz++;  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] =(minmax_w[J1+I+j][2][1]*(wellspecJ[j+J1][0]/(1-wellspecJ[j+J1][0]))); nz++; 
    } 
  
    // Subsea Manifold 2 - Line 4
    s=0;
    e=J2; 
    for(int j = s; j < e ; j++){
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                                                            nz++; 
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl; 
        values[nz] =(minmax_w[J1+I+j][2][1]*wellspecJ[j+J1][1]+minmax_gl[J1+I+j][1]); nz++;  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                                                             nz++; 
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] =(minmax_w[J1+I+j][2][1]);                                        nz++; 
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                                                             nz++; 
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] =(minmax_w[J1+I+j][2][1]*(wellspecJ[j+J1][0]/(1-wellspecJ[j+J1][0])));  nz++; 
    } 
    
      
    //cout<<"nz(412)="<<nz<<endl;
    // Linearization Mass Balance: (18) in Problem Description File 
    // Subsea Manifold 1
    s=0;
    e=L1;
    for(int j = s; j < e ; j++){
        values[nz] = -1;         nz++;
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++;
        values[nz] = -1;         nz++;
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++;
        values[nz] = -1;         nz++;
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
    }
    
   // Subsea Manifold 2
   e=0;
   e=L2;  
   for(int j = s; j < e ; j++){
        values[nz] = -1;         nz++;
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = -1;         nz++;
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = -1;         nz++;
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
        values[nz] = 1;          nz++; 
      }
      //cout<<"nz(484)="<<nz<<endl;
      
   // SUBSEA WELL LINE TO SEPARATOR 
   // Linearization Mass Balance: (19) in Problem Description File 
   // Subsea Manifold
    s=0;
    e=L;  
    for(int j = s; j < e ; j++){  
        values[nz] = -1;            nz++;
        values[nz] = 1;             nz++; 
        values[nz] = 1;             nz++; 
        values[nz] = 1;             nz++;
        values[nz] = -1;            nz++;
        values[nz] = 1;             nz++; 
        values[nz] = 1;             nz++; 
        values[nz] = 1;             nz++;
        values[nz] = -1;            nz++;
        values[nz] = 1;             nz++; 
        values[nz] = 1;             nz++; 
        values[nz] = 1;             nz++;
    }    
    //cout<<"nz(532)="<<nz<<endl;
    
    // Linearization Mass Balance: (20) in Problem Description File  
    // Subsea Manifold 1 - Separator 1
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                 nz++;
        values[nz] = minmax_p[j][0][1];  nz++;
        values[nz] = -1;                 nz++;
        values[nz] = minmax_p[j][1][1];  nz++;
        values[nz] = -1;                 nz++;
        values[nz] = minmax_p[j][2][1];  nz++;
    }  
    
 
    // Subsea Manifold 1 - Separator 2  
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                nz++;
        values[nz] = minmax_p[j][0][1]; nz++;
        values[nz] = -1;                nz++;
        values[nz] = minmax_p[j][1][1]; nz++;
        values[nz] = -1;                nz++;
        values[nz] = minmax_p[j][2][1]; nz++;
    }  
    
    // Subsea Manifold 1 - Separator 3
    s=0;
    e=L1;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                nz++;
        values[nz] = minmax_p[j][0][1]; nz++;
        values[nz] = -1;                nz++;
        values[nz] = minmax_p[j][1][1]; nz++;
        values[nz] = -1;                nz++;
        values[nz] = minmax_p[j][2][1]; nz++;
    }  

    // Subsea Manifold 2 - Separator 1
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][0][1];   nz++;
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][1][1];   nz++;
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][2][1];   nz++;
    }  
    
    // Subsea Manifold 2 - Separator 2
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][0][1];   nz++;
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][1][1];   nz++;
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][2][1];   nz++;
    }  
    
    // Subsea Manifold 2 - Separator 3
    s=0;
    e=L2;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][0][1];   nz++;
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][1][1];   nz++;
        values[nz] = -1;                     nz++;
        values[nz] = minmax_p[L1+j][2][1];   nz++;
    }    
    //cout<<"nz(604)="<<nz<<endl;
    
    // Linearization Mass Balance: (21) in Problem Description File   
    // Subsea Manifold 1
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;      nz++;
        values[nz] = 1;       nz++;   
        values[nz] = 1;       nz++;   
        values[nz] = -1;      nz++;
        values[nz] = 1;       nz++;   
        values[nz] = 1;       nz++;     
        values[nz] = -1;      nz++;
        values[nz] = 1;       nz++;   
        values[nz] = 1;       nz++;
    }

    // Subsea Manifold 2
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;      nz++;
        values[nz] = 1;       nz++;   
        values[nz] = 1;       nz++;   
        values[nz] = -1;      nz++;
        values[nz] = 1;       nz++;   
        values[nz] = 1;       nz++;     
        values[nz] = -1;      nz++;
        values[nz] = 1;       nz++;   
        values[nz] = 1;       nz++;
    }
    //cout<<"nz(658)="<<nz<<endl;
 
    // TOPSIDE WELL TO SEPARATOR        
    // Linearization Mass Balance: (22) in Problem Description File            
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
        values[nz] = -1;    nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++; 
        values[nz] = -1;    nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++; 
        values[nz] = -1;    nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
        values[nz] = 1;     nz++;
    }  
    //cout<<"nz(730)="<<nz<<endl;
    
    // Linearization Mass Balance: (23+24) in Problem Description File         

    // Separator 1
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
       values[nz] = -1;                                                         nz++;
       values[nz] = (minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1]);        nz++;  
       values[nz] = -1;                                                         nz++;
       values[nz] = minmax_w[j][2][1];                                          nz++;
       values[nz] = -1;                                                         nz++;
       values[nz] = minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]));    nz++;        
    }
    
      
    // Separator 2
    s=0;
    e=I; 
    for(int j = s; j < e ; j++){
       values[nz] = -1;                                                         nz++;
       values[nz] = (minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1]);        nz++;  
       values[nz] = -1;                                                         nz++;
       values[nz] = minmax_w[j][2][1];                                          nz++;
       values[nz] = -1;                                                         nz++;
       values[nz] = minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]));    nz++; 
    } 
    
    
    // Separator 3
    s=0;
    e=I;  
    for(int j = s; j < e ; j++){
       values[nz] = -1;                                                         nz++;
       values[nz] = (minmax_w[j][2][1]*wellspecI[j][1]+minmax_gl[j][1]);        nz++;  
       values[nz] = -1;                                                         nz++;
       values[nz] = minmax_w[j][2][1];                                          nz++;
       values[nz] = -1;                                                         nz++;
       values[nz] = minmax_w[j][2][1]*(wellspecI[j][0]/(1-wellspecI[j][0]));    nz++; 
    } 
    //cout<<"nz(838)="<<nz<<endl;
    
    // Linearization Mass Balance: (25) in Problem Description File   
    s=0;
    e=S;  
    for(int j = s; j < e ; j++){
       values[nz] = -1;         nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = -1;         nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = -1;         nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
       values[nz] = 1;          nz++;
    }
    //cout<<"nz(901)="<<nz<<endl;
    
               
   //-------------------------TOPSIDE WELLS----------------------------- 
    //Gas and Water production
    //Topside Well Models: (2) a-b-c in Problem Description File 
    s=0;
    e=I;
    for(int j = s; j < e ; j++){  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = 1;                      nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -wellspecI[j][1];       nz++;
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = -1;                     nz++;
      }
    
    for(int j = s; j < e ; j++){  
        //cout<<"Jacobian "<<"nz: "<<nz<<"Values: "<<values[nz]<<endl;
        values[nz] = 1;                                           nz++;
        values[nz] = -(wellspecI[j][0]/(1-wellspecI[j][0]));      nz++;
    } 
    //cout<<"nz(931)="<<nz<<endl;
    


    //-------------------------SUBSEA WELLS-------------------------------
    //Gas and Water production
    //Subsea Manifold 1 Well Models: (5) a, c in Problem Description File
    s=0;
    e=J1;
    for(int j = s; j < e ; j++){  
        values[nz] = 1;                      nz++;
        values[nz] = -wellspecJ[j][1];       nz++;
        values[nz] = -1;                     nz++;
    }
    
    for(int j = s; j < e ; j++){  
        values[nz] = 1;                                           nz++;
        values[nz] = -(wellspecJ[j][0]/(1-wellspecJ[j][0]));      nz++;
    }       
   
    
    //Subsea Manifold 2 Well Models: (5) a, c in Problem Description File
    s=J1;
    e=J;
    for(int j = s; j < e ; j++){  
        values[nz] = 1;                      nz++;
        values[nz] = -wellspecJ[j][1];       nz++;
        values[nz] = -1;                     nz++;
    }
    
    for(int j = s; j < e ; j++){  
        values[nz] = 1;                                           nz++;
        values[nz] = -(wellspecJ[j][0]/(1-wellspecJ[j][0]));      nz++;
    }  
    //cout<<"nz(981)="<<nz<<endl;
 //-------------------------TOPSIDE WELLS-----------------------------       
        
    //Well Model:  26
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [0][0][j];   nz++;
          values[nz] = tangent_jacw [0][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [1][0][j];   nz++;
          values[nz] = tangent_jacw [1][1][j];   nz++; 
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [2][0][j];   nz++;
          values[nz] = tangent_jacw [2][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [3][0][j];   nz++;
          values[nz] = tangent_jacw [3][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [4][0][j];   nz++;
          values[nz] = tangent_jacw [4][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [5][0][j];   nz++;
          values[nz] = tangent_jacw [5][1][j];   nz++;
      }
      //cout<<"nz(1341)="<<nz<<endl;    
      
    //-------------------------SUBSEA WELLS-------------------------------
    
    //Well Model:  26(b)
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [6][0][j];   nz++;
          values[nz] = tangent_jacw [6][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [7][0][j];   nz++;
          values[nz] = tangent_jacw [7][1][j];   nz++; 
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [8][0][j];   nz++;
          values[nz] = tangent_jacw [8][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [9][0][j];   nz++;
          values[nz] = tangent_jacw [9][1][j];   nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [10][0][j];  nz++;
          values[nz] = tangent_jacw [10][1][j];  nz++;
          values[nz] = -1;                       nz++;
          values[nz] = tangent_jacw [11][0][j];  nz++;
          values[nz] = tangent_jacw [11][1][j];  nz++;
      } 
  
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          values[nz] = -1;                     nz++;
          values[nz] = tangent_jacw [12][0][j];   nz++;
          values[nz] = tangent_jacw [12][1][j];   nz++;
          values[nz] = -1;                     nz++;
          values[nz] = tangent_jacw [13][0][j];   nz++;
          values[nz] = tangent_jacw [13][1][j];   nz++; 
          values[nz] = -1;                     nz++;
          values[nz] = tangent_jacw [14][0][j];   nz++;
          values[nz] = tangent_jacw [14][1][j];   nz++;
          values[nz] = -1;                     nz++;
          values[nz] = tangent_jacw [15][0][j];   nz++;
          values[nz] = tangent_jacw [15][1][j];   nz++;
    }
    //cout<<"nz(1941)="<<nz<<endl;
      
    
    //-------------------------PIPELINES-------------------------------
    //Pressure Drop Model:  27 
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          values[nz] = 1;                       nz++;
          values[nz] = -1;                        nz++;
          values[nz] = tangent_jacp [0][0][j];   nz++;
          values[nz] = tangent_jacp [0][1][j];   nz++;
          values[nz] = tangent_jacp [0][2][j];   nz++;
          values[nz] = 1;                       nz++;
          values[nz] = -1;                        nz++;
          values[nz] = tangent_jacp [1][0][j];   nz++;
          values[nz] = tangent_jacp [1][1][j];   nz++;
          values[nz] = tangent_jacp [1][2][j];   nz++;
    }      
  
    s=0;
    e=MaxIt;
    for(int j = s; j < e ; j++){
          values[nz] = 1;                       nz++;
          values[nz] = -1;                        nz++;
          values[nz] = tangent_jacp [2][0][j];   nz++;
          values[nz] = tangent_jacp [2][1][j];   nz++;
          values[nz] = tangent_jacp [2][2][j];   nz++;
          values[nz] = 1;                       nz++;
          values[nz] = -1;                        nz++;
          values[nz] = tangent_jacp [3][0][j];   nz++;
          values[nz] = tangent_jacp [3][1][j];   nz++;
          values[nz] = tangent_jacp [3][2][j];   nz++;
    }
    
  //New Binary variables for objective function:  (28) in description file
   s=0;
   e=NB;
   for(int j = s; j < e ; j++){
       values[nz] = 1;          nz++;
       values[nz] = -1;         nz++;
       values[nz] = 1;          nz++;
   //cout<<"g["<<i<<"]:"<<g[i]<<endl;
    }
    
    //cout<<"nz(2591)="<<nz<<endl;
    //cout<<"nz:"<<nz<<endl;
    //cout<<"Ferdig eval_jac_g ELSE LOOP"<<endl;
    return true;
    }

}

bool
MyTMILP::eval_h(Index n, const Number* x, bool new_x,
                 Number obj_factor, Index m, const Number* lambda,
                 bool new_lambda, Index nele_hess, Index* iRow,
                 Index* jCol, Number* values)
{
 
  assert (n==NC);
  assert (m==MC_MILP);
  assert(nele_hess==0);

  //cout<<"ferdig eval_h"<<endl;
 // if(values==NULL)
 // {

  //else {
    //values[0] = 2*lambda[0];
    //values[1] = 2*lambda[0];
  //}
  cout<<"ferdig eval_h"<<endl;
  return true;
}

void
MyTMILP::finalize_solution(TMINLP::SolverReturn status,
                            Index n, const Number* x, Number obj_value)
{
  std::cout<<"Problem status: "<<status<<std::endl;
  std::cout<<"Objective value: "<<obj_value<<std::endl;
  if(printSol_ && x != NULL){
    std::cout<<"Solution:"<<std::endl;
    for(int i = 0 ; i < n ; i++){
      std::cout<<"x["<<i<<"] = "<<x[i];
      if(i < n-1) std::cout<<", ";}
    std::cout<<std::endl;
  }

  
  
  sol_feasible = status;
  //int k=56; int i1=126; int i2=98;
  //cout <<"Oil production Plane "<<tangent_w [0][2][0]+(tangent_jacw [0][0][0]*(x[i1]-tangent_w [0][0][0]))+(tangent_jacw [0][1][0]*(x[i2]-tangent_w [0][1][0]))<<endl;
  //cout <<"Oil production "<<x[k]<<endl;
    
  
  
}

//Functions to read well data
void MyTMILP::readWellData(const string &filen, double data[gdim][pdim][ddim]) {

    //cout<<"Reading well "<<endl;
	// Opening the well data file
	ifstream inFile(filen.c_str());
    
	int i,j,k;
	string line;
    string word = "s:";
	streampos beg;
	
	// Reading in the matrix of data into a string in order 
	// to find relevant positions
	while(!inFile.eof()){

		line.push_back(inFile.get());

	}

	//inFile has reached eof making it fail, so it must be cleared before continuing
	inFile.clear();
		
	size_t pos;
	
	//Find starting position of word
	pos = line.find(word);
	if (pos!=string::npos)

	//Move the get pointer 3 positions (bc of s:)
	beg = (int(pos) + 3);
	inFile.seekg(beg, ios::beg);

	//Now begin reading in the data	
        
		for(i=0;i<gdim;i++){
			for(j=0;j<pdim;j++){
                for(k=0;k<ddim;k++){
				inFile >> data[i][j][k];
                //cout<<data[i][j][k]<< "  ";
                }
            //cout<<endl;
            }
        }

	// Closing the well data file
	inFile.close();
}

void MyTMILP::readWells(){
    
    //Read well specifications of GOR and WC
    readWspecs();
    
    
    //Read topside well data
    readWellData("PMRL_1.txt",P01);
    readWellData("PMRL_2.txt",P02);
    readWellData("PMRL_3.txt",P03);
    readWellData("PMRL_4.txt",P04);
    readWellData("PMRL_5.txt",P05);
    readWellData("PMRL_6.txt",P06);
    
    //Read subsea well data
    //cout<<"S01"<<endl;
    readWellData("SMRL_7.txt",S01);
    //cout<<"S02"<<endl;
    readWellData("SMRL_8.txt",S02);
    //cout<<"S03"<<endl;
    readWellData("SMRL_9.txt",S03);
    //cout<<"S04"<<endl;
    readWellData("SMRL_10.txt",S04);
    readWellData("SMRL_11.txt",S05);
    readWellData("SMRL_12.txt",S06);
    //cout<<"S07"<<endl;
    readWellData("SMRL_13.txt",S07);
    readWellData("SMRL_14.txt",S08);
    readWellData("SMRL_15.txt",S09);
    readWellData("SMRL_16.txt",S010);

    //Set the pointers to the well data matrices
    //cout<<" Hei"<<endl;
    set_arrptr();   
   
    PSEPA = 10.0;
    PSEPB = 12.0;
    PSEPC = 15.0;
    
    //read min/max values of the wells
    minmax_wells(0, P01);
    minmax_wells(1, P02);
    minmax_wells(2, P03);
    minmax_wells(3, P04);
    minmax_wells(4, P05);
    minmax_wells(5, P06);
    
    minmax_wells(6, S01);
    minmax_wells(7, S02);
    minmax_wells(8, S03);
    minmax_wells(9, S04);
    minmax_wells(10, S05);
    minmax_wells(11, S06);
    
    minmax_wells(12, S07);
    minmax_wells(13, S08);
    minmax_wells(14, S09);
    minmax_wells(15, S010);   
    
    
    //print minmax results
//     for(int i=0; i<I+J; i++){
//         cout<<minmax_w[i][0][0]<<" -- "<<minmax_w[i][0][1]<<" -- "<<minmax_w[i][1][0]<<" -- "
//                 <<minmax_w[i][1][1]<<" -- "<<minmax_w[i][2][0]<<" -- "<<minmax_w[i][2][1]<<" -- "<<endl;
//     }
    
}

void MyTMILP::readminmax_gl(){
   
   minmax_gl[0][0] = 0;
   minmax_gl[0][1] = 400;
   minmax_gl[1][0] = 0;
   minmax_gl[1][1] = 400;
   minmax_gl[2][0] = 0;
   minmax_gl[2][1] = 400;
   minmax_gl[3][0] = 0;
   minmax_gl[3][1] = 400;
   minmax_gl[4][0] = 0;
   minmax_gl[4][1] = 400;
   minmax_gl[5][0] = 0;
   minmax_gl[5][1] = 400;
   
   minmax_gl[6][0] = 0;
   minmax_gl[6][1] = 400;
   minmax_gl[7][0] = 0;
   minmax_gl[7][1] = 400;
   minmax_gl[8][0] = 0;
   minmax_gl[8][1] = 400;
   minmax_gl[9][0] = 0;
   minmax_gl[9][1] = 400;
   minmax_gl[10][0] = 0;
   minmax_gl[10][1] = 400;
   minmax_gl[11][0] = 0;
   minmax_gl[11][1] = 400;
   minmax_gl[12][0] = 0;
   minmax_gl[12][1] = 400;
   minmax_gl[13][0] = 0;
   minmax_gl[13][1] = 400;
   minmax_gl[14][0] = 0;
   minmax_gl[14][1] = 400;
   minmax_gl[15][0] = 0;
   minmax_gl[15][1] = 400;   
}


void MyTMILP::readminmax_p(){
   //gas 
   minmax_p[0][0][0] = 0;
   minmax_p[0][0][1] = 2000;
   minmax_p[1][0][0] = 0;
   minmax_p[1][0][1] = 2000;
   minmax_p[2][0][0] = 0;
   minmax_p[2][0][1] = 2000;
   minmax_p[3][0][0] = 0;
   minmax_p[3][0][1] = 2000;     
   
   //oil
   minmax_p[0][1][0] = 0;
   minmax_p[0][1][1] = 5000;
   minmax_p[1][1][0] = 0;
   minmax_p[1][1][1] = 5000;
   minmax_p[2][1][0] = 0;
   minmax_p[2][1][1] = 5000;
   minmax_p[3][1][0] = 0;
   minmax_p[3][1][1] = 5000;  
   
   //water
   minmax_p[0][2][0] = 0;
   minmax_p[0][2][1] = 5000;
   minmax_p[1][2][0] = 0;
   minmax_p[1][2][1] = 5000;
   minmax_p[2][2][0] = 0;
   minmax_p[2][2][1] = 5000;
   minmax_p[3][2][0] = 0;
   minmax_p[3][2][1] = 5000;
   
   //pressure
   minmax_p[0][3][0] = 0;
   minmax_p[0][3][1] = 300;
   minmax_p[1][3][0] = 0;
   minmax_p[1][3][1] = 300;
   minmax_p[2][3][0] = 0;
   minmax_p[2][3][1] = 300;
   minmax_p[3][3][0] = 0;
   minmax_p[3][3][1] = 300; 
}


void MyTMILP::readWspecs(){
    //cout<<"reading Wspecs"<<endl;
    
    wellspecI[0][0] = 0.6110;
    wellspecI[0][1] = 0.089;
    wellspecI[1][0] = 0.4649;
    wellspecI[1][1] = 0.0787;
    wellspecI[2][0] = 0.6878;
    wellspecI[2][1] = 0.1009;     
    wellspecI[3][0] = 0.6702;
    wellspecI[3][1] = 0.0832;
    wellspecI[4][0] = 0.6110;
    wellspecI[4][1] = 0.0952;
    wellspecI[5][0] = 0.6548;
    wellspecI[5][1] = 0.0700;
    
    wellspecJ[0][0] = 0.2023;
    wellspecJ[0][1] = 0.0872;
    wellspecJ[1][0] = 0.7900;
    wellspecJ[1][1] = 0.0850;
    wellspecJ[2][0] = 0.3769;
    wellspecJ[2][1] = 0.0770;
    wellspecJ[3][0] = 0.1800;
    wellspecJ[3][1] = 0.0800;
    wellspecJ[4][0] = 0.2767;
    wellspecJ[4][1] = 0.0955;
    wellspecJ[5][0] = 0.2023;
    wellspecJ[5][1] = 0.0872;
    
    //Funnet p well-spec for testing
    wellspecJ[6][0] = 0.324;
    wellspecJ[6][1] = 0.081;
    wellspecJ[7][0] = 0.616;
    wellspecJ[7][1] = 0.0434;
    wellspecJ[8][0] = 0.0843;
    wellspecJ[8][1] = 0.0707;
    wellspecJ[9][0] = 0.7138;
    wellspecJ[9][1] = 0.0554;
}

void MyTMILP::minmax_wells(int i, double data[gdim][pdim][ddim]){//minmax_w[i][j][0]=min  minmax_w[i][j][1]=max
    //cout<<"MINIMAX_WELLS"<<endl;
    //cout<<"i: "<<i<<endl;
    
    for(int j=0; j<3; j++){ //for each well and each output (g/o/w/bhp)
            double a[gdim*pdim];
            //Extract the right column and save it in a[], which will be sent to min/max_val functions
            int l=0;
            for(int e=0; e<gdim; e++){
                for(int f=0; f<pdim; f++){
                    a[l] = data[e][f][j];
                    //cout<<a[l]<<endl;
                    l++;
                }
            }  
            int minn=min_val((gdim*pdim), a);
            int maxx=max_val((gdim*pdim), a);
            //cout<<"minn: "<<minn<<" -----  maxx: "<<maxx<<endl;
            
            minmax_w[i][j][0]= data[int(floor(minn/pdim))][int(minn-(pdim*(floor(minn/pdim))))][j];
            minmax_w[i][j][1]= data[int(floor(maxx/pdim))][int(maxx-(pdim*(floor(maxx/pdim))))][j];
            
            //cout<<"min "<<i<<","<<j<<": "<<minmax_w[i][j][0]<<endl;
            //cout<<"max "<<i<<","<<j<<": "<<minmax_w[i][j][1]<<endl;
            
        }
    
}

void MyTMILP::set_arrptr(){
    
parrptr[0]=P01;
parrptr[1]=P02;
parrptr[2]=P03;
parrptr[3]=P04;
parrptr[4]=P05;
parrptr[5]=P06;

sarrptr[0]=S01;
sarrptr[1]=S02;
sarrptr[2]=S03;
sarrptr[3]=S04;
sarrptr[4]=S05;
sarrptr[5]=S06;
sarrptr[6]=S07;
sarrptr[7]=S08;
sarrptr[8]=S09;
sarrptr[9]=S010;

}   

void MyTMILP::readDeltaPData(const string &filen, double data[dim][dim][dim][4]){

	// Opening the well data file
	ifstream inFile(filen.c_str());

	int i;
	string line; //used to store all the data in the file so we can search it later
	streampos beg;
	string G = "G:";
	string O = "O:";
	string W = "W:";
	string P = "P:";
	
	// Reading in the matrix of data into a string in order 
	// to find relevant positions
	while(!inFile.eof()){

		line.push_back(inFile.get());

	}

	//inFile has reached eof making it fail, so it must be cleared before continuing
	inFile.clear();
		
	size_t pos;
	
	//Now begin reading in the data points for gas
	//Find starting position of word for gas
	pos = line.find(G);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);

		for(i=0;i<dim;i++){
			inFile >> gas[i];
			//cout<< gas[i] << endl;
		}
	//data_intervall[0] = gas[1]-gas[0];

	//Now begin reading in the data points for oil
	//Find starting position of word for oil
	pos = line.find(O);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);

		for(i=0;i<dim;i++){
			inFile >> oil[i];
			//cout<< oil[i] << endl;
		}

	//data_intervall[1] = oil[1]-oil[0];

	//Now begin reading in the data points for water
	//Find starting position of word for water
	pos = line.find(W);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);

		for(i=0;i<dim;i++){
			inFile >> wat[i];
			//cout<< wat[i] << endl;
		}
	
	//data_intervall[2]=wat[1]-wat[0];

	//Now begin reading in the pressure drop data
	//Find starting position of word for pressuredrop data
	pos = line.find(P);
	if (pos!=string::npos)
	//cout <<"Word was found at: " << int(pos) <<endl;
	//Move the get pointer 2 positions because all words are 2 characters long
	beg = (int(pos) + 2);
	inFile.seekg(beg, ios::beg);
	int g, o, w, p;

	for(g=0; g<dim; g++){
		for(o=0; o<dim; o++){
			for(w=0; w<dim; w++){
				for(p=0; p<4; p++){
					inFile >> data[g][o][w][p];
					//cout<< data[g][o][w][p] << "  ";
				}
			//cout<<endl;
			}
		}
	
	}
	//OBS: Dette funker pga den fine rekkefolgen i datafilen. Dersom jeg vil lese inn olje forst, 
    //ogsaa vann ogsaa gass maa pos flyttes til begynnelsen av filen etter hver innlesing, noe som ikke er gjort naa.

	// Closing the file
	inFile.close();
}

void MyTMILP::readPipes(){
    
    readDeltaPData("Pipeline1.txt", dP1);
    readDeltaPData("Pipeline2.txt", dP2);
    readDeltaPData("Pipeline3.txt", dP3);
    readDeltaPData("Pipeline4.txt", dP4);
    
    set_dParrPtr();
}    

void MyTMILP::set_dParrPtr(){
    dParrptr[0] = dP1;
    dParrptr[1] = dP2;
    dParrptr[2] = dP3;
    dParrptr[3] = dP4;
}
    
            

//Functions to make simulator from tables + their derivatives
double * MyTMILP::ratesim(int well,int c, double pW, double qGL, double (*data)[pdim][ddim]){
    //cout<<"**********RATESIM***********"<<endl;
    double * values = new double[3];//This will be returned by the function:
                                    //values[0]=oil
                                    //values[1]=do/dp  
                                    //values[2]=do/dq 
    
    
   
    //cout<<"qGL="<<qGL<<" --- ";
    //cout<<"pW="<<pW<<endl;
     
//     for(int i=0; i<gdim; i++){
//         for(int j=0; j<pdim; j++){
//             for (int k=0; k<ddim; k++){
//                 cout<<data[i][j][k]<<"   ";
//             }
//             cout<<endl;
//         }
//     };
    
    
    //1) FIND THE INDEXES BELOW p^W and q^GL
    double qcol[gdim];
    double pcol[pdim];
    //cout<<"Printing qcol"<<endl;
    for (int i=0; i<gdim; i++){
        //cout<<i<<": "<<data[i][0][0]<<endl;
        qcol[i]=(qGL/data[i][0][0])-1;
        //cout<<i<<": "<<qcol[i]<<endl;
    }
    for (int i=0; i<pdim; i++){
        pcol[i]=(pW/data[0][i][1])-1;} 
    
    int iiq=closest_zero(gdim, qcol);
    int iip=closest_zero(pdim, pcol);
    //cout<<"1.iq="<<iiq<<"         "<<"ip="<<iip<<endl;
    
    if(iip<0){iip=0;}
    else if(iip>=pdim-1){
        iip=pdim-2;
        pW=data[0][iip][1];
    //    cout<<"pW="<<pW<<endl;
    }
    
    if(iiq<0){iiq=0;}
    else if(iiq>=gdim-1){
        iiq=gdim-2;
        qGL=data[iiq][0][0];
    //    cout<<"qGL="<<qGL<<endl;
    }
    
    //cout<<"2.iq="<<iiq<<"         "<<"ip="<<iip<<endl;
         
    //2) FIND THE OIL VALUE
    
    //2a)Find the weights: vp=closeness to pW upper breakpoint, vq=closeness to qGL upper breakpoint
    double vq= 1.0 -(  ((data[iiq+1][0][0]) - qGL)/((data[iiq+1][0][0] - data[iiq][0][0]))   );
    double vp= 1.0 -((data[0][iip+1][1] - pW)/(data[0][iip+1][1] - data[0][iip][1]));
    //cout<<"vq="<<vq<<"         "<<"vp="<<vp<<endl;
    
    //2b) Interpolate first twice in the pW direction with qGL constant, then interpolate once in the qGL direction
    
    //----Oil----
    double fgl=( (1-vp)*(data[iiq][iip][2]) + vp*(data[iiq][iip+1][2]) );
    double fgu=( (1-vp)*(data[iiq+1][iip][2]) + vp*(data[iiq+1][iip+1][2]) );
    //cout<<"fgl="<<fgl<<"         "<<"fgu="<<fgu<<endl;
    
    values[0] = ((1-vq)*fgl) + vq*(fgu);
    //cout<<"Oil value: "<<values[0]<<endl;
    
    
    for(int i=1; i<3; i++){        //Just setting the remaining slots in the vector values to zero in case
        values[i]=0;}              //we are just interested in function value and are not continuing.
    
    
    
if (c==1){  //if derivatives are needed, this part of the code will also be run
    //3) CALCULATING THE pW DERIVATIVES
        //cout<<"CALCULATING DERIVATIVES"<<endl;
        
    double ppert = 10e-4;
    double qpert = 10e-2;    

    //3.a) Increase pW by ppert
    double pWi = pW + ppert;
    double vpi= 1.0 -((data[0][iip+1][1] - pWi)/(data[0][iip+1][1] - data[0][iip][1]));

    //----Oil----
    double dp_gl=( (1-vpi)*(data[iiq][iip][2]) + vpi*(data[iiq][iip+1][2]) );
    double dp_gu=( (1-vpi)*(data[iiq+1][iip][2]) + vpi*(data[iiq+1][iip+1][2]) );
    values[1] = ((((1-vq)*dp_gl) + vq*(dp_gu)) - values[0])*(1/ppert);  
    
    //4) CALCULATING THE qGL DERIVATIVES
    
    //3.a) Increase qGL by qpert
    double qGLi = qGL + qpert;
    double vqi= 1.0 -(  ((data[iiq+1][0][0]) - qGLi)/((data[iiq+1][0][0] - data[iiq][0][0]))   );

    //----Oil----
    double dq_gl=( (1-vp)*(data[iiq][iip][2]) + vp*(data[iiq][iip+1][2]) );
    double dq_gu=( (1-vp)*(data[iiq+1][iip][2]) + vp*(data[iiq+1][iip+1][2]) );
    values[2] = ((((1-vqi)*dq_gl) + vqi*(dq_gu)) - values[0])*(1/qpert);
}   
    
    //5) WRITING TO FILE
    itt++;
    //if(itt<1000){
    //printsome(itt, iip, iiq, pW, pWi, qGL, qGLi, values);
    //}
    
    //For Testing Purposes - Remove Later
//     cout<<"------------Simulation Call----------- callnum: "<<itt<<"      PW: "<<pW<<" ----- QGL: "<<qGL<<endl;
//     for (int i=0; i<12; i++){
//         cout<<"v["<<i<<"]:"<<values[i]<<", ";
//     }
//     cout<<endl;   
    
    //cout<<"Done with Ratesim"<<endl;
    //cout<<"values[0]="<<values[0]<<"---"<<"values[1]="<<values[1]<<"---"<<"values[2]="<<values[2]<<endl;
    
//----------------------Feasibility Pump----------------------------
    
    
    
    return values;
}

double * MyTMILP::PressureDrop(int pipe, int k, double xx, double yy, double zz, double (*data)[dim][dim][4]){
    //This functions follows the trilinear interpolation description on Wikipedia, can be found at:
    // http://en.wikipedia.org/wiki/Trilinear_interpolation
    
    //cout<<"**********Entering PressureDrop*************"<<endl;
    
    //In addition, the derivatives in each direction will also be found    
    double * values = new double[4];//values[0]=Function value
                                    //values[1]=df/dx
                                    //values[2]=df/dy
                                    //values[3]=df/dz
    values[0] = 0;
    values[1] = 0;
    values[2] = 0;
    values[3] = 0;
    
//    cout<<"Gas: "<<xx<<"        Oil: "<<yy<<"          Water: "<<zz<<endl;

    double pert = 5; //Value for perturbation in each direction, needed in order to use finite differencing
    
for (int i=0; i<4; i++){
        
        if ((i==1) && (k==1)){
            xx=xx+pert;}
        else if ((i==2) && (k==1)){
            yy=yy+pert;}
        else if ((i==3) && (k==1)){
            zz=zz+pert;}

    //1. FIND LOWER INDICES IN ALL DIMENSIONS X,Y AND Z
    
    //1a. Make vectors
    double xcol[xdim];
    double ycol[ydim];
    double zcol[zdim];
    
    int irr = 0; //Irrelevant what number you put in here, might as well put zero
    
    //1b. Fill the vectors
    for(int b=0; b<xdim; b++){
        xcol[b]=(xx/data[b][irr][irr][0])-1;
    }
    
    for(int b=0; b<ydim; b++){
        ycol[b]=(yy/data[irr][b][irr][1])-1;
    }
    
    for(int b=0; b<zdim; b++){
        zcol[b]=(zz/data[irr][irr][b][2])-1;
    }
    
    
    //1c. The positive number closest to zero in the vector will give the lower index for each dimension
    int xi=closest_zero(xdim, xcol);
    int yi=closest_zero(ydim, ycol);
    int zi=closest_zero(zdim, zcol);
    
        //Make sure the indices are not above or under their bounds
        if(xi<0){xi=0;}
        else if(xi>=xdim-1){
        xi=xdim-2;
        xx=data[xi][irr][irr][0];
        }
        if(yi<0){yi=0;}
        else if(yi>=ydim-1){
        yi=ydim-2;
        yy=data[irr][yi][irr][1];
        }
        if(zi<0){zi=0;}
        else if(zi>=zdim-1){
        zi=zdim-2;
        zz=data[irr][irr][zi][3];
        }    
        
    //1d. Find difference between x,y,z and lower coordinate
    double xd = (xx-data[xi][irr][irr][0])/(data[xi+1][irr][irr][0] - data[xi][irr][irr][0]);
    double yd = (yy-data[irr][yi][irr][1])/(data[irr][yi+1][irr][1] - data[irr][yi][irr][1]);
    double zd = (zz-data[irr][irr][zi][2])/(data[irr][irr][zi+1][2] - data[irr][irr][zi][2]);
    
    //2. INTERPOLATION IN THE xx DIRECTION - GIVES 4 NEW POINTS
    
    double c00 = (data[xi][yi][zi][3]     * (1-xd)) + (data[xi+1][yi][zi][3]     * xd);
    double c10 = (data[xi][yi+1][zi][3]   * (1-xd)) + (data[xi+1][yi+1][zi][3]   * xd);
    double c01 = (data[xi][yi][zi+1][3]   * (1-xd)) + (data[xi+1][yi][zi+1][3]   * xd); 
    double c11 = (data[xi][yi+1][zi+1][3] * (1-xd)) + (data[xi+1][yi+1][zi+1][3] * xd);    
    
    //3. INTERPOLATION IN THE Y DIRECTION - GIVES 2 NEW POINTS
    double c0 = c00*(1-yd) + c10*yd;
    double c1 = c01*(1-yd) + c11*yd;
    
    //4. INTERPOLATION IN THE Z DIRECTION - GIVES THE FINAL APPROXIMATED VALUE
    double c = c0*(1-zd) + c1*zd;
    
    values[i]=c;

}
    //5. FOR THE DERIVATIVES, TAKE THE FINITE DIFFERENCE
    values[1] = (values[1] - values[0])/pert;
    values[2] = (values[2] - values[0])/pert;
    values[3] = (values[3] - values[0])/pert;

    //-------------------------Feasibility Pump----------------------------------
    
    
    
    //cout<<"values[0]="<<values[0]<<"  ---  "<<"values[1]="<<values[1]<<"  ---  "<<"values[2]="<<values[2]<<"  ---  "<<"values3]="<<values[3]<<endl;
    //cout<<"Leaving PressureDrop"<<endl;
    return values;
} 


void MyTMILP::printsome(int itt, int ip, int iq, double p, double pi, double q, double qi, double val[12]){ 

ofstream iterations;
iterations.open ("iterations.txt", ios::out | ios::app);

iterations<<"Iteration: "<<itt<<endl;
iterations<<"Simulator call for:  ---pW: "<<p<<"---  and ---qGL: "<<q<<"---"<<endl;
iterations<<"Perturbed values  :  ---pW: "<<pi<<"---  and ---qGL: "<<qi<<"---"<<endl;
iterations<<endl;
iterations<<"Breakpoint indices: pW="<<ip<<" & qGL="<<iq<<endl;
iterations<<endl;
iterations<<"Calculated Values"<<endl;
iterations<<"Gas: "<<val[0]<<"        dg/dp: "<<val[4]<<"       dg/dq: "<<val[8]<<endl;
iterations<<"Oil: "<<val[1]<<"        do/dp: "<<val[5]<<"       do/dq: "<<val[9]<<endl;
iterations<<"Water: "<<val[2]<<"        dw/dp: "<<val[6]<<"       dw/dq: "<<val[10]<<endl;
iterations<<"pBHP: "<<val[3]<<"        db/dp: "<<val[7]<<"       db/dq: "<<val[11]<<endl;
iterations<<endl;
// iterations<<endl;
// iterations<<"Distances & Weights"<<endl;
// for (int i=0; i<4; i++){
// iterations<<i<<": Dist="<<d[i]<<"        Weight=: "<<w[i]<<endl;
// }
iterations<<"-----------------------------------------------------------------------"<<endl;
iterations<<endl;
iterations.close();

    
}


//General Functions
int MyTMILP::round(double n){
int r;
if ( (n+0.5) >= (int(n)+1) )
	r = int(n) +1;
else
	r = int(n);

return r;
}	

int MyTMILP::min_val(int size, double a[]){
    int index=0;
    double temp=a[0];
    for (int i=1; i<size; i++){
        if (a[i]==-1){
        }
        else if (a[i]<temp){
            temp=a[i];
            index=i;
        }
    }
    return index;
}
        
int MyTMILP::max_val(int size, double a[]){
    int index=0;
    double temp=a[0];
    for (int i=1; i<size; i++){
        if (a[i] == -1){
        }
        else if (a[i]>temp){
            temp=a[i];
            index=i;
        }
    }
    return index;
}

int MyTMILP::closest_zero(int size, double a[]){
    int index=0;
    double temp=a[0];
    for(int i=1; i<size;i++){
        if (a[i] < 0){
        }
        else if (a[i]<temp){
            temp=a[i];
            index=i;
        }
    }
    return index;
}

// void MyTMILP::save_sol(const double* adr){
// 	
// 	for(int i=0;i<88;i++){
// 	sol[i] = adr[i];
// 	
// 	}
// }
// 
// void MyTMILP::is_int_feasible(){
//     int ret=0;
//     int sum=0;
//     for(int i=0; i<18; i++){
//         if ((sol[i] == 1) || (sol[i] == 0)){
//             sum=sum+1;
//         }
//     }
//     
//     if (sum == 18){
//         ret = 1;
//     }
// }
        






//FEASIBILITY PUMP

void MyTMILP::set_It(int It){
    It_nlp=It;
    
  
}


void MyTMILP::setWW(int It){
    
   
if (It==0){WW=1;}				
			
// else if (It==		1	){
// WW=	0.95		;}
// 			
// else if (It==		2	){
// WW=	0.9		;}
// 			
// else if (It==		3	){
// WW=	0.8		;}
// 			
// else if (It==		4	){
// WW=	0.1		;}
// 			
// else if (It==		5	){
// WW=	0.09		;}
// 			
// else if (It==		6	){
// WW=	0.08		;}
// 			
// else if (It==		7	){
// WW=	0.07		;}
// 			
// else if (It==		8	){
// WW=	0.06		;}
// 			
// else if (It==		9	){
// WW=	0.05		;}
// 			
// else if (It==		10	){
// WW=	0.03		;}
// 			
// else if (It==		11	){
// WW=	0.01		;}
// 			
// else if (It==		12	){
// WW=	0.01		;}
// 			
// else if (It==		13	){
// WW=	0.01		;}
// 			
// else if (It==		14	){
// WW=	0.01		;}
// 			
// else if (It==		15	){
// WW=	0.01		;}
// 			
// else if (It==		16	){
// WW=	0.01		;}
// 			
// else if (It==		17	){
// WW=	0		;}
// 			
// else if (It==		18	){
// WW=	0		;}
// 			
// else if (It==		19	){
// WW=	0		;}
//     
//     NND=1000;
    
			
			
if (It==0){WW=1;}			
			
else if (It==		1	){
WW=	1		;}
			
else if (It==		2	){
WW=	1		;}
			
else if (It==		3	){
WW=	0.999		;}
			
else if (It==		4	){
WW=	0.99		;}
			
else if (It==		5	){
WW=	0.5		;}
			
			
else if (It==		6	){
WW=	0.1		;}
			
else if (It==		7	){
WW=	0.01		;}
			
else if (It==		8	){
WW=	0.006		;}
			
else if (It==		9	){
WW=	0.005		;}
			
else if (It==		10	){
WW=	0.003		;}
			
else if (It==		11	){
WW=	0.001		;}
			
else if (It==		12	){
WW=	0.0001		;}
			
else if (It==		13	){
WW=	0.001		;}
			
else if (It==		14	){
WW=	0.0001		;}
			
else if (It==		15	){
WW=	0.0001	;}
			
else if (It==		16	){
WW=	0.0001		;}
			
else if (It==		17	){
WW=	0.0001		;}
			
else if (It==		18	){
WW=	0.00		;}
			
else if (It==		19	){
WW=	0.00		;}    
    NND=100;
       
    
			
			
// else if (It==		1	){
// WW=	0.95		;}
// 			
// else if (It==		2	){
// WW=	0.9		;}
// 			
// else if (It==		3	){
// WW=	0.8		;}
// 			
// else if (It==		4	){
// WW=	0.001		;}
// 			
// else if (It==		5	){
// WW=	0.0009		;}
// 			
// else if (It==		6	){
// WW=	0.0008		;}
// 			
// else if (It==		7	){
// WW=	0.0007		;}
// 			
// else if (It==		8	){
// WW=	0.0006		;}
// 			
// else if (It==		9	){
// WW=	0.005		;}
// 			
// else if (It==		10	){
// WW=	0.0003		;}
// 			
// else if (It==		11	){
// WW=	0.0001		;}
// 			
// else if (It==		12	){
// WW=	0.0001		;}
// 			
// else if (It==		13	){
// WW=	0.0001		;}
// 			
// else if (It==		14	){
// WW=	0.0001		;}
// 			
// else if (It==		15	){
// WW=	0.0001	;}
// 			
// else if (It==		16	){
// WW=	0.0001		;}
// 			
// else if (It==		17	){
// WW=	0.0001		;}
// 			
// else if (It==		18	){
// WW=	0.00		;}
// 			
// else if (It==		19	){
// WW=	0.00		;}    
//     NND=10;
    

       
   // cout<<"MILP WW: "<<WW<<endl;
    
}

void MyTMILP::save_sol(const double* adr){
    if(nlp==true){
	for(int i=0;i<50;i++){
    Parameter_f[i]=adr[i];
	}}
    if(milp==true){
    for(int i=0;i<150;i++){
    Parameter_start[i]=adr[i];
	}}
}



void MyTMILP::set_nlp(){
    nlp=true;
    milp=false;
}

void MyTMILP::set_milp(){
    nlp=false;
    milp=true;
}
void MyTMILP::init_tangentValues(){   
 
for (int i=0; i<150; i++){
     Parameter_f[i]=0;
 }

for (int i=0; i<150; i++){
     Parameter_start[i]=0;
 }





  
 for(int i=1; i<MaxIt; i++){    
        for (int j=0; j<I+J; j++){
        tangent_w [j][0][i] = 0;        //Pressure
        tangent_w [j][1][i] = 0;        //Gas Lift
        tangent_w [j][2][i] = 3000;     //Oil
        tangent_jacw [j][0][i] = 0;     //Gradient
        tangent_jacw [j][1][i] =  0;     //Gradient
        }           
        for (int j=0; j<L; j++){
        tangent_p [j][0][i] = 0;      //Gas
        tangent_p [j][1][i] = 0;     //Oil
        tangent_p [j][2][i] = 0;     //Water
        tangent_p [j][3][i] = 0;       //Pressure Drop
        tangent_jacp [j][0][i] =0;     //Gradient
        tangent_jacp [j][1][i] =0;     //Gradient
        tangent_jacp [j][2][i] =0;     //Gradient
        }   
    }
}

void MyTMILP::set_tangentValues(double const* adr, double t_jacw[I+J][2][MaxIt], double t_jacp[L][3][MaxIt]){   
    
//         for (int j=0; j<I+J; j++){
//         tangent_w [j][0][It_nlp] = t_w [j][0][It_nlp];         //Pressure
//         tangent_w [j][1][It_nlp] = t_w [j][1][It_nlp];        //Gas Lift
//         tangent_w [j][2][It_nlp] = t_w [j][2][It_nlp];     //Oil
//         tangent_jacw [j][0][It_nlp] = t_jacw [j][0][It_nlp];     //Gradient
//         tangent_jacw [j][1][It_nlp] = t_jacw [j][1][It_nlp];     //Gradient
//         }           
//         for (int j=0; j<L; j++){
//         tangent_p [j][0][It_nlp] = t_p [j][0][It_nlp];      //Gas
//         tangent_p [j][1][It_nlp] = t_p [j][1][It_nlp];     //Oil
//         tangent_p [j][2][It_nlp] = t_p [j][2][It_nlp];     //Water
//         tangent_p [j][3][It_nlp] = t_p [j][3][It_nlp];       //Pressure Drop
//         tangent_jacp [j][0][It_nlp] =t_jacp [j][0][It_nlp]; ;     //Gradient
//         tangent_jacp [j][1][It_nlp] =t_jacp [j][1][It_nlp]; ;     //Gradient
//         tangent_jacp [j][2][It_nlp] =t_jacp [j][2][It_nlp]; ;     //Gradient
//         }   
        
        int i1=0;
        for (int j=0; j<I; j++){
        tangent_w [j][0][It_nlp] =adr[126+i1];        //Pressure
        //cout<<"tangent_w ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_w [j][0][It_nlp]<<endl;
        tangent_w [j][1][It_nlp] =adr[98+i1];        //Gas Lift
        //cout<<"tangent_w ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_w [j][1][It_nlp]<<endl;
        tangent_w [j][2][It_nlp] = adr[56+i1];     //Oil
        //cout<<"tangent_w ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_w [j][2][It_nlp]<<endl;
        i1++;
        
        tangent_jacw [j][0][It_nlp] = t_jacw[j][0][It_nlp];     //Gradient
        //cout<<"tangent_jacw ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacw [j][0][It_nlp]<<endl;
        tangent_jacw [j][1][It_nlp] = t_jacw[j][1][It_nlp];     //Gradient
        //cout<<"tangent_jacw ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacw [j][1][It_nlp]<<endl;
        }
        
        
        i1=0;
        for (int j=I; j<I+J1; j++){
        tangent_w [j][0][It_nlp] =adr[132+i1];        //Pressure
        //cout<<"tangent_w ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_w [j][0][It_nlp]<<endl;
        tangent_w [j][1][It_nlp] =adr[104+i1];        //Gas Lift
        //cout<<"tangent_w ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_w [j][1][It_nlp]<<endl;
        tangent_w [j][2][It_nlp] = adr[74+i1];     //Oil
        //cout<<"tangent_w ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_w [j][2][It_nlp]<<endl;
        i1++;
        
        tangent_jacw [j][0][It_nlp] = t_jacw[j][0][It_nlp];     //Gradient
        //cout<<"tangent_jacw ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacw [j][0][It_nlp]<<endl;
        tangent_jacw [j][1][It_nlp] = t_jacw[j][1][It_nlp];     //Gradient
        //cout<<"tangent_jacw ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacw [j][1][It_nlp]<<endl;
        }
        
        i1=0;
        for (int j=I+J1; j<I+J1+J2; j++){
        tangent_w [j][0][It_nlp] =adr[138+i1];        //Pressure
        //cout<<"tangent_w ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_w [j][0][It_nlp]<<endl;
        tangent_w [j][1][It_nlp] =adr[110+i1];        //Gas Lift
        //cout<<"tangent_w ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_w [j][1][It_nlp]<<endl;
        tangent_w [j][2][It_nlp] = adr[90+i1];     //Oil
        //cout<<"tangent_w ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_w [j][2][It_nlp]<<endl;
        i1++;
        
        tangent_jacw [j][0][It_nlp] = t_jacw[j][0][It_nlp];     //Gradient
        //cout<<"tangent_jacw ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacw [j][0][It_nlp]<<endl;
        tangent_jacw [j][1][It_nlp] = t_jacw[j][1][It_nlp];     //Gradient
        //cout<<"tangent_jacw ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacw [j][1][It_nlp]<<endl;
        }
        
        i1=0;          
        for (int j=0; j<L1; j++){
        tangent_p [j][0][It_nlp] = adr[114+i1];      //Gas
        //cout<<"tangent_p ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_p [j][0][It_nlp]<<endl;
        tangent_p [j][1][It_nlp] = adr[116+i1];     //Oil
        //cout<<"tangent_p ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_p [j][1][It_nlp]<<endl;
        tangent_p [j][2][It_nlp] = adr[118+i1];     //Water
        //cout<<"tangent_p ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_p [j][2][It_nlp]<<endl;
        tangent_p [j][3][It_nlp] = adr[142+i1]-adr[146+i1];       //Pressure Drop
        //cout<<"tangent_p ["<<j<<"][3]["<<It_nlp<<"]: "<<tangent_p [j][3][It_nlp]<<endl;
        
        i1++;
        
        tangent_jacp [j][0][It_nlp] =t_jacp[j][0][It_nlp];     //Gradient
        //cout<<"tangent_jacp ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacp [j][0][It_nlp]<<endl;
        tangent_jacp [j][1][It_nlp] =t_jacp[j][1][It_nlp];     //Gradient
        //cout<<"tangent_jacp ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacp [j][1][It_nlp]<<endl;
        tangent_jacp [j][2][It_nlp] =t_jacp[j][2][It_nlp];     //Gradient
        //cout<<"tangent_jacp ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_jacp [j][2][It_nlp]<<endl; 
        }  
         
        
        i1=0;
        for (int j=L1; j<L; j++){
        tangent_p [j][0][It_nlp] = adr[120+i1];      //Gas
         //cout<<"tangent_p ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_p [j][0][It_nlp]<<endl;
        tangent_p [j][1][It_nlp] = adr[122+i1];     //Oil
         //cout<<"tangent_p ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_p [j][1][It_nlp]<<endl;
        tangent_p [j][2][It_nlp] = adr[124+i1];     //Water
         //cout<<"tangent_p ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_p [j][2][It_nlp]<<endl;
        tangent_p [j][3][It_nlp] = adr[144+i1]-adr[148+i1];        //Pressure Drop
        //cout<<"tangent_p ["<<j<<"][3]["<<It_nlp<<"]: "<<tangent_p [j][3][It_nlp]<<endl;
        
        i1++;
        
        tangent_jacp [j][0][It_nlp] =t_jacp[j][0][It_nlp];     //Gradient
        //cout<<"tangent_jacp ["<<j<<"][0]["<<It_nlp<<"]: "<<tangent_jacp [j][0][It_nlp]<<endl;
        tangent_jacp [j][1][It_nlp] =t_jacp[j][1][It_nlp];     //Gradient
        //cout<<"tangent_jacp ["<<j<<"][1]["<<It_nlp<<"]: "<<tangent_jacp [j][1][It_nlp]<<endl;
        tangent_jacp [j][2][It_nlp] =t_jacp[j][2][It_nlp];     //Gradient
        //cout<<"tangent_jacp ["<<j<<"][2]["<<It_nlp<<"]: "<<tangent_jacp [j][2][It_nlp]<<endl; 
        }   
        
        for (int j=0; j<I; j++){
        check_tangentw(j,parrptr[j]);}
        
        
        for (int j=0; j<J; j++){
        check_tangentw(j+I,sarrptr[j]);}
        
        for (int j=0; j<L; j++){
        check_tangentp(j,dParrptr[j]);}
        
        
        print_tangentValues();
 }
  
void MyTMILP::check_tangentw(int j, double (*data)[pdim][ddim]){        
    double q_tangent;
    double q_function;
    double delta = 0;
    double Max_delta = 0;
    
    int n1 = 0;
    int n2 = 0;
    double diff = 0;
        
        if(j==0){
        ofstream myfile ("Checktangent.txt");            
        if (myfile.is_open()){   
       
        for (int k1=0; k1<gdim; k1++){  
        for (int k2=0; k2<pdim; k2++){
            //g[i]=-x[k]+tangent_w [0][2][j]+(tangent_jacw [0][0][j]*(x[i1]-tangent_w [0][0][j]))+(tangent_jacw [0][1][j]*(x[i2]-tangent_w [0][1][j]));i++; k++; i1++; i2++;
            q_tangent = tangent_w [j][2][It_nlp]+(tangent_jacw [j][0][It_nlp]*(data[0][k2][1]-tangent_w [j][0][It_nlp]))+(tangent_jacw [j][1][It_nlp]*(data[k1][0][0]-tangent_w [j][1][It_nlp]));
            q_function = data[k1][k2][2];
            
            myfile <<endl;
            myfile<<"Q_Tangent for well "<<j+1<<" is "<<q_tangent<<endl;
            myfile<<"Q_Function for well "<<j+1<<" is "<<q_function<<endl;
            myfile<<"Difference "<<q_function-q_tangent<<endl;
            
            if((q_function-q_tangent) > diff){
            diff = q_function-q_tangent;
            myfile<<"Diff "<<diff<<endl;}
            
            if(k1+1==gdim && k2+1==pdim){
            myfile.close();}
            }}
        }
        }
    
        for (int k1=0; k1<gdim; k1++){  
        for (int k2=0; k2<pdim; k2++){
            //g[i]=-x[k]+tangent_w [0][2][j]+(tangent_jacw [0][0][j]*(x[i1]-tangent_w [0][0][j]))+(tangent_jacw [0][1][j]*(x[i2]-tangent_w [0][1][j]));i++; k++; i1++; i2++;
            q_tangent = tangent_w [j][2][It_nlp]+(tangent_jacw [j][0][It_nlp]*(data[0][k2][1]-tangent_w [j][0][It_nlp]))+(tangent_jacw [j][1][It_nlp]*(data[k1][0][0]-tangent_w [j][1][It_nlp]));
            q_function = data[k1][k2][2];
            delta = q_function - q_tangent;
            
                        
             if(delta > Max_delta){
                n1=k1; n2=k2;
                Max_delta=delta;
              }}}
    
                if(n1 != 0 || n2 != 0){
                tangent_w [j][2][It_nlp] = data[n1][n2][2];
                tangent_w [j][0][It_nlp] = data[0][n2][1];
                tangent_w [j][1][It_nlp] = data[n1][0][0];}
  
}

void MyTMILP::check_tangentp(int j,double (*data)[dim][dim][4]){   
    double q_tangent;
    double q_function;
    double delta = 0;
    double Max_delta = 0;
    
    int n1=0; int n2=0; int n3=0;
    
   int teller=0;
   
   ofstream myfile ("pressuredroppipe.txt");    
   
   //cout<<data[0][0][dim-1][2]<<endl;
   
   if(It_nlp<2){
   if(tangent_jacp [j][1][It_nlp]>0.01){
     myfile<<tangent_jacp [j][1][It_nlp]<<endl;
     tangent_jacp [j][1][It_nlp]=0.01;
   }}
   
   if(It_nlp<2){
   if(tangent_jacp [j][2][It_nlp]>0.01){
     myfile << tangent_jacp [j][2][It_nlp]  <<endl;
     tangent_jacp [j][2][It_nlp]=0.01;
   }}
   
   if (myfile.is_open()){ 
       
        myfile <<endl;
        for (int k1=0; k1<23; k1++){  
        for (int k2=10; k2<25; k2++){
        for (int k3=10; k3<25; k3++){
            
            //myfile<<" Oil Datapoints; "<<data[0][k2][0][1]<<endl;
            //myfile <<" Water Datapoints: "<<data[0][0][k3][2]<<endl;
            //myfile <<" 1200: "<<data[0][0][dim-1][2]<<endl;
            //myfile <<" Water Tangent: "<<tangent_p [j][2][It_nlp] <<endl;
            //myfile <<" Oil Tangent: "<<tangent_p [j][1][It_nlp] <<endl;
            //myfile <<" Wc_PipeTangent: "<<(data[0][0][k3][2]/ (data[0][k2][0][1]+ data[0][0][k3][2]))<<endl;
            
            //if( (data[0][k2][0][1]+ data[0][0][k3][2]) <= (data[0][0][dim-1][2]/(tangent_p [j][2][It_nlp]/(tangent_p [j][1][It_nlp]+tangent_p [j][2][It_nlp])))){
            if( (data[0][k2][0][1]+ data[0][0][k3][2]) <= (data[0][0][dim-1][2]/(data[0][0][k3][2]/ (data[0][k2][0][1]+ data[0][0][k3][2])))){
            q_tangent = tangent_p [j][3][It_nlp]+(tangent_jacp [j][0][It_nlp]*(data[k1][0][0][0]-tangent_p [j][0][It_nlp]))+(tangent_jacp [j][1][It_nlp]*(data[0][k2][0][1]-tangent_p [j][1][It_nlp]))+(tangent_jacp [j][2][It_nlp]*(data[0][0][k3][2]-tangent_p [j][2][It_nlp]));
            q_function = data[k1][k2][k3][3];
            
            
            delta = q_tangent-q_function;
            
             if(delta > Max_delta){
                n1=k1; n2=k2; n3=k3;
                Max_delta=delta;
                myfile<<"Pipeline: "<<j<<endl;
                myfile<<"Q_Tangent "<<q_tangent<<endl;
                myfile<<"Q_Function "<<q_function<<endl;
                myfile<<" Gas Datapoints; "<<data[n1][0][0][0]<<endl;
                myfile<<" Oil Datapoints; "<<data[0][n2][0][1]<<endl;
                myfile<<" Water Datapoints; "<<data[0][0][n3][2]<<endl;
             }}}}}
            myfile.close();
        } 
    
                if(n1 !=0 || n2 !=0 || n3 != 0){
                tangent_p [j][0][It_nlp] = data[n1][0][0][0];
                tangent_p [j][1][It_nlp] = data[0][n2][0][1];
                tangent_p [j][2][It_nlp] = data[0][0][n3][2];
                tangent_p [j][3][It_nlp] = data[n1][n2][n3][3];}
}





void MyTMILP::print_tangentValues(){  

ofstream myfile ("tangentvalues.txt");    
    
if (myfile.is_open()){    
for(int i=0; i<MaxIt; i++){    
        for (int j=0; j<I+J; j++){
        myfile <<"Well Tangent functions"<<endl;
        myfile <<endl;
        myfile <<"Pressure in tangent: "<<i+1<<" for well "<<j+1<<" "<<tangent_w [j][0][i]<<endl;
        myfile <<"Gas Lift in tangent: "<<i+1<<" for well "<<j+1<<" "<<tangent_w [j][1][i]<<endl;
        myfile <<"Oil in tangent: "<<i+1<<" for well "<<j+1<<" "<<tangent_w [j][2][i]<<endl;
        myfile <<"Jacobian Pressure in tangent: "<<i+1<<" for well "<<j+1<<" "<<tangent_jacw [j][0][i]<<endl;
        myfile <<"Jacobian GasLift in tangent: "<<i+1<<" for well "<<j+1<<" "<<tangent_jacw [j][1][i]<<endl;
        myfile <<endl;
        }
        for (int j=0; j<L; j++){
        myfile <<"Pressure Drop Tangent functions"<<endl;
        myfile <<endl;
        myfile <<"Gas in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_p [j][0][i]<<endl;
        myfile <<"Oil in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_p [j][1][i]<<endl;
        myfile <<"Water in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_p [j][2][i]<<endl;
        myfile <<"Pressure Drop in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_p [j][3][i]<<endl;
        myfile <<"Jacobian Gas in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_jacp [j][0][i]<<endl;
        myfile <<"Jacobian Oil in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_jacp [j][1][i]<<endl;
        myfile <<"Jacobian Water in tangent: "<<i+1<<" for pipeline "<<j+1<<" "<<tangent_jacp [j][2][i]<<endl;
        myfile <<endl;
        }
}
  
     myfile.close();
}
}

void MyTMILP::print_solValues(const double* x){ 

ofstream myfile ("oilproductionMILP.txt");    
    
if (myfile.is_open()){
    
     double tot_prod=0;
   
   tot_prod =   (x[56]*(x[0]+x[1]+x[2]))+(x[57]*(x[3]+x[4]+x[5]))+ (x[58]*(x[6]+x[7]+x[8]))+ (x[59]*(x[9]+x[10]+x[11]))+ (x[60]*(x[12]+x[13]+x[14]))+ (x[61]*(x[15]+x[16]+x[17])) + (x[116]*(x[38]+x[39]+x[40])) + (x[117]*(x[41]+x[42]+x[43]))+ (x[122]*(x[44]+x[45]+x[46])) + (x[123]*(x[47]+x[48]+x[49]));
    
   myfile <<"Oil production from wells"<<endl;
        myfile<<endl;
        myfile<<"Total Production: "<<tot_prod<<endl;
        myfile<<endl;
 
    
    
        myfile <<"Oil production from wells"<<endl;
        myfile<<endl;
        myfile <<"Topside Wells"<<endl;
        for (int i=0; i<I; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Production: "<<x[56+i]<<endl;}
        for (int i=0; i<I; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Gas: "<<x[50+i]<<endl;}
        for (int i=0; i<I; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Water: "<<x[62+i]<<endl;
        }
        myfile<<endl;
        myfile <<"Subsea Wells"<<endl;
        
        for (int i=0; i<J1; i++){ 
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Production: "<<x[74+i]<<endl;}
        for (int i=0; i<J1; i++){ 
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Gas: "<<x[68+i]<<endl;}
        for (int i=0; i<J1; i++){ 
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Water: "<<x[80+i]<<endl;
         }
        for (int i=0; i<J2; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Production: "<<x[90+i]<<endl;}
        for (int i=0; i<J2; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Gas: "<<x[86+i]<<endl;}
        for (int i=0; i<J2; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Water: "<<x[94+i]<<endl;
        }
        
        
         myfile<<endl; 
           //Gas Lift Capacity: (12) in Problem Description File
        double tot_gaslift=0;
        tot_gaslift = 
            x[98]*(x[0]+x[1]+x[2]) + x[99]*(x[3]+x[4]+x[5])
            +x[100]*(x[6]+x[7]+x[8])+x[101]*(x[9]+x[10]+x[11])
            +x[102]*(x[12]+x[13]+x[14])+ x[103]*(x[15]+x[16]+x[17])
            +x[104]*(x[18]+x[19]) + x[105]*(x[20]+x[21])
            +x[106]*(x[22]+x[23]) + x[107]*(x[24]+x[25])
            +x[108]*(x[26]+x[27]) + x[109]*(x[28]+x[29])
            +x[110]*(x[30]+x[31]) + x[111]*(x[32]+x[33])
            +x[112]*(x[34]+x[35]) + x[113]*(x[36]+x[37]);
        
        myfile<<"Tot GasLift: "<<tot_gaslift<<endl;
        myfile<<endl;
        double tot_gas =0;
        tot_gas=x[50]*(x[0]+x[1]+x[2]) + x[51]*(x[3]+x[4]+x[5])
            +x[52]*(x[6]+x[7]+x[8]) + x[53]*(x[9]+x[10]+x[11])
            +x[54]*(x[12]+x[13]+x[14]) + x[55]*(x[15]+x[16]+x[17])
            +x[114]+x[115]+x[120]+x[121];
   
        myfile<<"Tot Gas: "<<tot_gas<<endl;
        myfile<<endl;
    //Water Production Capacity: (14) in Problem Description File
    double tot_WaterA=0;
    double tot_WaterB=0;
    double tot_WaterC=0;
    //Separator A
   
    tot_WaterA =    x[62]*x[0] + x[63]*x[3] + x[64]*x[6] + x[65]*x[9] + x[66]*x[12] + x[67]*x[15]
            +x[118]*x[38] + x[119]*x[41] + x[124]*x[44] + x[125]*x[47];
    myfile<<"Tot WaterA: "<<tot_WaterA<<endl;
    myfile<<endl;
    
    //Separator B
    tot_WaterB=    x[62]*x[1] + x[63]*x[4] + x[64]*x[7] + x[65]*x[10] + x[66]*x[13] + x[67]*x[16]
            +x[118]*x[39] + x[119]*x[42] + x[124]*x[45] + x[125]*x[48];
    myfile<<"Tot WaterB: "<<tot_WaterB<<endl;
    myfile<<endl;
    
    //Separator C
    tot_WaterC=    x[62]*x[2] + x[63]*x[5] + x[64]*x[8] + x[65]*x[11] + x[66]*x[14] + x[67]*x[17]
            +x[118]*x[40] + x[119]*x[43] + x[124]*x[46] + x[125]*x[49];
    myfile<<"Tot WaterC: "<<tot_WaterC<<endl;
    myfile<<endl;
        
        
        myfile<<endl;
        for (int i=0; i<I+J; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" GasLift: "<<x[98+i]<<endl;}
        
        myfile<<endl;
        for (int i=0; i<I+J; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Pressure: "<<x[126+i]<<endl;}
        
        
         myfile<<endl;
        for (int i=0; i<L; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Pressure Manifold: "<<x[142+i]<<endl;}
        
        myfile<<endl;
        for (int i=0; i<L; i++){
        myfile<<"Well: "<<i+1<<". Iteration: "<<It_nlp<<" Pressure Platform: "<<x[146+i]<<endl;}
        
        myfile<<endl;
        myfile<<"Separator1 Topside Iteration: "<<It_nlp<<" Flow: "<<x[303]<<endl;
        myfile<<"Separator2 Topside Iteration: "<<It_nlp<<" Flow: "<<x[304]<<endl;
        myfile<<"Separator3 Topside Iteration: "<<It_nlp<<" Flow: "<<x[305]<<endl;
        
        myfile<<endl;
        for (int i=0; i<I; i++){
        myfile<<"Separator1 Topside Well "<<i+1<< " Iteration: "<<It_nlp<<" Flow: "<<x[249+9*i]<<endl;
        }
        for (int i=0; i<I; i++){
        myfile<<"Separator2 Topside Well "<<i+1<< " Iteration: "<<It_nlp<<" Flow: "<<x[250+9*i]<<endl;
        }
        for (int i=0; i<I; i++){
        myfile<<"Separator3 Topside  Well "<<i+1<< " Iteration: "<<It_nlp<<" Flow: "<<x[251+9*i]<<endl;
        }
        
        myfile<<endl;
        for (int i=0; i<I; i++){
        myfile<<"Separator1 Topside Water Well "<<i+1<< " Iteration: "<<It_nlp<<" Flow: "<<x[252+9*i]<<endl;
        }
        for (int i=0; i<I; i++){
        myfile<<"Separator2 Topside Water Well "<<i+1<< " Iteration: "<<It_nlp<<" Flow: "<<x[253+9*i]<<endl;
        }
        for (int i=0; i<I; i++){
        myfile<<"Separator3 Topside Water  Well "<<i+1<< " Iteration: "<<It_nlp<<" Flow: "<<x[254+9*i]<<endl;
        }
        
        int t=1;
        myfile<<endl;
        for (int i=0; i<I*3; i++ ){
        myfile<<" Binary well topside "<<t<<": "<<x[i]<<" "<<x[i+1]<<" "<<x[i+2]<<endl;
        i=i+2;
        t++;
        }
        t=1;
        int s=18;
        int e=s+J*2;
        for (int i=s; i<e; i++ ){
        myfile<<" Binary well subsea "<<t<<": "<<x[i]<<" "<<x[i+1]<<endl;
        i=i+1;
        t++;
        }
        
        myfile<<endl;
        t=1;
        s=38;
        e=s+L*3;
        for (int i=s; i<e; i++ ){
        myfile<<" Binary well line "<<t<<": "<<x[i]<<" "<<x[i+1]<<" "<<x[i+2]<<endl;
        i=i+2;
        t++;
        }
        myfile<<endl;
        
        myfile.close();

}
}
